{Acquisition de la matrice d'orientation}
unit Limat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  Tflimat = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label3: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    edit0: TEdit;
    button1: TBitBtn;
    button2: TBitBtn;
    BitBtn1: TBitBtn;
    Label4: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure Aide_matrice(Sender: TObject);
    procedure verifie(Sender: TObject);
    procedure init_first(Sender: TObject);
    procedure ferme(Sender: TObject);
    procedure calcul_mat(Sender: TObject);
    procedure cancel(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  flimat: Tflimat;


implementation

uses
  oemath,dessin;
var
  reseaux,reseauy,reseauz,ier  :integer;
  px,qx,rx,py,qy,ry,pz,qz,rz   :double;
  nomf                           :Textfile;

{$R *.DFM}

procedure initialise_zero;
//-------------------------
begin
  flimat.radiogroup1.itemIndex:=0;
  flimat.radiogroup2.itemIndex:=1;
  flimat.radiogroup3.itemIndex:=1;
  flimat.edit0.text:='0';
  flimat.edit1.text:='0';
  flimat.edit2.text:='0';
  flimat.edit3.text:='0';
  flimat.edit4.text:='0';
  flimat.edit5.text:='0';
  flimat.edit6.text:='0';
  flimat.edit7.text:='0';
  flimat.edit8.text:='0';
end;

procedure Tflimat.Aide_matrice(Sender: TObject);
//----------------------------------------------
begin
   Application.HelpFile:=repertoire_origine+'/gretep.hlp';
   Application.HelpContext(5);
end;

procedure Tflimat.verifie(Sender: TObject);
//----------------------------------------
var
 chaine: string;

begin
  chaine:=edit0.text;
  if(length(chaine) <> 0)then begin
  add_zero(chaine);
    val(chaine,px,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit0.text:='';
    end;
  end
  else px:=0;

  chaine:=edit1.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit1.text:='';
    end;
  end
  else qx:=0;

  chaine:=edit2.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit2.text:='';
    end;
  end
  else rx:=0;

  chaine:=edit3.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,py,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit3.text:='';
    end;
  end
  else py:=0;

  chaine:=edit4.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qy,ier);
    if(ier <> 0)then begin
      erreur ('Type error'); edit4.text:='';
    end;
  end
  else qy:=0;

  chaine:=edit5.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,ry,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit5.text:='';
    end;
  end
  else ry:=0;

  chaine:=edit6.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,pz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit6.text:='';
    end;
  end
  else pz:=0;

  chaine:=edit7.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit7.text:='';
    end;
  end
  else qz:=0;

  chaine:=edit8.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit8.text:='';
    end;
  end
  else rz:=0;

  reseaux:=radiogroup1.ItemIndex;
  reseauy:=radiogroup2.ItemIndex;
  reseauz:=radiogroup3.ItemIndex;

end;

Procedure matrois  (var i1,i2,ier : integer);
//-------------------------------------------
var
  s1,s2                     : string;
  x,y,z                     : vecteur3;
  i,j                       : integer;
  som,xx                    : double;
begin
{  wr(nomfich,'r20',r20);
  wr(nomfich,'r31',r31);
  wr(nomfich,'r20',r20);
  writeln(nomfich,'i1:',i1:2,' i2:',i2:2);}
  ier:=0;
  x[1]:=r31[i1,1];
  x[2]:=r31[i1,2];
  x[3]:=r31[i1,3];
  {writeln(nomfich,'X avant trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  trfo3(x,r20);
{  writeln(nomfich,'X aprs trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);  }
  norm(x[1],x[2],x[3]);
{  writeln(nomfich,'X aprs norm :',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  y[1]:=r31[i2,1];
  y[2]:=r31[i2,2];
  y[3]:=r31[i2,3];
 { writeln(nomfich,'Y avant trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);}
  trfo3(y,r20);
{  writeln(nomfich,'Y aprs trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);  }
  norm(y[1],y[2],y[3]);
{  writeln(nomfich,'Y aprs norm :',y[1]:10:5,y[2]:10:5,y[3]:10:5);}

{les deux vecteurs doivent tre perpendiculaires}
  som:=0;
  for  i:=1 to 3 do  som:=som+x[i]*y[i];
{  writeln(nomfich,'Produit scalaire : ',som:5:2);}
  if(som > 0.01)then begin
    str(i1:2,s1);
    str(i2:2,s2);
    {chaine:='les 2 vecteurs ne sont pas perpendiculaires';
    erreur(chaine);}
    //erreur('Error! the vectors are not perpendicular');
    ier:=1;
    exit;
  end;
  prodvec(x,y,z);
{  writeln(nomfich,'Vecteur Z avant trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}

{Changement de signe du produit vectoriel si i1+i2 est pair}
  {k:=i1+i2+1;
  xx:=(-1.)^k;}
  xx:=1;
  if((i1+i2) mod 2 =0) then xx:=-1;
  if((i1+i2) mod 2 <> 0)then xx:=1;
  for i:=1 to 3 do z[i]:=xx*z[i];
  trfo3(z,r02);
{  writeln(nomfich,'Vecteur Z aprs trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}
  for i:=1 to 3 do begin
    if(i = i1) or (i = i2) then continue;
    for j:=1 to 3 do r31[i,j]:=z[j];
  end;

  {  writeln(nomfich,'Matrice avant inversion :');}
  {  wr(nomfich,'R31',r31);}
  {  closefile(nomfich);   }
  matinv(r31,r13,ier);
end;


procedure Tflimat.init_first(Sender: TObject);
//--------------------------------------------
begin
  initialise_zero;
  edit0.setfocus;
  left:=10;
  top:=40;
end;

procedure Tflimat.ferme(Sender: TObject);
//--------------------------------------
begin
 { closefile(nomfich);}
end;


procedure Tflimat.calcul_mat(Sender: TObject);
//--------------------------------------------
var
  rpqr                         : matrice3;
  som1,som2,som3,x,y,z         : double;
  i                            : integer;
begin
  verifie(sender);
  {Axe OX}
  som1:=abs(px)+abs(qx)+abs(rx);
  som2:=abs(py)+abs(qy)+abs(ry);
  som3:=abs(pz)+abs(qz)+abs(rz);
  if (som1+som2+som3 = 0)then begin
    flimat.visible:=false;
    exit;
  end;
  if(som1 <> 0)then begin
    if(reseaux = 0)then begin
      normd(px,qx,rx);
      r31[1,1]:=px;
      r31[1,2]:=qx;
      r31[1,3]:=rx;
      trfo(px,qx,rx,x,y,z,r10);
      r13[1,1]:=x;
      r13[2,1]:=y;
      r13[3,1]:=z;
    end;
    if(reseaux = 1)then begin
      normr(px,qx,rx);
      r13[1,1]:=px;
      r13[2,1]:=qx;
      r13[3,1]:=rx;
      trfo(px,qx,rx,x,y,z,r01);
      r31[1,1]:=x;
      r31[1,2]:=y;
      r31[1,3]:=z;
    end;
  end;
  if(som1 = 0)then begin
    for i:=1 to 3 do begin
      r13[1,i]:=0;
      r31[1,i]:=0;
    end;
  end;

  {Axe OY}
  if(som2 <> 0)then begin
    if(reseauy = 0)then begin
      normd(py,qy,ry);
      r31[2,1]:=py;
      r31[2,2]:=qy;
      r31[2,3]:=ry;
      trfo(py,qy,ry,r13[1,2],r13[2,2],r13[3,2],r10);
    end;
    if(reseauy = 1)then begin
      normr(py,qy,ry);
      r13[1,2]:=py;
      r13[2,2]:=qy;
      r13[3,2]:=ry;
      trfo(py,qy,ry,r31[2,1],r31[2,2],r31[2,3],r01);
    end;
  end ;
  if(som2 = 0)then begin
    for i:=1 to 3 do begin
      r13[2,i]:=0;
      r31[2,i]:=0;
    end;
  end;
  {Axe OZ}
  if(som3 <> 0)then begin
    if(reseauz = 0)then begin
      normd(pz,qz,rz);
      r31[3,1]:=pz;
      r31[3,2]:=qz;
      r31[3,3]:=rz;
      trfo(pz,qz,rz,r13[1,3],r13[2,3],r13[3,3],r10);
    end;
    if(reseauz = 1)then begin
      normr(pz,qz,rz);
      r13[1,3]:=pz;
      r13[2,3]:=qz;
      r13[3,3]:=rz;
      trfo(pz,qz,rz,r31[3,1],r31[3,2],r31[3,3],r01);
    end;
  end;
  if(som3 = 0)then begin
    for i:=1 to 3 do begin
      r13[3,i]:=0;
      r31[3,i]:=0;
    end;
  end;

  rpqr[1,1]:=px;
  rpqr[1,2]:=qx;
  rpqr[1,3]:=rx;

  rpqr[2,1]:=py;
  rpqr[2,2]:=qy;
  rpqr[2,3]:=ry;

  rpqr[3,1]:=pz;
  rpqr[3,2]:=qz;
  rpqr[3,3]:=rz;

  calcmat (rpqr,ier);
  if (ier = 1) then exit;

 {code_data_dll};
  conditionne_matrice;
  dessine;
  close;
end;

procedure Tflimat.cancel(Sender: TObject);
//----------------------------------------
begin
  flimat.visible:=false;
end;



end.

