unit at_child;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, ExtCtrls;

type
  Tfchild = class(TForm)
    Panel1: TPanel;
    StringGrid2: TStringGrid;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Retour: TBitBtn;
    procedure affichage(Sender: TObject);
    procedure effacement_type_atome(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fchild: Tfchild;

implementation

{$R *.DFM}

uses
  oemath;

procedure Tfchild.affichage(Sender: TObject);
//-------------------------------------------
var
    i,j         : integer;
    s           : string;
    x           : real;
begin
   panel1.visible:=true;
   with stringGrid2 do begin
     refresh;
     colwidths[0]:=27;
     colwidths[1]:=37;
     rowCount:=nb_child+1;
     cells[0,0]:=' No';
     cells[1,0]:='Atome';
     cells[2,0]:='     X';
     cells[3,0]:='     Y';
     cells[4,0]:='     Z';
     cells[5,0]:='     B11';
     cells[6,0]:='     B22';
     cells[7,0]:='     B33';
     cells[8,0]:='     B12';
     cells[9,0]:='     B13';
     cells[10,0]:='     B23';
     for i:=1 to nb_child do begin
       with child[i] do begin
         cells[0,i]:=inttostr(i);
         cells[1,i]:=nom;
         str(x:9:5,s);
         cells[2,i]:=s;
         str(y:9:5,s);
         cells[3,i]:=s;
         str(z:9:5,s);
         cells[4,i]:=s;
         for j:=1 to 6 do begin
           if (abs(beta[j]) <  0.000001)then begin
             s:='';
           end else begin
             str(beta[j]:9:6,s);
             cells[4+j,i]:=s;
           end;
         end;
       end;
     end;
   end;
end;


procedure Tfchild.effacement_type_atome(Sender: TObject);
//------------------------------------------------------
begin
  //fefface.visible:=true;
end;

end.
