unit change_style_liai;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  Tfchange_style_liai = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    procedure sortie(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure select(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fchange_style_liai: Tfchange_style_liai;
  width_cust        : integer;
  coul_cust         : integer;

implementation

{$R *.DFM}
uses
  dessin,oemath;

procedure Tfchange_style_liai.sortie(Sender: TObject);
//----------------------------------------------------
var
  x              : real;
  s              : string;
  ier,i          : integer;
begin
  coul_cust:=edit1.color;
  s:=edit2.text;
  s:=trim(s);
  val(s,x,ier);
  width_cust:=round(x/0.01);
  beep;
  fchange_style_liai.visible:=false;
  flag_cust_bond:=1;
  fdessin.panel12.visible:=true;
  fdessin.panel12.caption:='Customize a bond. Click on the first atom. Right button to cancel';
end;

procedure Tfchange_style_liai.initialise(Sender: TObject);
//--------------------------------------------------------
var
  i,n1,n2                             : integer;
  s                                   : string;
  x                                   : real;
begin
  edit1.color:=coul_liai;
  x:=epaisseur*0.01;
  str(x:8:2,s);
  edit2.text:=s;
end;

procedure Tfchange_style_liai.select(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//-------------------------------------------------------------------------
begin
  edit1.color:=image1.canvas.pixels[x,y];
end;

end.
