unit at_motif;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, ExtCtrls, ColorBtns;

type
  TFmotif = class(TForm)
    Panel1: TPanel;
    StringGrid2: TStringGrid;
    Color95Button2: TColor95Button;
    Color95Button3: TColor95Button;
    Color95Button4: TColor95Button;
    Color95Button5: TColor95Button;
    Color95Button6: TColor95Button;
    Color95Button1: TColor95Button;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    ListBox2: TListBox;
    ListBox1: TListBox;
    Edit1: TEdit;
    edit2: TEdit;
    edit3: TEdit;
    edit4: TEdit;
    edit5: TEdit;
    edit6: TEdit;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label7: TLabel;
    Color95Button7: TColor95Button;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Color95Button8: TColor95Button;
    Label3: TLabel;
    Color95Button9: TColor95Button;
    procedure Affichage(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure erase_data(Sender: TObject);
    procedure dessine_case(Sender: TObject; Col, Row: Longint; Rect: TRect;
      State: TGridDrawState);
    procedure modif_ligne(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure init(Sender: TObject);
    procedure effacementE(Sender: TObject);
    procedure effacementA(Sender: TObject);
    procedure efface_bloc(Sender: TObject);
    procedure restaure(Sender: TObject);
    procedure set_numero(Sender: TObject);
    procedure verif_case(Sender: TObject);
    procedure click_groupe(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure peint_grille1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure on_click(Sender: TObject);
    procedure on_selecte_cell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure selecte_tou(Sender: TObject);
    procedure deselecte_tout(Sender: TObject);
    procedure corrige_liaisons(Sender: TObject);
    procedure plot(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Fmotif: TFmotif;

implementation

{$R *.DFM}
uses
oemath, mainmenu, effaceE, effaceA, effaceB, fichiers, typliai, dessin;

var
  col_err,row_err               : integer;
  flag_modif_liste              : boolean;
  no_case                       : integer;
  acol,arow                     : integer;

//Evenement onExit dans les cases edit
procedure verif_frappe;
//---------------------
var
  s                : string;
  x                : double;
  ier              : integer;
begin
  with fmotif do begin

    case no_case of
      1: s:=edit1.text;
      2: s:=edit2.text;
      3: s:=edit3.text;
      4: s:=edit4.text;
      5: s:=edit5.text;
      6: s:=edit6.text;
    end;
    verif(s);
    val(s,x,ier);
    if (ier > 0)then begin
      case no_case of
        1: edit1.setfocus;
        2: edit2.setfocus;
        3: edit3.setfocus;
        4: edit4.setfocus;
        5: edit5.setfocus;
        6: edit6.setfocus;
      end;
      erreur ('Type error!');
      exit;
    end;

    case no_case of
      1:begin
        if (systeme = 'CUBI') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        if (systeme = 'TETR') or (systeme = 'HEXA') then edit2.text:=s;
        if (systeme = 'RHOM') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        cel[1]:=x;
      end;
      2: cel[2]:=x;
      3: cel[3]:=x;
      4:begin
          cel[4]:=x;
          if (systeme = 'RHOM') then begin
            edit5.text:=s;
            edit6.text:=s;
            cel[5]:=x;
            cel[6]:=x;
          end;
        end;
    end;

  end;
end;

procedure couleur_edit_param;{
-----------------------------}
begin
    with fmotif do begin
      edit1.color:=clwhite;
      edit2.color:=clwhite;
      edit3.color:=clwhite;
      edit4.color:=clwhite;
      edit5.color:=clwhite;
      edit6.color:=clwhite;
      if(systeme = 'CUBI')then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;edit3.text:=edit1.text;
      end else if (systeme = 'TETR')then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;
      end else if (systeme  = 'ORTH')then begin
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
      end else if (systeme = 'HEXA') then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='120';
          edit2.text:=edit1.text;
      end else If (systeme = 'RHOM') then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit2.text:=edit1.text;edit3.text:=edit1.text;
          edit5.text:=edit4.text;edit6.text:=edit4.text;
      end else if(systeme = 'MONO')then begin
          edit4.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit6.text:='90';
      end;
    end;
end;

procedure lit_affiche_groupes;
//----------------------------
var
  s,s1                    : string;
  nomf                    : TextFile;
  n,i                     : integer;
begin
  with fmotif do begin
    s1:=systeme+'.pos';
    AssignFile(nomf,s1);
    reset(nomf);
    listbox2.items.clear;
    nb_groupes:=0;
    while not (eof(nomf)) do begin
      readln(nomf,s);
      s:=TrimRight(s);
      if(length(s) = 0)then begin
        readln(nomf,s);
        s:=trim(s);
        listbox2.items.add(s);
        nb_groupes:=nb_groupes+1;
        readln(nomf);
        readln(nomf,n);for i:=1 to n do readln(nomf);
        readln(nomf,n);if (n > 0)then for i:=1 to n do readln(nomf);
      end;
    end;
    closeFile(nomf);
    //listbox3.clear;
  end;
end;

//Allume le groupe et le systme slectionns
procedure allume_groupes;{
-------------------------}
var
  s                       : string;
  i                       : integer;
begin
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'RHOM')then bravais:='P';
  s:=groupe_espace;s:=trim(s);s:=uppercase(s);

//Allumage du systeme
  for i:=1 to 7 do begin
    s:=copy(fmotif.listbox1.items.strings[i-1],1,4);
    s:=uppercase(s);
    if(s = systeme)then begin
      fmotif.listbox1.ItemIndex:=i-1;
      break;
    end;
  end;

//Allumage du groupe d'espace dans listbox2
  if(length(groupe_espace) > 0)then begin
    for i:=1 to nb_groupes do begin
      s:=fmotif.listbox2.items.strings[i-1];
      s:=Trim(s);
      if(groupe_espace = s) then begin
        fmotif.listbox2.ItemIndex:=i-1;
        break;
      end;
    end;
  end;
end;

procedure relit_stringGrid2(var ier:integer);
//------------------------------------------
var
    i,j         : integer;
    s           : string;
    x           : double;
begin
  ier:=0;
  with fmotif.StringGrid2 do begin
    nb_motif:=0;
    for i:=1 to rowcount-1 do begin
      s:=cells[1,i];
      if (length(s) = 0)then continue;
      nb_motif:=nb_motif+1;
      motif[nb_motif].nom:=s;
      for j:=1 to 3 do begin
        s:=cells[j+1,i];
        s:=trim(s);
        if (length(s) = 0)then begin
          x:=0;
          cells[j+1,i]:='  0';
        end else val(s,x,ier);
        if (ier > 0)then begin
          row_err:=i;
          col_err:=j+1;
          fmotif.stringgrid2.refresh;
          exit;
        end;
        case j of
          1: motif_old[nb_motif].x:=x;
          2: motif_old[nb_motif].y:=x;
          3: motif_old[nb_motif].z:=x;
        end;
      end;
      for j:=1 to 6 do begin
        s:=cells[j+4,i];
        s:=trim(s);
        if (length(s) = 0)then begin
          x:=0;
          cells[j+4,i]:='';
        end else val(s,x,ier);
        if (ier > 0)then begin
          row_err:=i;
          col_err:=j+4;
          fmotif.stringgrid2.refresh;
          exit;
        end;
        motif_old[i].beta[j]:=x;
      end;
    end;
  end;
end;

procedure ecrit_maille;
//---------------------
var
  s   : string;
begin
  with fmotif do begin
    str(cel[1]:8:4,s);
    edit1.text:=s;
    str(cel[2]:8:4,s);
    edit2.text:=s;
    str(cel[3]:8:4,s);
    edit3.text:=s;
    str(cel[4]:8:3,s);
    edit4.text:=s;
    str(cel[5]:8:3,s);
    edit5.text:=s;
    str(cel[6]:8:3,s);
    edit6.text:=s;
  end;
end;

procedure raze_data;
//------------------
var
  i         : integer;
begin
  nom_fichier_shelx:='';
  nom_fichier_grt:='';
  npos:=0;
  npos_sel:=0;
  nb_motif:=0;
  nb_child:=0;
  for i:=1 to 6 do cel[i]:=0;
end;

procedure ecrit_stringgrid1;
//--------------------------
var
  i,j,k         : integer;
  s             : string;
  v4            : vecteur4;
begin
  with fmotif.StringGrid1 do begin
    colwidths[0]:=20;
    colwidths[4]:=50;
    cells[0,0]:='Nb';
    cells[1,0]:='a';
    cells[2,0]:='b';
    cells[3,0]:='c';
    cells[4,0]:='Selected';

    if (npos = 0)then exit;
    for i:=1 to rowcount-1 do
      for j:=0 to 4 do cells[j,i]:='';

    for i:=1 to npos do begin
      str(i:3,s);
      cells[0,i]:=inttostr(i);
      for j:=1 to 3 do begin
        for k:=1 to 4 do v4[k]:=tp[i,j,k];
        code(v4,s);
        s:=uppercase(s);
        cells[j,i]:=s;
      end;
      if (selected[i] = 1)then cells[4,i]:= '*';
    end;
  end;
end;

{Affichage des acquisitions (labels sur cran principal)}
procedure TFmotif.Affichage(Sender: TObject);
//-------------------------------------------
var
    i,j          : integer;
    s            : string;
begin
   stringgrid2.color:=clwhite;
   flag_modif_liste:=true;
   if (nb_motif > 0)then begin
     quel_systeme;
     couleur_edit_param;
     couleur_edit_param;
     for i:=0 to 5 do begin
       s:=copy(listbox1.Items[i],1,4);
       s:=uppercase(s);
       if (s = systeme) then begin
         listbox1.ItemIndex:=i;
         break;
       end;
     end;
     lit_affiche_groupes;
     if (groupe_espace <> '')then begin
       allume_groupes;
       label7.visible:=false;
     end else label7.visible:=true;
     ecrit_maille;
   end;

   fmotif.left:=6;
   panel1.visible:=true;
   fmotif.caption:='Data for '+extractFileName(nom_fichier_shelx);
   ecrit_stringgrid1;
   with stringGrid2 do begin
     refresh;
     colwidths[0]:=27;
     colwidths[1]:=37;
     if (nb_motif > 0)then rowCount:=nb_motif+1;
     cells[0,0]:='No';
     cells[1,0]:='Atome';
     cells[2,0]:='X';
     cells[3,0]:='Y';
     cells[4,0]:='Z';
     cells[5,0]:='u11';
     cells[6,0]:='u22';
     cells[7,0]:='u33';
     cells[8,0]:='u12';
     cells[9,0]:='u13';
     cells[10,0]:='u23';
     for i:=0 to colcount-1 do
     for j:=1 to rowcount-1 do cells[i,j]:='';
     if (nb_motif > 0)then begin
       for i:=1 to nb_motif do begin
         with motif_old[i] do begin
           cells[0,i]:=inttostr(i);
           cells[1,i]:=nom;
           str(x:9:5,s);
           cells[2,i]:=s;
           str(y:9:5,s);
           cells[3,i]:=s;
           str(z:9:5,s);
           cells[4,i]:=s;
           for j:=1 to 6 do begin
             if (abs(beta[j]) <  0.000001)then begin
               s:='';
             end else begin
               str(beta[j]:9:6,s);
               cells[4+j,i]:=s;
             end;
           end;
         end;
       end;
     end;
   end;
end;

procedure relit_positions_selectionnees;
//--------------------------------------
var
   s,s1                : string;
   i,j,k,ier           : integer;
   x1,x2               : double;
const
   cod  : array[1..8] of string[20] =('Y-X','X-Y','-Z','-Y','-X','Z','Y','X');
   xn   : array[1..8] of integer = (-1, 1, 0, 0,-1, 0, 0, 1);
   yn   : array[1..8] of integer = ( 1,-1, 0,-1, 0, 0, 1, 0);
   zn   : array[1..8] of integer = ( 0, 0,-1, 0, 0, 1, 0, 0);
begin
  npos_sel:=0;
  with fmotif.stringgrid1 do begin
    //ligne i
    for i:=1 to rowcount-1 do begin
      s:=cells[1,i];s:=trim(s);
      if (s = '')then break;
      if (cells[4,i] <> '*')then begin
        selected[i]:=0;
        continue;
      end;
      npos_sel:=npos_sel+1;
      selected[i]:=1;
      //colonne j
      for j:=1 to 3 do begin
        s:=cells[j,i];
        s:=trim(s);
        s:=UpperCase(s);
        for k:=1 to 8 do begin
          if (pos(cod[k],s) > 0)then begin
            tp_sel[npos_sel,j,1]:=xn[k];
            tp_sel[npos_sel,j,2]:=yn[k];
            tp_sel[npos_sel,j,3]:=zn[k];
            delete(s,pos(cod[k],s),length(cod[k]));
            s:=trim(s);
            break;
          end;
        end;
        ier:=0;
        while (pos('+',s) > 0)do s[pos('+',s)]:=' ';s:=trim(s);
        if (s = '')then begin
          tp_sel[npos_sel,j,4]:=0;
          continue;
        end;
        if (pos('/',s) = 0)then begin
          val(s,tp_sel[npos_sel,j,4],ier);
        end else begin
          s1:=copy(s,1,pos('/',s)-1);
          val(s1,x1,ier);
          delete(s,1,pos('/',s));
          val(s,x2,ier);
          tp_sel[npos_sel,j,4]:=x1/x2;
        end;
        if (ier > 0)then begin
            erreur('Decoding Error!');
            exit;
        end;
      end;
    end;
  end;
end;

procedure TFmotif.sortie(Sender: TObject);
//---------------------------------------
var
  ier : integer ;
begin
  relit_stringgrid2(ier);
  relit_positions_selectionnees;
  if (ier = 1)then erreur('Read error');
  close;
end;

procedure TFmotif.erase_data(Sender: TObject);
//--------------------------------------------
var
  i,j         : integer;
begin
  nom_fichier_shelx:='';
  nom_fichier_grt:='';
  npos:=0;
  npos_sel:=0;
  nb_motif:=0;
  nb_child:=0;
  for i:=1 to 6 do cel[i]:=0;
  listbox1.Clear;listbox2.clear;
  edit1.text:='';edit2.text:='';edit3.text:='';
  edit4.text:='';edit5.text:='';edit6.text:='';
  with stringGrid2 do begin
    for i:=0 to colcount-1 do
    for j:=1 to rowcount-1 do cells[i,j]:='';
  end;
end;

procedure TFmotif.dessine_case(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------
var
  s           : string;
  posx        : integer;
begin
  with stringGrid2.canvas do begin
    if (col = col_err) and (row = row_err)then begin
      font.color:=clred;
      textout(rect.left+1,rect.top+1,stringgrid2.cells[col,row]);
      erreur('Erreur  la ligne '+inttostr(row)+' ,colonne '+inttostr(col+1));
      col_err:=-1;
      row_err:=-1;
    end;
    s:=stringGrid2.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-textWidth(s)) div 2;
    textrect(rect,rect.left+posx,rect.top,s);
  end;
end;

procedure TFmotif.modif_ligne(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
//----------------------------------------------------------------
var
  ier,i               :integer;
  s                   : string;
begin
  col_err:=-1;
  row_err:=-1;
  if (flag_modif_liste = false) then exit;
  relit_stringGrid2(ier);
  s:=StringGrid2.cells[1,row];
  s:=trim(s);
  if (length(s) = 0)then begin
     for i:=0 to stringGrid2.colcount do begin
       s:='';
       StringGrid2.cells[i,row]:=s;
     end;
  end;
end;

procedure TFmotif.init(Sender: TObject);
//-------------------------------------
begin
  fmotif.left:=6;fmotif.top:=52;
  col_err:=-1;
  row_err:=-1;
end;

procedure TFmotif.effacementE(Sender: TObject);
//--------------------------------------------
begin
   feffaceE.visible:=true;
end;

procedure TFmotif.effacementA(Sender: TObject);
//--------------------------------------------
begin
  feffaceA.visible:=true;
end;

procedure TFmotif.efface_bloc(Sender: TObject);
//--------------------------------------------
begin
  feffaceb.visible:=true;
end;

procedure TFmotif.restaure(Sender: TObject);
//-----------------------------------------
var
  s  : string;
begin
  nb_child:=0;nb_child_old:=0;nb_motif:=0;nbtrans:=0;npos:=0;npos_sel:=0;
  nb_typ_element:=0;nb_typ_liai:=0;nb_bonds:=0;
  s:=nom_fichier_shelx;
  if (pos('.inp',s) > 0) or (pos('.ins',s) > 0)then licarte_input;
  if (pos('.out',s) > 0) then licarte_output;
  if ( s= '') and (pos('.grt',nom_fichier_grt) > 0) then lit_fichier_bin;
  Affichage(Sender);
end;

procedure TFmotif.set_numero(Sender: TObject);
//--------------------------------------------
begin
  with fmotif do begin
    if edit1.focused then no_case:=1;
    if edit2.focused then no_case:=2;
    if edit3.focused then no_case:=3;
    if edit4.focused then no_case:=4;
    if edit5.focused then no_case:=5;
    if edit6.focused then no_case:=6;
  end;
end;

procedure TFmotif.verif_case(Sender: TObject);
//--------------------------------------------
begin
  verif_frappe;
end;

procedure TFmotif.click_groupe(Sender: TObject);
//----------------------------------------------
var
   i,j,k                    : integer;
   v4                       : vecteur4;
   s,s1                     : string;
begin
  groupe_espace:=listbox2.items[listbox2.itemIndex];
  bravais:=copy(groupe_espace,1,1);
  set_positions;
  set_translations;
  npos_sel:=1;
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      s:=s+','+uppercase(s1);
    end;
    s_pos[i]:=s;
    selected[i]:=0;
  end;
  selected[1]:=1;
  if (groupe_espace <> '')then fmotif.label7.visible:=false
  else fmotif.label7.visible:=true;
  ecrit_stringgrid1;
end;

procedure TFmotif.ListBox1Click(Sender: TObject);
//-----------------------------------------------
begin
  if (listbox1.ItemIndex > -1)then begin
    systeme:=copy(listbox1.Items[listbox1.ItemIndex],1,4);
    systeme:=uppercase(systeme);
    bravais:=copy(systeme,1,1);
    couleur_edit_param;
    lit_affiche_groupes;
  end;
end;

procedure TFmotif.peint_grille1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  //Changement de couleur si la position est slectionne
  s:=trim(Stringgrid1.cells[4,row]);
  if (s = '*') and (col = 4) then begin
    stringgrid1.canvas.brush.color:=$EECBFF;
    stringgrid1.canvas.fillrect(rect);
    stringgrid1.canvas.font.color:=clblack;
    stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end else stringgrid1.canvas.brush.color:=clwhite;
  s:=stringgrid1.cells[col,row];
  //On numrote si le numro est absent
  if (col > 0) and (stringgrid1.cells[0,row] = '') and
  (stringgrid1.cells[1,row] <> '')then
  stringgrid1.cells[0,row]:=inttostr(row);
  //centrage
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);

end;

procedure TFmotif.on_click(Sender: TObject);
//-----------------------------------------
var s:string;
begin
   if (acol <> 4)then exit;
   s:=stringgrid1.cells[acol,arow];
   if (s = '') then s:='*' else s:='';
   stringgrid1.cells[acol,arow]:=s;
end;

procedure TFmotif.on_selecte_cell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-------------------------------------------------------------------
begin
   arow:=row;
   acol:=col;
end;

procedure TFmotif.selecte_tou(Sender: TObject);
//---------------------------------------------
var
 i             : integer;
begin
   with stringgrid1 do begin
     for i:=1 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='*';
     end;
   end;
end;

procedure TFmotif.deselecte_tout(Sender: TObject);
//-----------------------------------------------
var  i:integer;
begin
     with stringgrid1 do begin
     for i:=2 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='';
     end;
   end;
end;

procedure TFmotif.corrige_liaisons(Sender: TObject);
//--------------------------------------------------
begin
 ftypliai.visible:=true;
end;

procedure TFmotif.plot(Sender: TObject);
//--------------------------------------
var  i : integer;
begin
  fmotif.hide;
  fmainmenu.generer(sender);
  if (nb_child = 0)then begin
    beep;
    erreur('No data');
    exit;
  end;
  for i:=1 to nb_child do child_old[i]:=child[i];
  nb_child_old:=nb_child;
  fdessin.visible:=true;

end;

end.
