unit dessin; {Dessin GRETEP}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,clipbrd,
  Dialogs, ExtCtrls, Menus, math, StdCtrls, Buttons, ColorBtns,JPEG,
  Grids, ComCtrls, ExtDlgs, printers, DBTables, checklst,oemath;

type
  Tfdessin = class(TForm)
    Image1: TImage;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Image2: TImage;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    ColorDialog1: TColorDialog;
    Panel3: TPanel;
    RadioGroup1: TRadioGroup;
    Panel6: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Memo1: TMemo;
    Edit1: TEdit;
    Edit7: TEdit;
    Label3: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Panel11: TPanel;
    Label14: TLabel;
    BitBtn19: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    Label16: TLabel;
    edit8: TEdit;
    Panel12: TPanel;
    Edit9: TEdit;
    Edit10: TEdit;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn8: TBitBtn;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    StringGrid1: TStringGrid;
    ListBox: TListBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    FontDialog1: TFontDialog;
    PopupMenu1: TPopupMenu;
    JPEGformatjpg1: TMenuItem;
    Bitmapformatbmp1: TMenuItem;
    WindowsMetaFilewmf1: TMenuItem;
    Edit11: TEdit;
    Edit12: TEdit;
    Label6: TLabel;
    Edit13: TEdit;
    TrackBar3: TTrackBar;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    Panel2: TPanel;
    Label4: TLabel;
    Color95Button1: TColor95Button;
    Color95Button2: TColor95Button;
    CheckListBox1: TCheckListBox;
    CreateaPovrayfile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    LaunchPOVRAY1: TMenuItem;
    RadioGroup4: TRadioGroup;
    edit14: TEdit;
    CheckBox8: TCheckBox;
    MainMenu1: TMainMenu;
    Exporttheimage1: TMenuItem;
    SaveData1: TMenuItem;
    Print1: TMenuItem;
    PrintImage1: TMenuItem;
    PrintScreen1: TMenuItem;
    Directionofprojection1: TMenuItem;
    Direction1: TMenuItem;
    Plane1: TMenuItem;
    Bestview1: TMenuItem;
    Display1: TMenuItem;
    Cordinates1: TMenuItem;
    Distances1: TMenuItem;
    Coordination1: TMenuItem;
    Angleof3atoms1: TMenuItem;
    Anglesanddistancesaroundanatom1: TMenuItem;
    Meanplane1: TMenuItem;
    Ring1: TMenuItem;
    Mask1: TMenuItem;
    Atom1: TMenuItem;
    Atomsinarectangle1: TMenuItem;
    Elements1: TMenuItem;
    Fragments1: TMenuItem;
    MaskAddabond1: TMenuItem;
    maskbondsinarectangle1: TMenuItem;
    Choosethecentralatom1: TMenuItem;
    Reset1: TMenuItem;
    help1: TMenuItem;
    Return1: TMenuItem;
    Matrix1: TMenuItem;
    Adistance1: TMenuItem;
    Panel4: TPanel;
    BitBtn33: TBitBtn;
    BitBtn34: TBitBtn;
    BitBtn35: TBitBtn;
    BitBtn36: TBitBtn;
    BitBtn37: TBitBtn;
    BitBtn38: TBitBtn;
    BitBtn39: TBitBtn;
    BitBtn40: TBitBtn;
    BitBtn41: TBitBtn;
    BitBtn42: TBitBtn;
    BitBtn43: TBitBtn;
    BitBtn44: TBitBtn;
    BitBtn45: TBitBtn;
    BitBtn46: TBitBtn;
    BitBtn47: TBitBtn;
    BitBtn48: TBitBtn;
    BitBtn49: TBitBtn;
    BitBtn50: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    CheckBox9: TCheckBox;
    Panel5: TPanel;
    CheckListBox2: TCheckListBox;
    Label7: TLabel;
    Color95Button3: TColor95Button;
    RadioGroup5: TRadioGroup;
    SpeedButton2: TSpeedButton;
    BitBtn11: TBitBtn;
    procedure initialise_fiche(Sender: TObject);
    procedure flag_on(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mouse_up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mouse_move(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Retour(Sender: TObject);
    procedure enregistrer(Sender: TObject);
    procedure imprime_dessin(Sender: TObject);
    procedure initialise_creation(Sender: TObject);
    procedure aide(Sender: TObject);
    procedure redessine(Sender: TObject);
    procedure change_probabilite(Sender: TObject);
    procedure change_width_bond(Sender: TObject);
    procedure chane_angle_perspective(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure selection_couleur(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure set_mode_rotation(Sender: TObject);
    //procedure sauve_binary(Sender: TObject);
    procedure select_atom_rect(Sender: TObject);
    procedure print_screen(Sender: TObject);
    procedure modif_orientation(Sender: TObject);
    procedure set_direction_projection(Sender: TObject);
    procedure matrice_sur_3atomes(Sender: TObject);
    procedure best_view(Sender: TObject);
    procedure set_position_label(Sender: TObject);
    procedure decale_label(Sender: TObject);
    procedure label_centre(Sender: TObject);
    procedure affiche_distances(Sender: TObject);
    procedure pique_distance(Sender: TObject);
    procedure pique_angle(Sender: TObject);
    procedure set_coordinance(Sender: TObject);
    procedure affiche_liste_coord(Sender: TObject);
    procedure set_zoom(Sender: TObject);
    procedure reset_zoom(Sender: TObject);
    procedure ok_translation(Sender: TObject);
    procedure set_translations(Sender: TObject);
    procedure reset_child(Sender: TObject);
    procedure selecte_centre(Sender: TObject);
    procedure clickonplanesaxes(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure set_mean_plane(Sender: TObject);
    procedure tue_atome(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure tue_liaison(Sender: TObject);
    procedure Bitmapfilebmp1Click(Sender: TObject);
    procedure WindowsMetaFilewmf1Click(Sender: TObject);
    procedure JPEGfilejpg1Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure masque_panel2(Sender: TObject);
    procedure change_bond_width(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure draw_cell(Sender: TObject);
    procedure ASCIIfilegre1Click(Sender: TObject);
    procedure desactivation(Sender: TObject);
    procedure click_on_checklistbox(Sender: TObject);
    procedure degarde_option(Sender: TObject);
    procedure aide_label(Sender: TObject);
    procedure masque_elements(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure change_echelle(Sender: TObject);
    procedure make_povray(Sender: TObject);
    procedure povray(Sender: TObject);
    procedure masque_fragment(Sender: TObject);
    procedure dbrown(Sender: TObject);
    procedure ferme(Sender: TObject; var Action: TCloseAction);
    procedure centroid(Sender: TObject);
    procedure customize_bond(Sender: TObject);
    procedure tue_liaisons(Sender: TObject);
    procedure ecrit_labels(Sender: TObject);
    procedure CheckListBox2Click(Sender: TObject);
    procedure fin_label_bond(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fdessin: Tfdessin;
  k1,k2,k3,k4                                 : array[1..5000] of double;
  MyMetaFile                                  : TMetaFile;
  cb4_check_old,cb7_check_old                 : boolean;
  child_init                                  : array[1..5000] of atomes;
  no_atome_bond                               : array[1..2]of integer;

    procedure diagonalise;
    procedure trace_atomes_plans;
    procedure dessine;
    procedure reset_config_labels;

implementation
{$R *.DFM}

uses
 impression, diag, mainmenu, {oemath,} fichiers, liaisons, Limat, disp_distances,
  disp_coordinance, disp_coord2, plan_moyen, wmetafile2, mask_elements, digicode,
  scruteFichiers, brown, customize,change_style_liai;

type
   tab21                        = array[1..21] of integer;

var
  xog,yog,zog                                 : double;
  ixo,iyo,ixo_old,iyo_old                     : integer;
  xold,yold,ixw,iyw,xav,yav                   : integer;
  mode_rotation                               : integer;
  echelle                                     : double;
  mat_rot                                     : matrice3;
  num_trace,num_atome                         : array[1..5000] of integer;
  co,si                                       : array[1..51] of double;
  nb_stk,change_couleur,numero                : integer;

  //flag = test du bouton enfonc ou non
  flag,no_bouton                              : integer;
  point_atom                                  : boolean;
  bb                                          : array[1..5000,1..3,1..3] of double;

  phix0,phiy0,phiz0                           : double;
  x_repo,y_repo,z_repo                        : array[1..8] of double;

  souris_down                                 : boolean;
  x_up,y_up,x_down,y_down,xr1,yr1,xr2,yr2     : integer;

  //Dtermination de la matrice par la direction de projection (2 atomes)
  nb_click_bond                               : integer;
  //no_atome_bond                               : array[1..2]of integer;

  //Dtermination des angles
  nb_click_angle                         : integer;
  no_atome_angle                         : array[1..3]of integer;

 //Dtermination de la matrice par un plan (3 atomes)
  nb_click_plan                               : integer;
  no_atome_plan                               : array[1..3]of integer;

 //Dtermination des atomes pour milieu
  nb_click_milieu                             : integer;
  no_atome_milieu                             : array[1..10]of integer;

  //stockage de la palette
  teinte                                      : array[1..93] of integer;

  //Atome cliqu
  no_atome_clique,nb_click_label              : integer;

  //Zoom et cut
  flag_zoom,flag_cut,flag_move, flag_transl,
  flag_triangle                               : integer;

  //Sauvegarde des coordonnes locales
  xstk_old,ystk_old,zstk_old                  : array[1..5000] of double;
  nb_stk_old,probabilite_old                  : integer;
  echelle_old,facteur_echelle                 : double;
  change_sommet                               : integer;
  fllab_shift_old,fllab_centre_old  : integer;

  x_milieu,y_milieu,z_milieu                     : double;
  xstk_milieu,ystk_milieu,zstk_milieu            : double;
  x_m,y_m,z_m,xstk_m,ystk_m,zstk_m               : array[1..20] of double;

{$i ecran800.pas}
{$i ellipses2.pas}
{$i ellipsepr.pas}
{$i liaisons5.pas}
{$i liaisonspr.pas}
{$i dessin2.pas}


procedure Tfdessin.initialise_fiche(Sender: TObject);{
----------------------------------------------------}
var
   i                       : integer;
   pas,arg                 : double;
 begin
  flag_brown:=0;
  phix0:=0;
  phiy0:=0;
  phiz0:=0;
  caption:=fmainmenu.caption;
  if (shunte_init = 1)then begin
    shunte_init:=0;
    exit;
  end;
  flag_modif_data:=0;
  left:=0;top:=0;
  //panel6.left:=1;
  //panel6.width:=fdessin.width-2;
  panel2.top:=92;panel2.left:=50;
  panel5.top:=92;panel5.left:=50;

//Dcalage label
  with stringGrid1 do begin
    rowcount:=nb_typ_element+2;
    height:=20*stringgrid1.rowcount;
    colwidths[1]:=20;
    colwidths[0]:=50;
  end;
  panel12.visible:=false;

//Initialisations fentre image
  mode_rotation:=1;
  radiogroup1.ItemIndex:=0;
  ixo:=image1.width div 2;
  iyo:=image1.height div 2;
  pas:=2*pi/50;
  for i:=1 to 51 do begin
     arg:=pas*(i-1);
     co[i]:=cos(arg);
     si[i]:=sin(arg);
  end;
  ixw:=20;
  iyw:=10;

//Set des coefficients du contour dans l'espace 3
  if (checkBox6.state = cbchecked)then begin         //noir et blanc
    for i:=1 to nb_typ_element do begin
      element[i].couleur:=couleurs_old[i];
      font_color:=clblack;
    end;
    coul_liai:=coul_liai_old;
    coul_bkgrd:=coul_bkgrd_old;
    coul_scalebar:=coul_scalebar_old;
    checkBox6.state:=cbunchecked
  end;
  for i:=1 to nb_typ_element do couleurs_old[i]:=element[i].couleur;
  //for i:=1 to nb_child do child[i]:=child_old[i];
  coul_liai_old:=coul_liai;
  coul_bkgrd_old:=coul_bkgrd;
  coul_scalebar_old:=coul_scalebar;
  diagonalise;
  coefficients_contour;
  ecrit_panel2;
  premier_dessin;
  edit12.left:=0;
  edit11.left:=edit12.width+1;
  edit11.top:=image1.top+image1.height-edit11.height;
  edit14.top:=edit11.top;
  edit12.top:=edit11.top;
  dessine;
end;

procedure Tfdessin.redessine(Sender: TObject);
//--------------------------------------------
var
   s                          : string;
   ier,i                      : integer;
   x                          : real;
begin
  if (fdessin.visible = false)then exit;
  mode_rotation:=radiogroup1.itemIndex+1;
  if (CheckBox3.checked = true) then flag_sommets:=1 else flag_sommets:=0;
  if (CheckBox4.checked = true) then flag_label_centre:=1 else
   flag_label_centre:=0;
  if (CheckBox7.checked = true) then flag_label_shift:=1 else
   flag_label_shift:=0;
  if (CheckBox5.checked = true) then flag_degrade:=1 else flag_degrade:=0;
  s:=edit5.text;
  val(s,x,ier);
  epaisseur:=round(x/0.01);
  if (ier > 0)then begin
    erreur('Read error!');
    edit5.setfocus;
    exit;
  end;
  s:=edit6.text;
  val(s,alfa,ier);
  if (ier > 0)then begin
    erreur('Read Error!');
    edit6.setfocus;
    exit;
  end;
  probabilite:=Listbox.ItemIndex+1;
//couleurs
  if (checkBox6.state = cbchecked)then begin         //noir et blanc
    for i:=1 to nb_typ_element do begin
      couleurs_old[i]:=element[i].couleur;
      if (flag_noir_blanc = 0)then element[i].couleur:=clwhite;
      font_color:=clblack;
    end;
    coul_liai_old:=coul_liai;
    coul_bkgrd_old:=coul_bkgrd;
    coul_scalebar_old:=coul_scalebar;
    coul_liai:=clwhite;
    coul_bkgrd:=clwhite;
    coul_scalebar:=clblack;
    ecrit_stringgrid1;
    change_couleur:=1;
    flag_noir_blanc:=1;
  end else begin
    ier:=1;
    for i:=1 to nb_typ_element do element[i].couleur:=couleurs_old[i];
    coul_liai:=coul_liai_old;
    coul_bkgrd:=coul_bkgrd_old;
    coul_scalebar:=coul_scalebar_old;
    for i:=1 to nb_typ_element do begin
      if (element[i].couleur = clwhite)then continue;
      ier:=0;
      break;
    end;
    if (ier = 1)then begin //Ils sont tous blancs
      for i:=1 to nb_typ_element do element[i].couleur:=palett[i];
      ecrit_stringGrid1;
    end;
    if (flag_noir_blanc = 1)then begin
      flag_noir_blanc:=0;
      ecrit_stringgrid1;
      diagonalise;
    end;
  end;
  if (change_sommet <> flag_sommets)then premier_dessin;
  change_sommet:=flag_sommets;
  attribue_couleur;
  if (change_couleur = 1)then begin
    change_couleur:=0;
    attribue_couleur;
    //diagonalise;
  end;
  if (probabilite_old <> probabilite)then begin
    diagonalise;
    coefficients_contour;
    premier_dessin;
  end;
  dessine;
end;

procedure click_a_droite(var x,y : integer);
//-----------------------------------------
var
  n,i,j,k,ixat,iyat,nb,nb_du    : integer;
  s                             : string;
begin

//Bouton droit
 with fdessin do begin
    if (flag_tue_atome = 1) or (flag_coordinance = 1) or (flag_angle = 1)
    or (flag_killbond = 1) or (flag_distance = 1) {or (flag_milieu = 1)} then
    reset_config_labels ;
    radiogroup4.visible:=false;
    panel12.visible:=false;
    memo1.visible:=false;
    nb_click_bond:=0;
    nb_click_plan:=0;
    nb_click_angle:=0;

    flag_distance:=0;
    flag_coordinance:=0;
    flag_angle:=0;
    flag_triangle:=0;
    flag_killbond:=0;
    flag_tlabel:=0;
    flag_label_shift:=0;
    flag_tue_atome:=0;
    if (flag_cust_bond = 1)then begin
      flag_cust_bond:=0;
      checkbox8.checked:=false;
      panel12.visible:=false;
      panel12.color:=clyellow;
      mode_rotation:=1;
      exit;
    end;
    if (flag_ecrit_labels_bond = 1)then begin
      edit12.visible:=false;
      edit11.visible:=false;
      flag_ecrit_labels_bond:=0;
      panel12.visible:=false;
      panel12.color:=clyellow;
      panel12.alignment:=tacenter;
      panel12.left:=0;
      edit11.top:=image1.top+image1.height-edit11.height;
      edit14.top:=edit11.top;
      edit12.top:=edit11.top;
      mode_rotation:=1;
      exit;
    end;
    checklistbox1.itemindex:=-1;
    checklistbox1.state[1]:=cbunchecked;
    flag_label_centre:=0;
    checklistbox1.state[2]:=cbunchecked;
    flag_delete_label:=0;
    checklistbox1.state[3]:=cbunchecked;
    flag_fenetre_label:=0;
    checklistbox1.state[7]:=cbunchecked;
    flag_zoom:=0;
    flag_transl:=0;
    speedButton2.down:=true;
    radiogroup1.ItemIndex:=0;
    mode_rotation:=1;
    edit11.visible:=false;
    edit14.visible:=false;
    edit12.visible:=false;

//Effacement d'un atome pour plan moyen ---------------------------------------
    if (flag_plan_moyen = 1)then begin
      n:=0;

//Identification de l'atome
      n:=0;
      for i:=1 to nb_child do begin
        ixat:=round(xstk[i]*echelle+ixo);
        iyat:=iyo-round(ystk[i]*echelle);
        if (abs(x-ixat)< 10) and (abs(y-iyat) <  10) then begin
          n:=i;
          break;
        end;
      end;
      if (n = 0)then exit;

//plan moyen?
      with fplan_moyen.StringGrid1 do begin
        ligne:=nb_plan_moyen;
        colonne:=0;

//Dtection du numro de l'atome cliqu  droite (entre parenthses)
        for k:=1 to nb_plm do begin
          s:=cells[k,ligne];
          delete(s,1,pos('(',s));
          delete(s,pos(')',s),1);
          if (strToInt(s) = n)then begin             //correction de la liste
            colonne:= k;
            cells[colonne,ligne]:='';
            if (colonne < nb_plm)then begin
               for i:=colonne to  nb_plm-1 do begin //Correction de la grille
                 Cells[i,ligne]:=cells[i+1,ligne];
                 no_plm[i]:=no_plm[i+1];
               end;
            end;
            nb_plm:=nb_plm-1;
            break;
          end;
        end;

//Effacrement dans la grille
        if (colonne > 0)then begin
          Cells[colonne,ligne]:='';
          for k:=colonne to colcount-2 do
          Cells[k,ligne]:=cells[k+1,ligne];
        end;
      end;
      dessine;

//On trace les noms des atomes slectionns
      trace_atomes_plans;
      exit;
    end;
//Fin d'effacement d'un atome pour plan moyen ----------------------------------

//Calcul du milieu d'un cycle---------------------------------------------------
    if (flag_milieu = 1)then begin               //click  droite
      if (nb_click_milieu  < 3)then begin
         erreur('Not enough atoms');
         nb_click_milieu:=0;
         flag_milieu:=0;
         exit;
      end;

      x_milieu:=0;y_milieu:=0;z_milieu:=0;
      xstk_milieu:=0;ystk_milieu:=0;zstk_milieu:=0;
      nb:=0;
      for j:=1 to nb_click_milieu-1 do begin
        for k:=j+1 to nb_click_milieu do begin
          if (abs(x_m[j]-x_m[k]) < 0.0001) and (abs(y_m[j]-y_m[k]) < 0.0001) and
          (abs(z_m[j]-z_m[k]) < 0.0001) then begin
            x_m[k]:=-1000;
            y_m[k]:=-1000;
            z_m[k]:=-1000;
          end;
        end;
      end;
      for j:=1 to nb_click_milieu do begin
        if (x_m[j] = -1000) or (y_m[j] = -1000) or (z_m[j] = -1000) then continue;
        x_milieu:=x_milieu+x_m[j];
        y_milieu:=y_milieu+y_m[j];
        z_milieu:=z_milieu+z_m[j];
        xstk_milieu:=xstk_milieu+xstk_m[j];
        ystk_milieu:=ystk_milieu+ystk_m[j];
        zstk_milieu:=zstk_milieu+zstk_m[j];
        nb:=nb+1;
      end;

      nb_child:=nb_child+1;
      xstk[nb_child]:=xstk_milieu/nb;
      ystk[nb_child]:=ystk_milieu/nb;
      zstk[nb_child]:=zstk_milieu/nb;
      with child[nb_child] do begin
        element:='DU';
        nb_du:=0;
        for j:=1 to nb_child do if (child[j].element = 'DU')then nb_du:=nb_du+1;
        nom:='DU'+inttostr(nb_du);
        part:=0;
        x:=x_milieu/nb;
        y:=y_milieu/nb;
        z:=z_milieu/nb;
        dx:=0;dy:=0;
        iso:=1;
        trace:=1;
      end;
      if (nb_du = 1)then begin
        nb_typ_element:=nb_typ_element+1;
        with element[nb_typ_element] do begin
            nom:='DU';
            couleur:=clred;
            rayon:=2;
        end;
      end;

      nb_click_milieu:=0;
      flag_milieu:=0;
      beep;
      fcustomize.visible:=true;
      exit;
    end;
//-----------------------------------------------------------------------------
    dessine;
 end;
end;

procedure Tfdessin.mouse_up(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
-----------------------------------------------------------------}
var
   bb2,bb3,aux                  : matrice3;
   ixat,iyat,i,j,num,iat,ix,iy  : integer;
   s,s1                         : string;
   w                            : word ;
   atdel                        : array [1..5000] of ^atomes;
   xog,yog,zog,d,xx,yy,zz       : double;
   xx1,yy1                      : double;
   x1,y1,x2,y2,angle            : integer; //fenetre zoom
   n,k,ier,h,l,n1,n2            : integer;
   i1,i2,i3,i4,i5               : integer;

   v                            : array[1..6]of real;
   depi2                        : real;
   nb                           : integer;
   label 1;

begin
  x_up:=x;
  y_up:=y;
  souris_down:=false;
  if (mode_rotation > 0)then flag:=0;

//Bouton droit
    if (button = mbright)then begin
      click_a_droite(x,y);
      exit;
    end;
//==============================================================================
//Up et down identiques  3 pixels prs: il s'agit d'un click
//==============================================================================
  if (abs(x_up-x_down) < 3) and (abs(y_up-y_down) < 3) then begin

//Dcalage label atome (Deuxime click)
    if (flag_label_shift = 1) and (nb_click_label = 1)then begin
      child[no_atome_clique].dx:=xstk[no_atome_clique]-(x_down-ixo)/echelle;
      child[no_atome_clique].dy:=ystk[no_atome_clique]-(iyo-y_down)/echelle;
      child[no_atome_clique].tlabel:=1;
      slabel[no_atome_clique]:=edit11.text;
      edit11.visible:=false;
      edit14.visible:=false;
      edit12.visible:=false;
      nb_click_label:=0;
      dessine;
      exit;
    end;

//Identification de l'atome cliqu
    if (nb_click_bond = 2) and (flag_ecrit_labels_bond = 1) then goto 1;

    ier:=1;
    for i:=1 to nb_child do begin
      ixat:=round(xstk[i]*echelle+ixo);
      iyat:=iyo-round(ystk[i]*echelle);
      if (abs(x-ixat)< 10) and (abs(y-iyat) <  10) then begin
        ier:=0;


//Dcalage label_atome  (premier click)
        if (flag_label_shift = 1) and (nb_click_label = 0) then begin
          nb_click_label:=1;
          no_atome_clique:=i;
          beep;beep;beep;
          ix:=ixo+round(xstk[i]*echelle);
          iy:=iyo-round(ystk[i]*echelle);
          image1.canvas.brush.color:=clred;
          image1.canvas.ellipse(ix-6,iy-6,ix+6,iy+6);
          edit11.visible:=true;
          edit11.text:=trim(slabel[i]);
          if (radiogroup4.itemIndex = 1)then begin
            j:=i;
            code_positions(j,i1,i2,i3,i4);
            s:=' ('+s_pos[i1]+')('+inttostr(i1)+'_'+inttostr(i2)+
            inttostr(i3)+inttostr(i4)+')';
            edit14.visible:=true;
            edit14.text:=s;
          end else edit14.text:='';
          edit11.SetFocus;
          edit12.visible:=true;
          exit;
        end;

//Ecriture du label de l'atome cliqu
        fdessin.image1.canvas.font.size:=8;
        l:=fdessin.image1.canvas.textwidth(s) div 2;
        h:=fdessin.image1.canvas.textheight(s) div 2;
        if (flag_plan_moyen = 0) and (memo1.visible = false) and
        (flag_label_shift = 0) {and (checkbox9.checked = false)}then begin
          image1.picture.assign(clipboard);
          j:=i;
          fdessin.image1.canvas.brush.color:=clwhite;
          s:=child[i].nom;
          image1.Canvas.textout(ixo+round(xstk[i]*echelle)-l,
          iyo-round(ystk[i]*echelle)-h,s);
          image1.Canvas.textout(5,image1.height-18,s);
        end;

//L'atome cliqu sera pris comme centre de rotation
        if (speedbutton2.Down = false) then begin
          xx:=xstk[i];
          yy:=ystk[i];
          zz:=zstk[i];
          for j:=1 to nb_stk do begin
            xstk[j]:=xstk[j]-xx;
            ystk[j]:=ystk[j]-yy;
            zstk[j]:=zstk[j]-zz;
          end;
          speedbutton2.down:=true;
          panel12.visible:=false;
          reset_config_labels;
          dessine;
          exit;
        end;

        s:=child[i].nom;
        traite_nom_atome(s);

//Dtermination de la matrice par la direction de projection
        if (flag_direction = 1)then begin
          nb_click_bond:=nb_click_bond+1;
          if (nb_click_bond = 1) then begin
            ix:=ixo+round(xstk[i]*echelle);
            iy:=iyo-round(ystk[i]*echelle);
            image1.canvas.brush.color:=clred;
            image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
            panel12.caption:='Click on the second atom. (Right button to end)';
            beep;
          end;
          no_atome_bond[nb_click_bond]:=i;
          if (nb_click_bond = 2)then begin
            panel12.visible:=false;
            flag_direction:=0;
            nb_click_bond:=0;
            radiogroup1.itemIndex:=0;
            calc_direction;
            reset_config_labels;
            fdessin.masque_panel2(sender);
            dessine;
          end;
          exit;
        end;

//Affichage de la distance ou mofification de la liaison ou customization de la liaison
        if (flag_distance = 1) or (flag_killbond = 1) or (flag_cust_bond = 1) or
         (flag_ecrit_labels_bond = 1) then begin
          nb_click_bond:=nb_click_bond+1;
          ix:=ixo+round(xstk[i]*echelle);
          iy:=iyo-round(ystk[i]*echelle);
          image1.canvas.brush.color:=clred;
          image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
          if (nb_click_bond = 1) then begin
            panel12.caption:='Click on the second atom. Right button to cancel';
            if (flag_cust_bond = 1) then
            panel12.caption:='Customize a bond. Click on the second atom. Right button to cancel';
            panel12.visible:=true;
            beep;
          end;
          if (nb_click_bond < 3)then no_atome_bond[nb_click_bond]:=i;
          if (nb_click_bond = 2)then begin
            if (flag_ecrit_labels_bond = 0)then nb_click_bond:=0;
            if (flag_killbond  = 1) then modif_liaison;
            if (flag_distance  = 1) then calc_distance;
            if (flag_cust_bond = 1) or (flag_ecrit_labels_bond = 1)or
            (flag_ecrit_labels_bond = 1)then begin
              n1:=no_atome_bond[1];
              n2:=no_atome_bond[2];
              numero:=0;
              for j:=1 to nb_bonds do begin
                if (bonds[j].width = 0)then continue;
                if ((bonds[j].atome1 = n1) and (bonds[j].atome2 = n2)) or
                   ((bonds[j].atome1 = n2) and (bonds[j].atome2 = n1)) then begin
                   numero:=j;
                   break;
                end;
              end;
              if (flag_ecrit_labels_bond = 1) then begin
                 edit12.visible:=true;
                 edit11.visible:=true;
                 beep;
                 str(bonds[numero].distance:6:3,s);
                 edit11.text:=trim(s)+' ' ;
                 panel12.caption:=
                 'Now Click on the place you want to write';
                 exit;
              end;
              nb_click_bond:=0;
              panel12.caption:='Customize a bond. Click on the first atom. Right button to cancel';
              beep;
              if (numero > 0) and (flag_cust_bond = 1) then begin
                bonds[numero].width:=width_cust;
                bonds[numero].couleur:=coul_cust;
                dessine;
              end;
              exit;
            end;
          end;
          exit;
        end;

//Affichage de l'angle
        if (flag_angle = 1)then begin
          ix:=ixo+round(xstk[i]*echelle);
          iy:=iyo-round(ystk[i]*echelle);
          image1.canvas.brush.color:=clred;
          image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
          nb_click_angle:=nb_click_angle+1;
          no_atome_angle[nb_click_angle]:=i;
          if (nb_click_angle =  1) then begin
            panel12.caption:='Click on the second atom. Right button to cancel';
            beep;
          end;
          if (nb_click_angle = 2) then begin
            panel12.caption:='Click on the third atom. Right button to cancel';
            beep;
          end;
          if (nb_click_angle = 3)then begin
            nb_click_angle:=0;
            calc_angle;
            beep;
            exit;
          end;
          exit;
        end;

//Coordinance;
        if (flag_coordinance = 1)then begin
          x_coordinance:=child[i].x;
          y_coordinance:=child[i].y;
          z_coordinance:=child[i].z;
          no_atome_coordinance:=i;
          fdisp_coordinance.show;
          reset_config_labels;
          ix:=ixo+round(xstk[i]*echelle);
          iy:=iyo-round(ystk[i]*echelle);
          image1.canvas.brush.color:=clred;
          image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
          exit;
        end;

//Dtermination de la matrice par 3 atomes
        if (flag_triangle = 1) then begin
          nb_click_plan:=nb_click_plan+1;
          image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
          if nb_click_plan =1 then begin
            s:='Click on the second atom. Right button to cancel';
            beep;
          end else if (nb_click_plan = 2)then begin
            panel12.caption:='Click on the third atom. Right button to cancel';
            beep;
          end;
          no_atome_plan[nb_click_plan]:=i;
          fdessin.image1.canvas.brush.color:=clred;
          fdessin.image1.canvas.ellipse(x-5,y-5,x+5,y+5);
          if (nb_click_plan = 3)then begin
            panel12.visible:=false;
            flag_triangle:=0;
            nb_click_plan:=0;
            mode_rotation:=1;
            radiogroup1.itemIndex:=0;
            calc_plan;
            reset_config_labels;
            exit;
          end;
          exit;
        end;

//Ecriture label centr
        if (flag_label_centre = 1) and (flag_plan_moyen = 0) and (flag_tue_atome = 0)then begin
          child[i].dx:=0;child[i].dy:=0;child[i].tlabel:=1;
          beep;beep;beep;
          dessine;
          exit;
        end;

//Tue un atome individuellement
        if (flag_tue_atome = 1)then begin
          child[i].trace:=0;
          child[i].tlabel:=0;
          child_init[i].trace:=0;
          child_init[i].tlabel:=0;
          if (flag_zoom = 0)then premier_dessin;
          dessine;
          exit;
        end;

//Tue un fragment (mars 2001)
        if (flag_tue_fragment = 1)then begin
          j:=child[i].nbfrg;
          for k:=1 to nb_child do begin
            if (child[k].nbfrg = j)then child[k].trace:=0
          end;
          flag_tue_fragment:=0;
          panel12.visible:=false;
          dessine;
          exit;
        end;

//Tue un label individuellement
        if (flag_delete_label = 1)then begin
          child[i].tlabel:=0;
          dessine;
          exit;
        end;

//Plan moyen -------------------------------------------------------------------
        if (flag_plan_moyen = 1)then begin
          beep;
          nb_plm:=nb_plm+1;
          if (nb_plm > 30)then begin
            erreur('Nb of atoms exceeding 30!');
            exit;
          end;
          with child[i] do begin
            no_plm[nb_plm]:=i;
            s:=nom;
            traite_nom_atome(s);
            s:=s+'('+inttostr(i)+')';
            fplan_moyen.stringGrid1.cells[0,nb_plan_moyen]:=
            'Nb.'+inttostr(nb_plan_moyen+1);
            fplan_moyen.stringgrid1.cells[nb_plm,nb_plan_moyen]:=s;
            fdessin.image1.canvas.brush.color:=clwhite;

//Modif 8 septembre
            fdessin.image1.canvas.font.size:=8;
            l:=fdessin.image1.canvas.textwidth(s) div 2;
            h:=fdessin.image1.canvas.textheight(s) div 2;
            image1.Canvas.textout(ixo+round(xstk[i]*echelle)-l,
            iyo-round(ystk[i]*echelle)-h,s);

          end;
          exit;
        end;
//Plan moyen fin----------------------------------------------------------------

//Milieu d'un cycle(juillet 2001)
        if (flag_milieu = 1)then begin
          beep;
          nb_click_milieu:=nb_click_milieu+1;
          x_m[nb_click_milieu]:=child[i].x;
          y_m[nb_click_milieu]:=child[i].y;
          z_m[nb_click_milieu]:=child[i].z;
          xstk_m[nb_click_milieu]:=xstk[i];
          ystk_m[nb_click_milieu]:=ystk[i];
          zstk_m[nb_click_milieu]:=zstk[i];
          for k:=1 to nb_click_milieu do begin
            ix:=ixo+round(xstk_m[k]*echelle);
            iy:=iyo-round(ystk_m[k]*echelle);
            image1.canvas.brush.color:=clred;
            image1.canvas.ellipse(ix-5,iy-5,ix+5,iy+5);
          end;
          exit;
      end;

      end;
    end;

//L'atome n'a pas t dtect
    if (ier = 1)and (flag_plan_moyen = 1)then begin
       exit;
    end;
    if (ier = 1)then begin
      j:=flag_killbond+flag_distance+flag_angle+flag_coordinance+flag_milieu+
      flag_tue_atome+flag_ecrit_labels_bond;
      if (j > 0)then begin
        beep;
        showmessage('Not identified atom');
      end;        
      exit;
    end;

//Trac des labels des liaisons
 1: if (checkbox9.state = cbunchecked)then begin
       flag_ecrit_labels_bond:=0;
       exit;
    end;
    n1:=no_atome_bond[1];
    xx:=xstk[n1]*echelle+ixo;
    yy:=iyo-round(ystk[n1]*echelle);
    n2:=no_atome_bond[2];
    xx1:=xstk[n2]*echelle+ixo;
    yy1:=iyo-round(ystk[n2]*echelle);
    s:=edit11.text;
    bonds[numero].labell:=trim(s);
    nb_click_bond:=0;
    if (radiogroup5.itemIndex = 1)then begin
      d:=arctan2(yy-yy1,xx1-xx);
      iy:=y-round(cos(d)*(image1.canvas.textheight(s) div 2));
      ix:=x-round(sin(d)*(image1.canvas.textheight(s) div 2));
      bonds[numero].angle:=round(57.2957*d);
    end else begin
      ix:=x;
      iy:=y-round(image1.canvas.textheight(s) div 2);
      bonds[numero].angle:=0;
    end;
//--------------------------------------------------//
    bonds[numero].dx:=xstk[n1]-(ix-ixo)/echelle;    //
    bonds[numero].dy:=ystk[n1]-(iyo-iy)/echelle;    //
//--------------------------------------------------//
//si on a cliqu en premier sur le deuxime atome de la liaison, if faut inverse l'ordre
    if (n1 = bonds[numero].atome2) and (n2 = bonds[numero].atome1) then begin
      ix:=bonds[numero].atome1;
      bonds[numero].atome1:=bonds[numero].atome2;
      bonds[numero].atome2:=ix;
    end;
    beep;
    panel12.caption:=
    'Click on the first atom with the left button to select a bond (right button to end)';
    dessine;
    edit12.visible:=false;
    edit11.visible:=false;
    exit;

//==============================================================================
//up et down diffrents: fin du rectangle ==>
//==============================================================================

// Effacement dans une fentre
  end else if (mode_rotation = 0) and (flag_cut = 1) then begin
     beep;
     w:=messageDlg('Do you want to delete the windows contents?', //confirmation
     mtConfirmation,mbYesNoCancel,0);
//Ne pas effacer
     if (w = mrNo) or (w = mrAbort) then begin
       image1.picture.assign(clipboard);
       mode_rotation:=1;
       radiogroup1.ItemIndex:=0;
       flag_cut:=0;
       exit;
     end;

//Recherche des atomes  effacer
     for i:=1 to nb_child do begin
       ixat:=round(xstk[i]*echelle+ixo);
       iyat:=iyo-round(ystk[i]*echelle);
       if (ixat >= xr1)and(iyat >= yr1)and(ixat <= xr2)and(iyat <= yr2)then
       child[i].trace:=0;
       child[i].tlabel:=0;
     end;

//calcul et dessin
    diagonalise;
    coefficients_contour;
    premier_dessin;
    dessine;

//remise des options  jour
     mode_rotation:=1;
     radiogroup1.ItemIndex:=0;
     flag_cut:=0;
     checkbox1.checked:=false;
     panel12.visible:=false;
     exit;
//-----------------------------------------------------------------------------
//Effacement des labels dans une fentre
  end else if (mode_rotation = 0) and (flag_fenetre_label = 1) then begin
     beep;
      w:=messageDlg('Do you want to delete the labels in the window?', //confirmation
      mtConfirmation,mbYesNoCancel,0);
//Ne pas effacer
     if (w = mrNo) or (w = mrAbort) then begin
       image1.picture.assign(clipboard);
       mode_rotation:=1;
       radiogroup1.ItemIndex:=0;
       flag_fenetre_label:=0;
       exit;
     end;

//Recherche des labels  effacer
     for i:=1 to nb_child do begin
       ixat:=round(xstk[i]*echelle+ixo);
       iyat:=iyo-round(ystk[i]*echelle);
       if (ixat >= xr1)and(iyat >= yr1)and(ixat <= xr2)and(iyat <= yr2)then
       child[i].tlabel:=0;
     end;
     checklistbox1.itemindex:=-1;
     checklistbox1.state[7]:=cbunchecked;
     dessine;

//remise des options  jour
     mode_rotation:=1;
     radiogroup1.ItemIndex:=0;
     flag_fenetre_label:=0;
     panel12.visible:=false;
     exit;

//------------------------------------------------------------------------------
//Zoom in
  end else if (flag_zoom = 1)then begin
    for i:=1 to nb_child do begin
      xstk_old[i]:=xstk[i];ystk_old[i]:=ystk[i]; zstk_old[i]:=zstk[i];
    end;
    nb_stk_old:=nb_stk;{echelle_old:=echelle;}
    xog:=0;yog:=0;zog:=0;
    n:=0;
    if(x_up < x_down)then begin
      x1:=x_up;
      x2:=x_down;
    end else begin
      x2:=x_up;
      x1:=x_down;
    end;
    if(y_up < y_down)then begin
      y1:=y_up;
      y2:=y_down;
    end else begin
      y2:=y_up;
      y1:=y_down;
    end;
    for i:=1 to nb_stk_old do begin
       ixat:=round(xstk[i]*echelle+ixo);
       iyat:=iyo-round(ystk[i]*echelle);
       if (ixat > x1) and (ixat < x2)
       and(iyat > y1) and (iyat < y2) then begin
         xog:=xog+xstk[i];
         yog:=yog+ystk[i];
         zog:=zog+zstk[i];
         n:=n+1;
       end;
    end;
    if (n > 0)then xog:=xog/n;yog:=yog/n;zog:=zog/n;
    for i:=1 to nb_stk do begin
      xstk[i]:=xstk[i]-xog;
      ystk[i]:=ystk[i]-yog;
      zstk[i]:=zstk[i]-zog;
    end;
    xx:=(abs(x_up-x_down)/echelle)+2/vp_min;
    yy:=(abs(y_down-y_up)/echelle)+2/vp_min;
    (*xx:=abs(x_up-x_down)/echelle;
    yy:=abs(y_down-y_up)/echelle;*)
    if (xx < yy)then xx:=yy;
    echelle:=fdessin.image1.height/xx ;
    facteur_echelle:=echelle/echelle_old;
    trackbar3.position:=round(5*facteur_echelle-5);
    str(facteur_echelle:6:2,s);
    edit13.text:=' X '+s;
    flag_zoom:=2;
    mode_rotation:=1;
    radiogroup1.ItemIndex:=0;
    x_up:=x;y_up:=y;x_down:=x;y_down:=y;
    panel12.visible:=false;
    dessine;
  end else if (flag_transl = 1) then begin
    panel11.visible:=true;
    edit8.SetFocus;
    panel12.visible:=false;

////////////////////Aout2001
  end else if (mode_rotation = 0) and (flag_kill_bonds = 1) then begin
     beep;
      w:=messageDlg('Do you want to delete all the bonds in the window?', //confirmation
      mtConfirmation,mbYesNoCancel,0);
//Ne pas effacer
     if (w = mrNo) or (w = mrAbort) then begin
       image1.picture.assign(clipboard);
       mode_rotation:=1;
       flag_kill_bonds:=0;
       panel12.visible:=false;
       mode_rotation:=1;
       exit;
     end;

//Recherche des liaisons  effacer
     for i:=1 to nb_bonds do begin
       n1:=bonds[i].atome1;
       ixat:=round(xstk[n1]*echelle+ixo);
       iyat:=iyo-round(ystk[n1]*echelle);
       if (ixat >= xr1)and(iyat >= yr1)and(ixat <= xr2)and(iyat <= yr2)then begin
         n1:=bonds[i].atome2;
         ixat:=round(xstk[n1]*echelle+ixo);
         iyat:=iyo-round(ystk[n1]*echelle);
         if (ixat >= xr1)and(iyat >= yr1)and(ixat <= xr2)and(iyat <= yr2)then
         bonds[i].width:=0;
       end;
     end;
     flag_kill_bonds:=0;
     panel12.visible:=false;
     mode_rotation:=1;
     dessine;
     exit;

  end;

end;

{Calcul des angles de rotation, de la matrice et des coordonnes}
procedure Tfdessin.mouse_move(Sender: TObject; Shift: TShiftState; X,Y: Integer);{
-------------------------------------------------------------------------------}
var
  aux                                         : matrice3;
  cx,sx,cy,sy,cz,sz                           : double;
  xx,yy,phi1,phi2,xxold,yyold,angle_rot       : double;
  i,ier                                   : integer;
  phix,phiy,phiz                              : double;

begin
 i:=flag_killbond+flag_distance+flag_angle+flag_coordinance+flag_milieu+
 flag_tue_atome+flag_ecrit_labels_bond;
 if (i > 0)then exit;
 if (souris_down = false)then exit;

//Translation
 if (mode_rotation = 3)then begin
   ixo:=ixo+x-xav;
   iyo:=iyo+y-yav;
   dessine;
   xav:=x;
   yav:=y;
   exit;
  end;

//Si les options triangle, direction, distance, angle, coordinance, pla moyen
// sont actives, on sort.
  if (memo1.visible = true) or (flag_triangle = 1) or (flag_direction = 1)
  or (flag_angle = 1) or (flag_distance = 1) or (flag_coordinance = 1)
  or (speedButton2.down = false) or (flag_plan_moyen = 1) or (flag_killbond = 1)
  or (flag_tlabel = 1) or (flag_milieu = 1) then exit;

//Drag_rectangle: Trac d'un rectangle de slection en pointill
  if (mode_rotation = 0) or (flag_transl = 1) then begin
    image1.picture.assign(clipboard);
    with image1.canvas do begin
      pen.style:=psdash;
      pen.color:=clgray;
      moveto(x_down,y_down);
      lineto(x,y_down);
      lineto(x,y);
      lineto(x_down,y);
      lineto(x_down,y_down);
      pen.style:=pssolid;
      pen.color:=clblack;
      xr1:=x_down;yr1:=y_down;
      xr2:=x;yr2:=y;
    end;
    image1.refresh;
    exit;
  end;
  if(flag = 0)then exit;
  flag_degrade:=0;

//Rotation
  if (no_bouton = 2)then exit;
  if(mode_rotation =1) then begin
    checkbox5.checked:=false;
    phix:=(y-yold)/100;
    phiy:=(x-xold)/100;
    phiz:=0;
    xold:=x;
    yold:=y;
    cx:=cos(phix);
    sx:=sin(phix);
    cy:=cos(phiy);
    sy:=sin(phiy);
    mat_rot[1,1]:=cy;
    mat_rot[1,2]:=sy*sx;
    mat_rot[1,3]:=sy*cx;
    mat_rot[2,1]:=0;
    mat_rot[2,2]:=cx;
    mat_rot[2,3]:=-sx;
    mat_rot[3,1]:=-sy;
    mat_rot[3,2]:=cy*sx;
    mat_rot[3,3]:=cx*cy;
  end;
  if(mode_rotation =2) then begin
    checkbox5.checked:=false;
    xx:=ixo-x;
    yy:=iyo-y;
    phi1:=arctan2(yy,xx);
    xxold:=ixo-xold;
    yyold:=iyo-yold;
    xold:=x;
    yold:=y;
    phi2:=arctan2(yyold,xxold);
    angle_rot:=(phi2-phi1);
    phiz:=angle_rot;
    phix:=0;
    phiy:=0;
    cz:=cos(angle_rot);
    sz:=sin(angle_rot);
    mat_rot[1,1]:=cz;
    mat_rot[1,2]:=-sz;
    mat_rot[1,3]:=0;
    mat_rot[2,1]:=sz;
    mat_rot[2,2]:=cz;
    mat_rot[2,3]:=0;
    mat_rot[3,1]:=0;
    mat_rot[3,2]:=0;
    mat_rot[3,3]:=1;
  end;
  phix0:=phix0+phix*57.2957;
  phiy0:=phiy0+phiy*57.2957;
  phiz0:=phiz0+phiz*57.2957;

  mat_mult(mat_rot,r30,aux);
  ident(aux,r30);
  matinv(r30,r03,ier);
   if (ier > 0)then begin
     erreur('erreur dans dessin ligne 1427');
     halt;
   end;
  mat_mult(r20,r03,r23);
  mat_mult(r30,r02,r32);
  mat_mult(r12,r23,r13);
  mat_mult(r32,r21,r31);

  for i:=1 to nb_stk do trfo2(xstk[i],ystk[i],zstk[i],mat_rot);
  if (flag_sphere =1) or (flag_boite = 1) then
  trfo2(xstk[nb_stk+1],ystk[nb_stk+1],zstk[nb_stk+1],mat_rot);
  coefficients_contour;
  dessine;
end;

//==============================================================================
procedure Tfdessin.flag_on(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
-----------------------------------------------------------------}
begin
  x_down:=x;
  y_down:=y;
  xav:=x;
  yav:=y;
  souris_down:=true;
  if (button = mbleft) then no_bouton:=1 else no_bouton:=2;
  if (mode_rotation > 0)then begin
    flag:=1;
    xold:=x;
    yold:=y;
  end;
  if (flag_cust_bond = 1)or (flag_kill_bonds = 1)then mode_rotation:=0;
end;

procedure Tfdessin.Retour(Sender: TObject);{
-------------------------------------------}
var
  i,j  : integer;
begin
 // fmainmenu.visible:=true;
  flag_modif_data:=0;
  flag_zoom:=0;
  mode_rotation:=1;
  radiogroup1.itemIndex:=0;
  panel12.visible:=false;
  panel2.visible:=false;
  nb_plm:=0;
  nb_plan_moyen:=0;
  fplan_moyen.listbox1.clear;
  flag_plan_moyen:=0;
  fplan_moyen.hide;
  fplan_moyen.visible:=false;
  with fplan_moyen.stringGrid1 do begin
    for i:=0 to rowcount-1 do
    for j:=0 to colcount-1 do
    cells[j,i]:='';
  end;
  //for i:=1 to nb_child do child_old[i]:=child[i];
  close;
end;

//Enregistrement de l'image
procedure Tfdessin.enregistrer(Sender: TObject);
//----------------------------------------------
begin
  if panel2.visible then masque_panel2(Sender);
  PopupMenu1.popup(left+5,top+50);
end;

procedure Tfdessin.imprime_dessin(Sender: TObject);
//-------------------------------------------------
begin
  if panel2.visible then masque_panel2(Sender);
  fimprime.show;
end;

procedure Tfdessin.initialise_creation(Sender: TObject);
//-----------------------------------------------------
var
  itop,fsize,i : integer;
  ech_scroll   : double;
begin
  trackbar3.position:=0;
  probabilite_old:=5;
  change_sommet:=0;
  facteur_echelle:=1;
  left:=0;
  top:=0;
  memo1.left:=0;
  no_atome_clique:=0;
  nb_click_label:=0;
  nb_click_angle:=0;
  nb_click_bond:=0;
  flag_coordinance:=0;
  flag_direction:=0;
  flag_plan_moyen:=0;
  ixo_old:=0;
  iyo_old:=0;
    flag_label_shift:=0;
    flag_label_centre:=0;
    point_atom:=false;
    flag_sommets:=0;
    flag_triangle:=0;
    flag_axes:=0;
    flag_degrade:=0;
    flag_distance:=0;
    flag_killbond:=0;
    flag_tlabel:=0;
    flag_move:=0;
    flag_zoom:=0;
    flag_tue_fragment:=0;
    flag_cust_bond:=0;
    flag_ecrit_labels_bond:=0;
    epaisseur:=6;
    alfa:=6;
    coul_liai:=clyellow;
    coul_bkgrd:=clwhite;
    memo1.top:=0;
    panel12.top:=0;

//Fontes par dfaut pour criture excentre
  panel12.left:=image1.left;
  s_style:='Bold, Italic';
  font_color:=clblack;
  font_name:='Times New Roman';
  font_size:=12;
  font_style:=[fsbold];
  with fdessin.image1.canvas do begin
    font.name:=font_name;
    font.style:=font_style;
    font.size:=font_size;
    font.color:=font_color;
  end;

//Ecran 800X600
  if (screen.Width = 800)then dfm800;
  //if (screen.Width = 800)then fdessin.ScaleBy(78,100);

end;

procedure Tfdessin.aide(Sender: TObject);
//--------------------------------------
begin
   Application.HelpFile:=repertoire_origine+'/gretep.hlp';
   Application.HelpContext(3);
end;

procedure Tfdessin.change_probabilite(Sender: TObject);
//----------------------------------------------------
begin
  probabilite_old:=probabilite;
  probabilite:=listbox.itemIndex+1;
  redessine(sender);
end;

procedure Tfdessin.change_width_bond(Sender: TObject);
//----------------------------------------------------
var
   s           : string;
   x,y         : double;
   i,j,n1,n2   : integer;
begin
  x:=epaisseur;
  j:=trackbar1.position;
  y:=j*0.01;
  str(y:5:2,s);
  edit5.text:=s;
  for i:=1 to nb_bonds do begin
    bonds[i].width:=round(j*bonds[i].width/x);
    if (bonds[i].width = 0)then bonds[i].width:=1;
    n1:=bonds[i].atome1;
    n2:=bonds[i].atome2;
    if (child[n1].element = 'H') or (child[n2].element = 'H') then bonds[i].width:=j div 2; 
    if (bonds[i].width = 0)then bonds[i].width:=1;
  end;
  y:=j;
  epaisseur:=j;
  if (epaisseur = 0)then epaisseur:=1;
  redessine(sender);
end;

procedure Tfdessin.chane_angle_perspective(Sender: TObject);
//---------------------------------------------------------
 var
   s   : string;
   x   : double;
begin            //Dfinit l'angle alpha de perspective
  x:=trackbar2.position*2;
  str(x:5:2,s);
  edit6.text:=s;
  redessine(sender);
end;

procedure Tfdessin.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//----------------------------------------------------------------------
var
   s   : string;
   posx: integer;
begin
   if (col = 0) then stringgrid1.canvas.brush.color:=clsilver
   else begin
     if (row = 0) then stringgrid1.canvas.brush.color:=coul_bkgrd;
     if (row = 1) then stringGrid1.canvas.brush.color:=coul_liai;
     if (row = 2) then stringGrid1.canvas.brush.color:=coul_scalebar;
     if (row > 2) then stringGrid1.canvas.brush.color:=element[row-2].couleur;
     //stringgrid1.canvas.brush.color:=element[row-1].couleur;
   end;
   stringgrid1.canvas.fillrect(rect);
   stringgrid1.canvas.font.color:=clblack;
   s:=stringgrid1.cells[col,row];
   posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
   stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfdessin.selection_couleur(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//----------------------------------------------------------------------
var
  i: integer;
begin
  if colorDialog1.execute then begin
    change_couleur:=1;
    CheckBox6.state:=cbunchecked;
    if (row = 0)then begin
      coul_bkgrd:=colorDialog1.color;
      coul_bkgrd_old:=colorDialog1.color;
    end;
    if (row = 1)then begin
      coul_liai:=colorDialog1.color;
//    set_liaisons;
      for i:=1 to nb_bonds do begin
        if (bonds[i].couleur = coul_liai_old)then bonds[i].couleur:=coul_liai;
      end;
      coul_liai_old:=colorDialog1.color;
    end;
    if (row = 2)then begin
      coul_scalebar:=colorDialog1.color;
      coul_scalebar_old:=colorDialog1.color;
    end;
    if (row > 2)then begin
      element[row-2].couleur:=colordialog1.color;
      couleurs_old[row-2]:=colordialog1.color;
    end;
    stringgrid1.refresh;
    attribue_couleur;
    dessine;
  end;
end;

procedure Tfdessin.set_mode_rotation(Sender: TObject);
//----------------------------------------------------
begin
  mode_rotation:=radiogroup1.itemindex+1;
  if (mode_rotation = 3)then begin
    flag_move:=1;
    ixo_old:=ixo;
    iyo_old:=iyo;
  end else flag_move:=0;
end;

procedure Tfdessin.select_atom_rect(Sender: TObject);
//--------------------------------------------------
begin
    mode_rotation:=0;
    flag_cut:=1;
    radiogroup1.ItemIndex:=-1;
    panel12.caption:='Draw a rectangle around the atoms to be masked';
    panel12.visible:=true;
end;

procedure Tfdessin.print_screen(Sender: TObject);
//-----------------------------------------------
begin
  Printer.Orientation:=Polandscape;
  Print;
end;

procedure Tfdessin.modif_orientation(Sender: TObject);
//----------------------------------------------
begin
  flimat.show;
end;

procedure Tfdessin.set_direction_projection(Sender: TObject);
//-----------------------------------------------------------
begin
  sauve_config_labels;
  panel12.visible:=true;
  flag_direction:=1;
  panel12.caption:='The direction of the projection will be defined by 2 atoms: '
  +'Click on the first atom. Right button to cancel';
  beep;
end;

procedure Tfdessin.matrice_sur_3atomes(Sender: TObject);
//------------------------------------------------------
begin
  sauve_config_labels;
  panel12.visible:=true;
  flag_triangle:=1;
  panel12.caption:=
  'The base plane will be defined by 3 atoms.'+
  ' Click on the first atom. Right button to cancel' ;
  beep;
end;

procedure Tfdessin.best_view(Sender: TObject);
//--------------------------------------------
var
  i,j,n1,n2,n3                  : integer;
  dist,dist_max,x,y,z           : double;
begin
  if (nb_child > 3)then begin
    n1:=0;n2:=0;n3:=0;dist_max:=0;
    for i:=1 to nb_child-1 do begin
      for j:=i+1 to nb_child do begin
        dist:=sqr(xstk[i]-xstk[j])+sqr(ystk[i]-ystk[j])+sqr(zstk[i]-zstk[j]);
        if (dist > dist_max)then begin
          dist_max:=dist;
          n1:=i;
          n2:=j;
        end;
      end;
    end;
    y:=0.5*(ystk[n1]+ystk[n2]);
    x:=0.5*(zstk[n1]+zstk[n2]);
    dist_max:=0;
    for i:=1 to nb_child do begin
      if (i = n1) or (i = n2) then continue;
      dist:=sqr(xstk[i]-x)+sqr(ystk[i]-y)+sqr(zstk[i]-z);
      if (dist > dist_max)then begin
        dist_max:=dist;
        n3:=i;
      end;
    end;
    no_atome_plan[1]:=n1;
    no_atome_plan[2]:=n2;
    no_atome_plan[3]:=n3;
    calc_plan;
  end;
  if (nb_child = 3)then begin
    no_atome_plan[1]:=1;
    no_atome_plan[2]:=2;
    no_atome_plan[3]:=3;
    calc_plan;
  end;
end;

procedure Tfdessin.set_position_label(Sender: TObject);
//-----------------------------------------------------
begin
 flag_label_shift:=1;
 flag_label_centre:=0;
 memo1.visible:=true;
end;

procedure Tfdessin.decale_label(Sender: TObject);
//-----------------------------------------------
//click sur checkbox7
var  i:integer;
begin
  if (fdessin.visible = false)then exit;
  checkbox4.checked:=false;
  if (checkbox7.checked = true) then begin
    for i:=1 to nb_child do begin
      child[i].tlabel:=1;
    end;
    mode_rotation:=0;
    panel2.visible:=true;
    redessine(sender);
  end else begin
    panel2.visible:=false;
    for i:=1 to nb_child do child[i].tlabel:=0;
    dessine;
  end;
end;

//click sur checkbox4
procedure Tfdessin.label_centre(Sender: TObject);
//-----------------------------------------------
 var
   i  : integer;
begin
  if (fdessin.visible = false)then exit;
  if (checkbox4.checked = true)then begin
    with image1.canvas.Font do begin
      font.name:='Times New Roman';
      font.size:=8;
      font.color:=clblack;
      font.style:=[];
    end;
    checkbox7.state:=cbunchecked;
    flag_label_centre:=1;
    flag_label_shift:=0;
    memo1.visible:=false;
    for i:=1 to nb_child do begin
      with child[i] do begin
        dx:=0;
        dy:=0;
        if (trace = 1)then tlabel:=1;
      end;
    end;
  end else for i:=1 to nb_child do child[i].tlabel:=0;
  panel2.visible:=false;
  dessine;
end;

procedure Tfdessin.affiche_distances(Sender: TObject);
//----------------------------------------------------
begin
  fdistances.show;
end;

procedure Tfdessin.pique_distance(Sender: TObject);
//-------------------------------------------------
begin
  sauve_config_labels;
  flag_distance:=1;
  panel12.caption:='To display a bond length: '+
  'Click on two atoms.'
  +' (Click on the right button to stop)';
  panel12.visible:=true;
  nb_click_bond:=0;
end;

procedure Tfdessin.tue_liaison(Sender: TObject);
//----------------------------------------------
begin
  sauve_config_labels;
  flag_killbond:=1;
  panel12.caption:='To select a bond to Add/Delete: '+
  'Click on the first atom';
  panel12.visible:=true;
  nb_click_bond:=0;
end;

procedure Tfdessin.pique_angle(Sender: TObject);
//----------------------------------------------
begin
  sauve_config_labels;
  flag_angle:=1;
  panel12.caption:='Angle Atom1-Atom2-Atom3'+
  'Click on the first atom.'
  +' (Click on the right button to cancel)';
  panel12.visible:=true;
  nb_click_angle:=0;
end;

procedure Tfdessin.set_coordinance(Sender: TObject);
//--------------------------------------------------
begin
  sauve_config_labels;
  flag_coordinance:=1;
  panel12.caption:='Distances and Angles around a central atom:'+
  ' click on the central atom (Right button to cancel)';
  panel12.visible:=true;
  flag_distance:=0;
  beep;
end;

procedure Tfdessin.affiche_liste_coord(Sender: TObject);
//------------------------------------------------------
begin
  fdisp_coord.show;
end;

procedure Tfdessin.ok_translation(Sender: TObject);
//--------------------------------------------------
var
   s                                                   : string;
   i,ix,iy,h,k,l                                       : integer;
   x_transl,y_transl,z_transl                          : double;
begin
  if (edit8.text = '')then s:='0' else s:=edit8.text;s:=trim(s);
  h:=strtoint(s);
  if (edit9.text = '')then s:='0' else s:=edit9.text;s:=trim(s);
  k:=strtoint(s);
  if (edit10.text = '')then s:='0' else s:=edit10.text;s:=trim(s);
  l:=strtoint(s);
  if (h = 0) and (k = 0) and (l = 0) then begin
    flag_transl:=0;
    panel12.visible:=false;
    panel11.visible:=false;
    radiogroup1.ItemIndex:=0;
    mode_rotation:=1;
    dessine;
    exit;
  end;
  x_transl:=h;y_transl:=k;z_transl:=l;
  for i:=1 to nb_child do begin
    ix:=ixo+round(xstk[i]*echelle);
    iy:=iyo-round(ystk[i]*echelle);
    if (ix > x_down) and (ix < x_up) and
       (iy > y_down) and (iy < y_up)then begin
       child[i].x:=child[i].x+x_transl;
       child[i].y:=child[i].y+y_transl;
       child[i].z:=child[i].z+z_transl;
    end;
  end;
  panel11.visible:=false;
  flag_transl:=0;
  radiogroup1.ItemIndex:=0;
  mode_rotation:=1;
  premier_dessin;
  dessine;
end;

procedure Tfdessin.set_translations(Sender: TObject);
//----------------------------------------------------
begin
  if (flag_transl = 0)then begin
    mode_rotation:=0;
    radiogroup1.ItemIndex:=-1;
    panel12.caption:=
    'Translation: Draw a rectangle around the fragment to be translated ';
    panel12.visible:=true;
    flag_transl:=1;
  end;
end;

procedure Tfdessin.reset_child(Sender: TObject);
//----------------------------------------------
var  i:integer;
begin
    facteur_echelle:=1;
    echelle:=echelle_old;
    trackbar3.position:=0;
    nb_child:=nb_child_old;
    for i:=1 to nb_child do begin
      child[i]:=child_old[i];
      child[i].trace:=1;
    end;
    if (ixo_old <> 0) and (iyo_old <> 0)then begin
      ixo:=image1.width div 2;
      iyo:=image1.height div 2;
      for i:=1 to nb_stk do begin
        xstk[i]:=xstk_old[i];
        ystk[i]:=ystk_old[i];
      end;
    end;
    mode_rotation:=1;
    radiogroup1.ItemIndex:=0;
    panel12.visible:=false;
    diagonalise;
    coefficients_contour;
    set_liaisons;
    premier_dessin;
    dessine;
end;

procedure Tfdessin.set_zoom(Sender: TObject);
//------------------------------------------
begin
    if (flag_transl > 0)then exit;
    flag_zoom:=1;
    mode_rotation:=0;
    radiogroup1.ItemIndex:=-1;
    panel12.caption:='Zoom. Click and drag the area of interest ';
    panel12.visible:=true;
end;

procedure Tfdessin.reset_zoom(Sender: TObject);
//-------------------------------------------
begin
    flag_zoom:=0;
    mode_rotation:=1;
    radiogroup1.itemIndex:=0;
    panel12.visible:=false;
    trackbar3.position:=0;
    edit13.text:='X 1.00';
    facteur_echelle:=1;
    premier_dessin;
    dessine;
end;

procedure Tfdessin.selecte_centre(Sender: TObject);
//------------------------------------------------
begin
  sauve_config_labels;
  beep;
  panel12.caption:='Click on the atom for rotating around';
  panel12.visible:=true;
end;

//Trac des axes et des plans
procedure Tfdessin.clickonplanesaxes(Sender: TObject);
//---------------------------------------------------
begin
    if (fdessin.visible = false)then exit;
    //for i:=1 to nb_child do child[i]:=child_old[i];
    if (checkbox2.checked = true)then begin
      flag_axes:=1;
      checkbox1.checked:=false;
      flag_plans:=0;
    end;
    if (checkbox2.checked = false)then flag_axes:=0;
    redessine(sender);
end;

//Trace des plans
procedure Tfdessin.CheckBox1Click(Sender: TObject);
//-------------------------------------------------
begin
    if (fdessin.visible = false)then exit;
    //for i:=1 to nb_child do child[i]:=child_old[i];
    if (checkbox1.checked = true)then begin
      flag_plans:=1;
      checkbox2.checked:=false;
      flag_axes:=0;
    end;
    if (checkbox1.checked = false)then flag_plans:=0;
    redessine(sender);
end;

procedure Tfdessin.set_mean_plane(Sender: TObject);
//------------------------------------------------
var
  i,j          : integer;
begin
  fplan_moyen.visible:=true;
  fplan_moyen.listbox1.clear;
  flag_plan_moyen:=1;
  nb_plm:=0;
  nb_plan_moyen:=0;
  with fplan_moyen.stringGrid1 do begin
    for i:=1 to colcount do
    for j:=1 to rowcount do
    Cells[i,j]:='';
  end;
  if fileExists('plan.dat')then deletefile('plan.dat');
  if fileExists('plan.sor')then deletefile('plan.sor');
  sauve_config_labels;
end;

procedure Tfdessin.tue_atome(Sender: TObject);
//--------------------------------------------
begin
    sauve_config_labels;
    mode_rotation:=0;
    flag_tue_atome:=1;
    radiogroup1.ItemIndex:=-1;
    panel12.caption:=
    'Click on the atoms to be masked.'
    +' (Click with the right button to stop)';
    panel12.visible:=true;
end;

procedure Tfdessin.RadioGroup2Click(Sender: TObject);
//---------------------------------------------------
begin
  diagonalise;
  coefficients_contour;
  dessine;
end;

procedure Tfdessin.Bitmapfilebmp1Click(Sender: TObject);      //Bitmap file *.bmp
//------------------------------------------------------
var
  s            : string;
  w            : word;
begin
  OpenPictureDialog1.filterIndex:=1;
  if OpenPictureDialog1.execute then begin
     //Sauvegarde du fichier bmp
     s:=OpenPictureDialog1.filename;
     if (s = '')then exit;
     if (pos('.',s) = 0) then s:=s+'.bmp';

     if FileExists(s) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
     end;
     image1.picture.savetofile(s);
   end;
end;

procedure Tfdessin.WindowsMetaFilewmf1Click(Sender: TObject);  //Windows MetaFile
//-----------------------------------------------------------
begin
   fwmetafile2.visible:=true;
end;

procedure Tfdessin.JPEGfilejpg1Click(Sender: TObject);   //JPEG
//----------------------------------------------------
var
     ImageJPEG    : TJPEGImage;
     ImageBMP     : TBitmap;
     s            : string;
     w            : word;
begin
   OpenPictureDialog1.filterIndex:=2;
   if OpenPictureDialog1.execute then begin
     s:=OpenPictureDialog1.filename;
     if (s = '')then exit;
     if (pos('.',s) = 0) then s:=s+'.jpg';

     if FileExists(s) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
     end;

//Transformation du fichier bmp en fichier jpg
     ImageBMP := TBitmap.Create;
     try
       imageBMP.assign(Image1.picture.graphic);//image1 dans le bitmap
       //ImageBMP.LoadFromFile('dummy.bmp'); //chargement de ImageBMP  partir d'un fichier
       ImageJPEG := TJPEGImage.Create;
       try
         ImageJPEG.CompressionQuality:=50; //modification du facteur de compression
         ImageJPEG.Assign(ImageBMP); // Ainsi ImageJPEG contiendra l'image donn par ImageBMP
         ImageJPEG.SaveToFile(s);// Sauvegarde sous fichier
       finally
         ImageJPEG.Free; // libration de la mmoire (mme en cas d'erreur grce au try finally)
       end;
     finally
       ImageBMP.Free; // libration de la mmoire (mme en cas d'erreur grce au try finally)
     end;

   end;
end;

procedure Tfdessin.CheckBox6Click(Sender: TObject);
//-------------------------------------------------
var
  i:   integer;
begin
  if(checkBox4.checked = false)then
    for i:=1 to nb_child do child[i].tlabel:=1;
end;

procedure Tfdessin.masque_panel2(Sender: TObject);
//------------------------------------------------
begin
  panel2.visible:=false;
  memo1.visible:=false;
  flag_fenetre_label:=0;  flag_label_shift:=0;   flag_label_centre:=0;
  flag_tlabel:=0;
  mode_rotation:=1;
  //for i:=1 to nb_child do child_old[i]:=child[i];
end;

procedure Tfdessin.change_bond_width(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//-------------------------------------------------------------------
begin
  redessine(sender);
end;

procedure Tfdessin.draw_cell(Sender: TObject);
//-------------------------------------------
var    i  : integer;
begin
  if (fdessin.visible = false)then exit;
  for i:=1 to 7 do child[i+nb_child].trace:=1;
  redessine(sender);
end;

procedure Tfdessin.ASCIIfilegre1Click(Sender: TObject);
//----------------------------------------------------
var  w : word;
begin
   if panel2.visible then masque_panel2(Sender);
   savedialog1.filterIndex:=2;
   if SaveDialog1.execute then begin
     nom_fichier_sortie:=SaveDialog1.filename;
     if (nom_fichier_sortie = '')then exit;
     if (pos('.',nom_fichier_sortie) = 0)then
     nom_fichier_sortie:=nom_fichier_sortie+'.gre';
     if FileExists(nom_fichier_sortie) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
     end;
     ecrit_fichier_ascii;
   end;
end;

procedure Tfdessin.desactivation(Sender: TObject);
//------------------------------------------------
begin
  flag_modif_data:=0;
end;

procedure Tfdessin.click_on_checklistbox(Sender: TObject);
//--------------------------------------------------------
var
  i  : integer;
begin
  if memo1.visible or panel12.visible then begin
     beep;beep;
     erreur('Stop first the current process (click the right button)');
     exit;
  end;
  mode_rotation:=0;
  with checklistbox1 do begin
    for i:=0 to 9 do begin
      if (i = itemindex)then continue;
      state[i]:=cbunchecked;
    end;
    case itemindex of
      0: begin  //fontes
           with fontdialog1 do begin
             font.name:=font_name;
             font.color:=font_color;
             font.size:=font_size;
             font.style:=font_style;
             if execute then begin
               font_name:=font.name;
               font_size:=font.size;
               font_color:=font.color;
               font_style:=font.style;
               s_style:='';
               if (fsbold in font.style)then s_style:='Bold';
               if (fsItalic in  font.style)then begin
                 if (s_style = '')then s_style:='Italic'
                 else s_style:=s_style+', Italic';
               end;
               if (fsunderline in  font.style)then begin
                 if (s_style = '')then s_style:='Underline'
                 else s_style:=s_style+', Underline';
               end;
               if (fsstrikeout in  font.style)then begin
                 if (s_style = '')then s_style:='Strikeout'
                 else s_style:=s_style+', Strikeout';
               end;
             end;
           end;
           dessine;
         end;
      1:begin  // Ecriture dcale
          flag_label_shift:=1;
          radiogroup4.visible:=true;
          panel2.visible:=true;
          flag_label_centre:=0;
          flag_label_centre:=0;
          memo1.visible:=true;
          beep;beep;
          trace_labels_atomes;
        end;
      2:begin   //Ecriture centre
          panel12.visible:=true;
          panel12.caption:=
          'Write label in centre: Click on an atom with the left button.(right to end)';
          flag_label_centre:=1;
          flag_label_shift:=0;
          beep;
        end;
      3:begin   //efface un label
          panel12.visible:=true;
          panel12.caption:=
          'Delete label: Click on an atom with the left button.(right to end)';
          flag_delete_label:=1;
          dessine;
        end;
      4:begin   //efface tous les labels
          flag_label_centre:=0;
          flag_label_shift:=0;
          flag_delete_label:=0;
          for i:=1 to nb_child do child[i].tlabel:=0;
          dessine;
        end;
      5:begin   //efface tous les labels centrs
          flag_label_centre:=0;
          flag_label_shift:=0;
          flag_delete_label:=0;
          for i:=1 to nb_child do begin
            with child[i] do begin
              if (dx = 0) and (dy = 0)then tlabel:=0;
            end;
          end;
          dessine;
        end;
      6:begin   //efface tous les labels dplacs
          flag_label_centre:=0;
          flag_label_shift:=0;
          flag_delete_label:=0;
          for i:=1 to nb_child do begin
            with child[i] do if (dx <> 0) or (dy <> 0)then tlabel:=0;
          end;
          dessine;
        end;
      7:begin   //efface les labels dans un recrangle
          flag_fenetre_label:=1;
          panel12.caption:='Delete labels in a selected rectangle: Click and drag the area of interest';
          panel12.visible:=true;
        end;
      8:begin   //restaure tous les labels centrs
          for i:=1 to nb_child do begin
            with child[i] do if (dx = 0) and (dy = 0)then tlabel:=1;
          end;
          dessine;
        end;
     9:begin   //restaure tous les labels dplacs
          for i:=1 to nb_child do begin
            with child[i] do begin
              if (dx <> 0) or (dy <> 0) then tlabel:=1;
            end;
          end;
          dessine;
        end;
    end;
  end;
end;

procedure Tfdessin.degarde_option(Sender: TObject);
//------------------------------------------------
begin
  if (flag_noir_blanc = 1)then exit;
  redessine(sender);
end;

procedure Tfdessin.aide_label(Sender: TObject);
//---------------------------------------------
begin
   Application.HelpFile:=repertoire_origine+'/gretep.hlp';
   Application.HelpContext(9);
end;

procedure Tfdessin.masque_elements(Sender: TObject);
//---------------------------------------------------
begin
  fmask_element.visible:=true;
end;

procedure Tfdessin.RadioGroup3Click(Sender: TObject);
//---------------------------------------------------
begin
  dessine;
end;

procedure Tfdessin.change_echelle(Sender: TObject);
//-------------------------------------------------
var
  x  :real;
  s  : string;
begin
  x:=trackbar3.position;x:=1+x/5;
  facteur_echelle:=x;
  str(x:3:1,s);
  edit13.text:=' X '+s;
  echelle:=facteur_echelle*echelle_old;
  dessine;
end;

procedure wecrit(var nomf:TextFile; var s:string);

begin
  writeln(nomf,s);
end;

procedure Tfdessin.make_povray(Sender: TObject);
//----------------------------------------------
var
  r24,r34,r43,b4,b3,r43t,r42                       : matrice3;
  nom,nomf                                         : textfile;
  s,s1,nom_fichier_pov                             : string;
  s21,s22                                          : string[2];
  iat,i,j,k,ier,n1,n2                              : integer;
  max_coul,rouge,vert,bleu,epsi                    : double;
  xmin,xmax,ymin,ymax,zmin,zmax,xx,yy,zz,diag,xm,ym,zm  : real;
  w                                                : word;
  x,y,z                                            : array[1..5000] of real;
  x4,y4,z4,x3,y3,z3,dim_max,epai,angle             : double;
const
  som1 : array[1..12] of integer =(1,2,3,4,5,6,7,8,1,2,3,4);
  som2 : array[1..12] of integer =(2,3,4,1,6,7,8,5,5,6,7,8);

begin
//calcul de la distance (3*diag)
  epai:=epaisseur*0.01;
  SaveDialog1.filterIndex:=3;
  if SaveDialog1.execute then begin
     nom_fichier_pov:=SaveDialog1.filename;
     if (nom_fichier_pov = '')then exit;
     if (pos('.',nom_fichier_pov) = 0)then
     nom_fichier_pov:=nom_fichier_pov+'.pov';
     if FileExists(nom_fichier_pov) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
     end;
  end;

  xmin:=10000;
  xmax:=-10000;
  ymin:=10000;
  ymax:=-10000;
  zmin:=10000;
  zmax:=-10000;
  dim_max:=0;
  //for i:=1 to nb_child do begin
  for i:=1 to nb_stk do begin
    if (child[i].trace = 0)then continue;
    if (xstk[i] < xmin)then xmin:=xstk[i];
    if (xstk[i] > xmax)then xmax:=xstk[i];
    if (ystk[i] < ymin)then ymin:=ystk[i];
    if (ystk[i] > ymax)then ymax:=ystk[i];
    if (zstk[i] < zmin)then zmin:=zstk[i];
    if (zstk[i] > zmax)then zmax:=zstk[i];
    if (i > nb_child)then continue;
    x4:=1/sqrt(valeur_propre[i,1]);
    if (x4 > dim_max)then dim_max:=x4;
    x4:=1/sqrt(valeur_propre[i,2]);
    if (x4 > dim_max)then dim_max:=x4;
    x4:=1/sqrt(valeur_propre[i,3]);
    if (x4 > dim_max)then dim_max:=x4;
  end;
  xx:=xmax-xmin;
  yy:=ymax-ymin;
  zz:=zmax-zmin;
  diag:=yy;
  xm:=0.5*(xmin+xmax);
  ym:=0.5*(ymin+ymax);
  zm:=0.5*(zmin+zmax);
  for i:=1 to nb_stk do begin
    x[i]:=xstk[i]-xm;
    y[i]:=ystk[i]-ym;
    z[i]:=zstk[i]-zmin;
  end;
  //zmin:=zmin-zm;
  zmin:=0;

//Ecriture fichier Povray
  assignfile (nomf,nom_fichier_pov);
  rewrite(nomf);
  writeln(nomf,'/*File created by GRETEP2');
  writeln(nomf,datetostr(date));
  writeln(nomf,'Structure: ',fmainmenu.caption);
  writeln(nomf,'Povray file name: ',nom_fichier_pov,'*/');
  writeln(nomf,'#version 3.0');
  writeln(nomf,'#include "colors.inc" ');
  writeln(nomf,'#include "textures.inc" ');
  writeln(nomf,'#include "metals.inc" ');
  max_coul:=0;

//Ecriture dclaration couleur
  if (flag_couleur_fragment = 0)then begin
    for i:=1 to nb_typ_element do begin
      j:=element[i].couleur;
      rouge:=getRvalue(j)/255;
      vert:=getGvalue(j)/255;
      bleu:=getBvalue(j)/255;
      s:=element[i].nom;
      s:=trim(s);
      writeln(nomf,'#declare couleur_',s,
      '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;')
    end;

//Atome dummy
    j:=couleur_du;
    rouge:=getRvalue(j)/255;
    vert:=getGvalue(j)/255;
    bleu:=getBvalue(j)/255;
    s:='DU';
    writeln(nomf,'#declare couleur_',s,
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;')

  end else begin   (*Fragments*)
    for i:=1 to nb_fragm do begin
      j:=coul_frag[i];
      rouge:=getRvalue(j)/255;
      vert:=getGvalue(j)/255;
      bleu:=getBvalue(j)/255;
      writeln(nomf,'#declare couleur_',i,
      '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;')
    end;

  end;

//Texture liaisons
  j:=coul_liai;
  rouge:=getRvalue(j)/255;
  vert:=getGvalue(j)/255;
  bleu:=getBvalue(j)/255;
  writeln(nomf,'#declare color_bond',
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');
  writeln(nomf,'#declare Bond_Texture      = texture {');
  writeln(nomf,'                            pigment {color color_bond }');
  writeln(nomf,'                            finish { Metal } }');

//Couleur double_triple
 (* rouge:=0;vert:=255;bleu:=0;
  writeln(nomf,'#declare color_bond_double',
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');
  writeln(nomf,'#declare Bond_Texture_double      = texture {');
  writeln(nomf,'                            pigment {color color_bond_double }');
  writeln(nomf,'                            finish { Metal } }');  *)

//Couleur echelle
  j:=coul_scalebar;
  rouge:=getRvalue(j)/255;
  vert:=getGvalue(j)/255;
  bleu:=getBvalue(j)/255;
  writeln(nomf,'#declare color_scalebar',
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');
  writeln(nomf,'#declare scalebar_Texture      = texture {');
  writeln(nomf,'                            pigment {color color_scalebar }');
  writeln(nomf,'                            finish { Metal } }');

//Couleur background
  j:=coul_bkgrd;
  rouge:=getRvalue(j)/255;
  vert:=getGvalue(j)/255;
  bleu:=getBvalue(j)/255;
  writeln(nomf,'#declare color_background',
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');

//Couleur fontes
  j:=font_color;
  rouge:=getRvalue(j)/255;
  vert:=getGvalue(j)/255;
  bleu:=getBvalue(j)/255;
  writeln(nomf,'#declare color_font',
    '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');

//Texture des plans de coupure
  writeln(nomf,'#declare Equator_Texture  = texture { ');
  writeln(nomf,'                            pigment {color Black }');
  writeln(nomf,'                            finish { Shiny } }');

//Texture des atomes
  if (flag_couleur_fragment = 0)then begin
    for i:=1 to nb_typ_element do begin
     s1:=element[i].nom;s1:=trim(s1);s1:=uppercase(s1);
     writeln(nomf,'#declare Texture_',s1,'   = texture {');
     writeln(nomf,'                        pigment {color couleur_',s1,' }');
     writeln(nomf,'                        finish { Shiny } }');
    end;
  end else begin
    for i:=1 to nb_fragm do begin
      writeln(nomf,'#declare Texture_',i,'   = texture {');
      writeln(nomf,'                        pigment {color couleur_',i,' }');
      writeln(nomf,'                        finish { Shiny } }');
    end;
  end;

//Texture coupure
  writeln(nomf,'#declare Texture_Coupure = texture {');
  writeln(nomf,'                        pigment {color RichBlue }');
  writeln(nomf,'                        finish { Shiny } }');

//rayon liaisons
  if (nb_stk > nb_child)then
      writeln(nomf,'#declare Bond_Radius2       = ',(epai/2):6:3,' ;');

//Echelle
  writeln(nomf,'#declare Bond_Radius3       = ',(epai/4):6:3,' ;');

//rayon liaisons
  writeln(nomf,'#declare Bond_Radius       = ',epai:6:3,' ;');
  writeln(nomf,'#declare Bond_Dummy        = ',(width_cust*epai/3):6:3,' ;');
  writeln(nomf,'#declare Bond_Hydrogene    = ',(epai/3):6:3,' ;');

//Distance de vue
  writeln(nomf,'#declare View_Distance     = ',(yy+2*dim_max)/0.10:8:2,';');

//Lumire, camera
  writeln(nomf,'global_settings { assumed_gamma 2.2 ambient_light rgb < 1, 1, 1 > }');
  writeln(nomf,'camera { ');
  writeln(nomf,'        location < 0.0 , 0.0 , View_Distance >');
  writeln(nomf,'        angle     10.0');
  writeln(nomf,'        up       < 0.0 , 1.0 , 0.0 > ');
  writeln(nomf,'        right    <-1.33, 0.0 , 0.0 >');
  writeln(nomf,'        look_at  < 0.0 , 0.0 , 0.0 >');
  writeln(nomf,'       } ');
  writeln(nomf,'background { color_background }');
  writeln(nomf,'light_source { < 0.0,   0.0, 500.0 >');
  writeln(nomf,'      color red 2.0 green 2.0 blue 2.0 }');
  writeln(nomf,'light_source { < 0.0, 510,   0.0 >');
  writeln(nomf,'     color red 2.0 green 2.0 blue 2.0 } ');

//Ellipsoides
//------------------------Ni Plans ni axes--------------------------------------
  if (flag_plans = 0) and (flag_axes = 0)then begin

    for iat:=1 to nb_child do begin
      if (child[iat].trace = 0)then continue;
      writeln(nomf,'/*',child[iat].nom,'*/');
      for i:=1 to 3 do
      for j:=1 to 3 do b4[i,j]:=0;
      for i:=1 to 3 do begin
        b4[i,i]:=valeur_propre[iat,i];
      end;
      for i:=1 to 3 do
      for j:=1 to 3 do r24[i,j]:=vecteur_propre[iat,i,j];
      mat_mult(r32,r24,r34);
      matinv(r34,r43,ier);

//Quadric (ellipsode)
      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',b4[1,1]:8:5,',',b4[2,2]:8:5,',',b4[3,3]:8:5,' >');
      writeln(nomf,'<     0,   0,    0    >');
      writeln(nomf,'<     0,   0,    0    >, -1}');

//Couleur, texture de l'atome
      if (flag_couleur_fragment = 0)then begin
        s:=child[iat].element;
        s1:=uptrim(s);
        s:='      texture {Texture_'+s1+'}';
        writeln(nomf,s);
      end else begin
        s:='      texture {Texture_'+inttostr(child[iat].nbfrg)+'}';
        writeln(nomf,s);
      end;

//Matrice de Transformation
      writeln(nomf,'matrix < ',r34[1,1]:10:5,',',r34[2,1]:10:5,',',r34[3,1]:10:5,',');
      writeln(nomf,'         ',r34[1,2]:10:5,',',r34[2,2]:10:5,',',r34[3,2]:10:5,',');
      writeln(nomf,'         ',r34[1,3]:10:5,',',r34[2,3]:10:5,',',r34[3,3]:10:5,',');
      writeln(nomf,'         ',x[iat]:8:3,' ,',y[iat]:8:3,' ,',z[iat]:8:3, '> ');

      writeln(nomf,'                }');
    end;
  end;

//--------------------------------------plans-----------------------------------
  if (flag_plans = 1)then begin
    for iat:=1 to nb_child do begin
      if (child[iat].trace = 0)then continue;
      writeln(nomf,'/*',child[iat].nom,'*/');
      writeln(nomf,'object { union {');
      for i:=1 to 3 do
      for j:=1 to 3 do b4[i,j]:=0;
      for i:=1 to 3 do begin
        b4[i,i]:=valeur_propre[iat,i];
      end;
      for i:=1 to 3 do
      for j:=1 to 3 do r24[i,j]:=vecteur_propre[iat,i,j];
      mat_mult(r32,r24,r34);
      matinv(r34,r43,ier);

//Quadric (ellipsode)
      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',b4[1,1]:8:5,',',b4[2,2]:8:5,',',b4[3,3]:8:5,' >');
      writeln(nomf,'<     0,   0,    0    >');
      writeln(nomf,'<     0,   0,    0    >, -1}');

//Couleur, texture de l'atome
      if (flag_couleur_fragment = 0)then begin
        s:=child[iat].element;
        s1:=uptrim(s);
        s:='      texture {Texture_'+s1+'}';
        writeln(nomf,s);
      end else begin
        s:='      texture {Texture_'+inttostr(child[iat].nbfrg)+'}';
        writeln(nomf,s);
      end;
      writeln(nomf,'         }');
(*//Couleur, texture de l'atome
      s1:=child[iat].nom;traite_nom_element(s1);s1:=copy(s1,1,2);s1:=trim(s1);
      s1:=uppercase(s1);
      s:='      texture {Texture_'+s1+'}';
      writeln(nomf,s);
      writeln(nomf,'         }');
      writeln(nomf);*)

//Quadric (traces des plans)
      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',75*b4[1,1]:8:5,',',0.95*b4[2,2]:8:5,',',0.95*b4[3,3]:8:5,' >');
      writeln(nomf,'<     0,   0,    0    >');
      writeln(nomf,'<     0,   0,    0    >, -1}');
      writeln(nomf,'     texture {Equator_Texture}');
      writeln(nomf,'         }');
      writeln(nomf);

//Contour des plans principaux
      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',0.95*b4[1,1]:8:5,',',75*b4[2,2]:8:5,',',0.95*b4[3,3]:8:5,' >');
      writeln(nomf,'<     0,   0,    0    >');
      writeln(nomf,'<     0,   0,    0    >, -1}');
      writeln(nomf,'     texture {Equator_Texture}');
      writeln(nomf,'         }');
      writeln(nomf);

      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',0.95*b4[1,1]:8:5,',',0.95*b4[2,2]:8:5,',',75*b4[3,3]:8:5,' >');
      writeln(nomf,'<      0,   0,    0    >');
      writeln(nomf,'<      0,   0,    0    >, -1}');
      writeln(nomf,'     texture {Equator_Texture}');
      writeln(nomf,'         }');
      writeln(nomf);
      writeln(nomf,'                }');

//Matrice de Transformation
      writeln(nomf,'matrix < ',r34[1,1]:10:5,',',r34[2,1]:10:5,',',r34[3,1]:10:5,',');
      writeln(nomf,'         ',r34[1,2]:10:5,',',r34[2,2]:10:5,',',r34[3,2]:10:5,',');
      writeln(nomf,'         ',r34[1,3]:10:5,',',r34[2,3]:10:5,',',r34[3,3]:10:5,',');
      writeln(nomf,'         ',x[iat]:8:3,' ,',y[iat]:8:3,' ,',z[iat]:8:3, '> ');

      writeln(nomf,'                }');
    end;
  end;

//------------------------------------Axes--------------------------------------
  if (flag_axes = 1)then begin
    for iat:=1 to nb_child do begin
      if (child[iat].trace = 0)then continue;
      writeln(nomf,'/*',child[iat].nom,'*/');
      writeln(nomf,'object { difference { union {');
      for i:=1 to 3 do
      for j:=1 to 3 do b4[i,j]:=0;
      for i:=1 to 3 do begin
        b4[i,i]:=valeur_propre[iat,i];
      end;
      for i:=1 to 3 do
      for j:=1 to 3 do r24[i,j]:=vecteur_propre[iat,i,j];
      mat_mult(r32,r24,r34);
      matinv(r34,r43,ier);

//Quadric (ellipsode)
      writeln(nomf,'object {');
      write(nomf,  '         quadric { ');
      writeln(nomf,'< ',b4[1,1]:8:5,',',b4[2,2]:8:5,',',b4[3,3]:8:5,' >');
      writeln(nomf,'<     0,   0,    0    >');
      writeln(nomf,'<     0,   0,    0    >, -1}');

//Couleur, texture de l'atome
      if (flag_couleur_fragment = 0)then begin
        s:=child[iat].element;
        s1:=uptrim(s);
        s:='      texture {Texture_'+s1+'}';
        writeln(nomf,s);
      end else begin
        s:='      texture {Texture_'+inttostr(child[iat].nbfrg)+'}';
        writeln(nomf,s);
      end;
      writeln(nomf,'         }');

//Quadric (traces)
        writeln(nomf,'object {');
        write(nomf,  '         quadric { ');
        writeln(nomf,'< ',75*b4[1,1]:8:5,',',0.95*b4[2,2]:8:5,',',0.95*b4[3,3]:8:5,' >');
        writeln(nomf,'<     0,   0,    0    >');
        writeln(nomf,'<     0,   0,    0    >, -1}');
        writeln(nomf,'     texture {Equator_Texture}');
        writeln(nomf,'         }');
        writeln(nomf);

//Contour des plans principaux
        writeln(nomf,'object {');
        write(nomf,  '         quadric { ');
        writeln(nomf,'< ',0.95*b4[1,1]:8:5,',',75*b4[2,2]:8:5,',',0.95*b4[3,3]:8:5,' >');
        writeln(nomf,'<     0,   0,    0    >');
        writeln(nomf,'<     0,   0,    0    >, -1}');
        writeln(nomf,'     texture {Equator_Texture}');
        writeln(nomf,'         }');
        writeln(nomf);

        writeln(nomf,'object {');
        write(nomf,  '         quadric { ');
        writeln(nomf,'< ',0.95*b4[1,1]:8:5,',',0.95*b4[2,2]:8:5,',',75*b4[3,3]:8:5,' >');
        writeln(nomf,'<      0,   0,    0    >');
        writeln(nomf,'<      0,   0,    0    >, -1}');
        writeln(nomf,'     texture {Equator_Texture}');
        writeln(nomf,'         }');

      writeln(nomf);
      writeln(nomf,'         } box { < 0.000,   0.0000,   0.0000 > ,');
      writeln(nomf,'                 < ',sqrt(1/b4[1,1]):7:3,',',
                                        sqrt(1/b4[2,2]):7:3,',',
                                        sqrt(1/b4[3,3]):7:3,' >');
      writeln(nomf,'texture { Texture_Coupure } }');

//@
   x4:=1/sqrt(valeur_propre[iat,1]);y4:=0;z4:=0;
   trfo(x4,y4,z4,x3,y3,z3,r34);
   if (z3 < 0)then for i:=1 to 3 do r34[i,1]:=-r34[i,1];

   x4:=0;y4:=1/sqrt(valeur_propre[iat,2]);z4:=0;
   trfo(x4,y4,z4,x3,y3,z3,r34);
   if (z3 < 0)then for i:=1 to 3 do r34[i,2]:=-r34[i,2];

   x4:=0;y4:=0;z4:=1/sqrt(valeur_propre[iat,3]);
   trfo(x4,y4,z4,x3,y3,z3,r34);
   if (z3 < 0)then for i:=1 to 3 do r34[i,3]:=-r34[i,3];

//Matrice de Transformation
      writeln(nomf,'matrix < ',r34[1,1]:10:5,',',r34[2,1]:10:5,',',r34[3,1]:10:5,',');
      writeln(nomf,'         ',r34[1,2]:10:5,',',r34[2,2]:10:5,',',r34[3,2]:10:5,',');
      writeln(nomf,'         ',r34[1,3]:10:5,',',r34[2,3]:10:5,',',r34[3,3]:10:5,',');
      writeln(nomf,'         ',x[iat]:8:3,' ,',y[iat]:8:3,' ,',z[iat]:8:3, '> ');
      writeln(nomf,'                }}');
    end;
  end;

//Trac des labels des atomes
  if (fdessin.checkbox7.state = cbchecked)then begin
    for i:=1 to nb_child do begin
      if (abs(child[i].dx) > 0) and (abs(child[i].dy) > 0) then begin
        writeln(nomf,'   text{ttf "timrom.ttf" "', slabel[i],'" 0.5 0');
        writeln(nomf,'pigment {color_font}');
        x4:=0.025*font_size;
        writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
        writeln(nomf,'translate < ',(x[i]-child[i].dx):7:2,',',
                                  (y[i]-child[i].dy):7:2,z[i]:7:2,' >');
      //writeln(nomf,'translate < ',(x[i]-child[i].dx):7:2,',',(y[i]-child[i].dy):7:2,zmin:7:2,' >');
        writeln(nomf,'}');
      end;
    end;
  end;
  
//Trac des labels des liaisons
  if (fdessin.checkbox9.state = cbchecked)then begin
    for i:=1 to nb_bonds do begin
      if (abs(bonds[i].dx) > 0) and (abs(bonds[i].dy) > 0) then begin
        n1:=bonds[i].atome1;
        n2:=bonds[i].atome2;
        s:=bonds[i].labell;
        if (pos('',s) > 0) then s[pos('',s)]:='A';
        //writeln(nomf,'   text{ttf "crystal.ttf" "',s,'" 0.5 0');
        writeln(nomf,'   text{ttf "timrom.ttf" "',s,'" 0.5 0');
        //writeln(nomf,'   text{ttf "Times.ttf" "',s,'" 0.5 0');
        writeln(nomf,'pigment {color_font}');
        x4:=0.025*font2_size;
        writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
        angle:=bonds[i].angle;
        writeln(nomf,'rotate < 0 , 0, ',angle:7:2,' >');
        writeln(nomf,'translate < ',(x[n1]-bonds[i].dx):7:2,',',
                                  (y[n1]-bonds[i].dy):7:2,z[i]:7:2,' >');
        writeln(nomf,'}');
      end;
    end;
  end;

//------------------------------------------------------------------------------
//Trac des liaisons
  for i:=1 to nb_bonds do begin
    with bonds[i] do begin
      if (child[atome1].trace = 0) or (child[atome2].trace = 0) then continue;
//Personnalisation de la liaison
      j:=bonds[i].couleur;
      rouge:=getRvalue(j)/255;
      vert:=getGvalue(j)/255;
      bleu:=getBvalue(j)/255;
      if (bonds[i].nature = 1) and (fdessin.radiogroup3.itemIndex = 1)then begin
        rouge:=0;vert:=0.5;bleu:=0;
      end;
      if (bonds[i].nature = 2) and (fdessin.radiogroup3.itemIndex = 1)then begin
        rouge:=0;vert:=0;bleu:=0.5;
      end;
      writeln(nomf,'#declare color_bond',
      '       = color red ',rouge:8:5,' green ',vert:8:5,' blue ',bleu:8:5,' ;');
      writeln(nomf,'#declare Bond_Texture      = texture {');
      writeln(nomf,'                            pigment {color color_bond }');
      writeln(nomf,'                            finish { Metal } }');

      writeln(nomf,'#declare Bond_Texture_couleur      = texture {');
      writeln(nomf,'                            pigment {color color_bond }');
      writeln(nomf,'                            finish { Metal } }');
      //end else if (bonds[i].nature = 1)then begin
      s21:=child[atome1].element;s22:=child[atome2].element;
      writeln(nomf,'cylinder {<',x[atome1]:8:3,',',y[atome1]:8:3,',',z[atome1]:8:3,'  >');
      write(nomf,'          <',x[atome2]:8:3,',',y[atome2]:8:3,', ',z[atome2]:8:3,'   > ');
      writeln(nomf,0.01*bonds[i].width:8:3);
      if (flag_couleur_fragment = 0)then writeln(nomf,'texture {Bond_Texture} } ')
      else writeln(nomf,'texture {Texture_',child[atome1].nbfrg,' } } ')
    end;
  end;

//Trace de l'chelle
   writeln(nomf);
   xx:=1.2*(-xx/2-dim_max);
   yy:=1.2*(-yy/2-dim_max);
   zz:=-zz*0.95;
   zz:=0;
   writeln(nomf,'cylinder {<',xx:8:3,',',yy:8:3,',',zz:8:3,'  >');
   writeln(nomf,'          <',(xx+1):8:3,',',yy:8:3,',',zz:8:3,'   > Bond_Radius3');
   writeln(nomf,'texture {scalebar_Texture} } ');
//Ecriture de "1"
   writeln(nomf,'   text{ttf "timrom.ttf" "1A" 0.5 0');
   writeln(nomf,'pigment {color_scalebar}');
   x4:=0.030*font_size;
   //x4:=0.10*font_size;
   writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
   zz:=0;
   epsi:=0.1;
   writeln(nomf,'translate < ',(xx+0.5-epsi):8:3,',',(yy+epsi):7:2,', ',zz:8:3,'  >');
   writeln(nomf,'}');
   writeln(nomf);

//Trac des sommets
  if (nb_stk > nb_child) then begin
    for k:=1 to 12 do begin
      i:=som1[k]+nb_child;
      j:=som2[k]+nb_child;
      writeln(nomf,'cylinder {<',x[i]:8:3,',',y[i]:8:3,',',z[i]:8:3,'  >');
      writeln(nomf,'          <',x[j]:8:3,',',y[j]:8:3,', ',z[j]:8:3,'   > Bond_Radius2');
      writeln(nomf,'texture {Bond_Texture} } ');
    end;

//Ecriture de "O"
    writeln(nomf,'   text{ttf "timrom.ttf" "O" 0.5 0');
    writeln(nomf,'pigment {color_font}');
    x4:=0.030*font_size;
    writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
    j:=nb_child+1;
    writeln(nomf,'translate < ',x[j]:7:2,',',y[j]:7:2,z[j]:7:2,' >');
    writeln(nomf,'}');
//Ecriture de "a"
    writeln(nomf,'   text{ttf "timrom.ttf" "a" 0.5 0');
    writeln(nomf,'pigment {color_font}');
    x4:=0.030*font_size;
    writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
    j:=nb_child+2;
    writeln(nomf,'translate < ',x[j]:7:2,',',y[j]:7:2,z[j]:7:2,' >');
    writeln(nomf,'}');
//Ecriture de "b"
    writeln(nomf,'   text{ttf "timrom.ttf" "b" 0.5 0');
    writeln(nomf,'pigment {color_font}');
    x4:=0.030*font_size;
    writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
    j:=nb_child+4;
    writeln(nomf,'translate < ',x[j]:7:2,',',y[j]:7:2,z[j]:7:2,' >');
    writeln(nomf,'}');
//Ecriture de "c"
    writeln(nomf,'   text{ttf "timrom.ttf" "c" 0.5 0');
    writeln(nomf,'pigment {color_font}');
    x4:=0.030*font_size;
    writeln(nomf,'scale < ',x4:6:2,',',x4:6:2,',',x4:6:2,' >');
    j:=nb_child+5;
    writeln(nomf,'translate < ',x[j]:7:2,',',y[j]:7:2,z[j]:7:2,' >');
    writeln(nomf,'}');
  end;
  closefile(nomf);

end;

procedure cherche_chemin;
//----------------------
var
  S                         :string;
  NombreDeCaracteres,j      :integer;
  LesDrives                 :array[0..250]of ansichar;
  boule                     : boolean;
  
begin
  NombreDeCaracteres:=GetLogicalDriveStrings(sizeof(LesDrives),LesDrives);
  //NombreDeCaracteres contient maintenant le nombre de caractres significatifs de LesDrives
  // Les drives sont stocks dans LesDrives. Il sont spars par un caractre nul (#0)
  // a:\#0c:\#0 etc...
  // LesDrives[0] contient 'a' LesDrives[1] contient ':' LesDrives[2] contient '\'
  // LesDrives[3] contient le caractre #0 LesDrives[4] contient par exemple 'c' etc...
  // Il nous reste  les sparer les un des autres
  chemin:='';
  s:='';
  for j:=0 to NombreDeCaracteres do begin
    if LesDrives[j]<>#0 then S:=S+LesDrives[j]
    else begin
      if (pos('a:',lowercase(s)) > 0)then begin    // a:\ trivial
        s:='';
        continue;
      end; 
      boule:=true;
      ScruteDossier(copy(s,1,2),'pvengine.exe',faAnyFile,boule);
      S:='';
      if (chemin <> '')then exit;
    end;
  end;
end;

(*procedure cherche_chemin;
//----------------------
var
 boule  : boolean;
begin
  boule:=true;
  ScruteDossier('c:','pvengine.exe',faAnyFile,boule);
  //if (chemin = '')then cherche_chemin2;
end; *)

procedure Tfdessin.povray(Sender: TObject);
//-----------------------------------------
var
   s                : string;
   i                : integer;
   NomCourt         : array[0..MAX_PATH-1]of char;
   //nomf           : textfile;
begin
//Recherche du pathname au premier appel
   if (chemin = '')then begin
     screen.cursor:=crHourGlass;
     cherche_chemin;
     screen.cursor:=crDefault;
     if (chemin = '')then begin
       erreur('file Pvengine.exe not found!');
       exit;
     end;
   end;

//Get fichier  ouvrir
   if opendialog1.execute then begin

//Recherche du nom court ('C:\PROGRA~1\POV-RA~1.1\BIN\PVENGINE.EXE ')
     GetShortPathName(PChar(chemin),NomCourt,SizeOf(NomCourt));
     s:='';
     for i:=0 to max_path-1 do begin
       if nomcourt[i] = char(0) then break;
       s:=s+nomCourt[i];
     end;
     s:=s+' +I'+opendialog1.filename;
     i:=WinExec(Pchar(s),5);
   end else exit;
end;

procedure Tfdessin.masque_fragment(Sender: TObject);
//-------------------------------------------------
begin
    mode_rotation:=0;
    flag_tue_fragment:=1;
    flag_label_centre:=0;
    radiogroup1.ItemIndex:=-1;
    panel12.caption:=
    'Click on one atom of the frament to be masked.';
    panel12.visible:=true;
end;


procedure Tfdessin.dbrown(Sender: TObject);
//-----------------------------------------
begin
  if (fbrown.WindowState = WsMinimized)then begin
    Fbrown.WindowState:=WsNormal;
    exit;
  end;
  flag_brown:=0;
  fbrown.visible:=true;
end;

procedure Tfdessin.ferme(Sender: TObject; var Action: TCloseAction);
//-------------------------------------------------------------------
var
  i,j       : integer;
begin
  flag_modif_data:=0;
  flag_zoom:=0;
  mode_rotation:=1;
  radiogroup1.itemIndex:=0;
  panel12.visible:=false;
  panel2.visible:=false;
  nb_plm:=0;
  nb_plan_moyen:=0;
  fplan_moyen.listbox1.clear;
  flag_plan_moyen:=0;
  fplan_moyen.hide;
  fplan_moyen.visible:=false;
  with fplan_moyen.stringGrid1 do begin
    for i:=0 to rowcount-1 do
    for j:=0 to colcount-1 do
    cells[j,i]:='';
  end;
end;

procedure Tfdessin.centroid(Sender: TObject);
//-------------------------------------------
begin
  //sauve_config_labels;
  flag_label_centre:=0;
  flag_cust_bond:=0;
  panel12.visible:=true;
  flag_milieu:=1;
  nb_click_milieu:=0;
  panel12.caption:=
  'Click on the atoms. Right button to end' ;
  beep;
  x_milieu:=0;
  y_milieu:=0;
  z_milieu:=0;
  xstk_milieu:=0;
  ystk_milieu:=0;
  zstk_milieu:=0;
end;

procedure Tfdessin.customize_bond(Sender: TObject);
//-------------------------------------------------
begin
  if checkbox8.checked then begin
    mode_rotation:=0;
    panel12.visible:=true;
    panel12.caption:=' Customize bond. Click on the first atom with the left button';
    panel12.color:=claqua;
    fchange_style_liai.visible:=true;
    beep;
  end;
end;

procedure Tfdessin.tue_liaisons(Sender: TObject);
//-----------------------------------------------
begin
 mode_rotation:=0;
 flag_kill_bonds:=1;
 panel12.visible:=true;
 panel12.caption:='Draw a rectangle around the bonds to be masked';
end;

procedure Tfdessin.ecrit_labels(Sender: TObject);
//-----------------------------------------------
begin
  if (saute = 1)then exit;
  if (checkbox9.checked = true) then begin
     panel5.visible:=true;
     dessine;
  end else begin
     panel5.visible:=false;
     flag_ecrit_labels_bond:=0;
     dessine;
     mode_rotation:=1;
     panel12.visible:=false;
  end;
end;

procedure Tfdessin.CheckListBox2Click(Sender: TObject);
//-----------------------------------------------------
var
  i: integer;
begin
  if memo1.visible or panel12.visible then begin
     beep;
     erreur('Stop first the current process (click the right button)');
     exit;
  end;
  mode_rotation:=0;
  with checklistbox2 do begin
    for i:=0 to 2 do begin
      if (i = itemindex)then continue;
      state[i]:=cbunchecked;
    end;
    case itemindex of
      0: begin  //fontes
           with fontdialog1 do begin
             font.name:=font2_name;
             font.color:=font2_color;
             font.size:=font2_size;
             font.style:=font2_style;
             if execute then begin
               font2_name:=font.name;
               font2_size:=font.size;
               font2_color:=font.color;
               font2_style:=font.style;
               s2_style:='';
               if (fsbold in font.style)then s2_style:='Bold';
               if (fsItalic in font.style)then begin
                 if (s2_style = '')then s2_style:='Italic'
                 else s2_style:=s2_style+', Italic';
               end;
               if (fsunderline in  font.style)then begin
                 if (s2_style = '')then s2_style:='Underline'
                 else s2_style:=s2_style+', Underline';
               end;
               if (fsstrikeout in  font.style)then begin
                 if (s2_style = '')then s2_style:='Strikeout'
                 else s2_style:=s2_style+', Strikeout';
               end;
             end;
           end;
           checklistbox2.state[0]:=cbunchecked;
           dessine;
         end;

      1: begin   //Ecriture labels
           flag_ecrit_labels_bond:=1;
           panel12.left:=edit12.width+edit11.width;
           panel12.alignment:=taleftjustify;
           edit11.top:=0;edit12.top:=0;
           panel12.visible:=true;
           beep;
           panel12.caption:='Click on the first atom with the left button to slect a bond';
           panel12.color:=clAqua;
           mode_rotation:=0;
         end;

      2:begin  // effacement des labels de liaison
          for i:=1 to nb_bonds do bonds[i].labell:='';
          checklistbox2.state[1]:=cbunchecked;
          dessine;
        end;
      end;
    end;
end;

procedure Tfdessin.fin_label_bond(Sender: TObject);
//------------------------------------------------
begin
  panel5.visible:=false;
  panel12.left:=0;
  panel12.color:=clyellow;
  flag_ecrit_labels_bond:=0;
end;




end.
