procedure sauve_config_labels;
//----------------------------
var
  i   : integer;
begin
  with fdessin do begin
    for i:=1 to nb_child do begin
      child_init[i]:=child[i];
      with child[i] do begin
        dx:=0;
        dy:=0;
        tlabel:=1;
      end;
      //child_old[i]:=child[i];
    end;
    cb4_check_old:=checkbox4.checked;
    cb7_check_old:=checkbox7.Checked;
    fllab_centre_old:=flag_label_centre;
    fllab_shift_old:=flag_label_shift;
    Checkbox4.checked:=true;
    checkbox4.state:=cbchecked;
    Checkbox7.checked:=false;
    checkbox7.state:=cbunchecked;
    flag_label_shift:=0;
    flag_label_centre:=1;
  end;
end;

procedure reset_config_labels;
//----------------------------
var
  i   : integer;
begin
   with fdessin do begin
     checkbox7.checked:=cb7_check_old;
     checkbox4.checked:=cb4_check_old;
   end;
   for i:=1 to nb_child do begin
      child[i]:=child_init[i];
      //child_old[i]:=child[i];
   end;
   fdessin.panel2.visible:=false;
   flag_label_centre:=fllab_centre_old;
   flag_label_shift:=fllab_shift_old;
   if (flag_label_centre = 0)then begin
     fdessin.Checkbox7.checked:=false;
     fdessin.checkbox7.state:=cbunchecked;
   end;
end;

//Coefficients du contour dans l'espace 3
procedure coefficients_contour;
//----------------------------
var
   bb2,bb3,aux             : matrice3;
   i,j,iat                 : integer;
   nomf                    : TextFile;
begin
//Nouveaux coefficients du contour dans l'espace 3
  assignfile(nomf,'cont.txt');
  rewrite(nomf);
  for iat:=1 to nb_child do begin
    for i:=1 to 3 do begin
       for j:=1 to 3 do bb2[i,j]:=b_quad[iat,i,j];
    end;
    writeln(nomf,child[iat].nom);
    mat_mult(bb2,r23,aux);
    mat_mult(r32,aux,bb3); {r31.bb2.r13}
    for i:=1 to 3 do begin
      for j:=1 to 3 do bb[iat,i,j]:=bb3[i,j];
    end;
    writeln(nomf,bb3[1,1]:12:7,bb3[2,2]:12:7,bb3[3,3]:12:7);
    writeln(nomf,2*bb3[1,2]:12:7,2*bb3[2,3]:12:7,2*bb3[1,3]:12:7);
    k1[iat]:=bb3[1,3]*bb3[1,3]-bb3[1,1]*bb3[3,3];
    k2[iat]:=bb3[2,3]*bb3[2,3]-bb3[2,2]*bb3[3,3];
    k3[iat]:=2*(bb3[1,3]*bb3[2,3]-bb3[1,2]*bb3[3,3]);
    k4[iat]:=-bb3[3,3];
  end;
  closefile(nomf);
end;

Procedure dessin_repere;
//----------------------
const x_rep : array[1..8] of double = (0,1,0,1,0,1,0,1);
      y_rep : array[1..8] of double = (0,0,1,1,0,0,1,1);
      z_rep : array[1..8] of double = (0,0,0,0,1,1,1,1);
  var
     xm,ym,i                  : integer;
     ex,ey,xx,dx,dy           : double;
     ix,iy                    : array[1..8] of integer;
begin
//dessin du repre
  xx:=-10000;
  for i:=1 to 8 do
  trfo(x_rep[i],y_rep[i],z_rep[i],x_repo[i],y_repo[i],z_repo[i],r30);
  dx:=(x_repo[1]+x_repo[8])/2;
  dy:=(y_repo[1]+y_repo[8])/2;
  for i:=1 to 8 do begin
    x_repo[i]:=x_repo[i]-dx;
    y_repo[i]:=y_repo[i]-dy;
    if (abs(x_repo[i]) > xx)then xx:=abs(x_repo[i]);
    if (abs(y_repo[i]) > xx)then xx:=abs(y_repo[i]);
  end;
  xx:=2*xx;
  ex:=0.9*fdessin.image2.width/xx;
  ey:=0.9*fdessin.image2.height/xx;
  xm:=(fdessin.image2.width div 2)+1;
  ym:=(fdessin.image2.height div 2)+1;
  fdessin.image2.refresh;
  for i:=1 to 8 do begin
    ix[i]:=round(x_repo[i]*ex)+xm;
    iy[i]:=-round(y_repo[i]*ey)+ym;
  end;

  with fdessin.image2.canvas  do begin
    brush.color:=clblue;
    pen.color:=clyellow;
    pen.width:=2;
    font.size:=10;
    font.style:=[fsbold];
    font.color:=clwhite;
    rectangle(0,0,fdessin.image2.width,fdessin.image2.height);

    moveto(ix[1],iy[1]);
    lineto(ix[2],iy[2]);
    moveto(ix[1],iy[1]);
    lineto(ix[3],iy[3]);
    moveto(ix[1],iy[1]);
    lineto(ix[5],iy[5]);
    moveto(ix[4],iy[4]);
    lineto(ix[2],iy[2]);
    moveto(ix[4],iy[4]);
    lineto(ix[3],iy[3]);
    moveto(ix[4],iy[4]);
    lineto(ix[8],iy[8]);

    moveto(ix[6],iy[6]);
    lineto(ix[2],iy[2]);
    moveto(ix[6],iy[6]);
    lineto(ix[5],iy[5]);
    moveto(ix[6],iy[6]);
    lineto(ix[8],iy[8]);

    moveto(ix[7],iy[7]);
    lineto(ix[5],iy[5]);
    moveto(ix[7],iy[7]);
    lineto(ix[3],iy[3]);
    moveto(ix[7],iy[7]);
    lineto(ix[8],iy[8]);
    pen.color:=clblack;
    pen.width:=1;

    textout(ix[1]-4,iy[1]-7,'o');
    textout(ix[2]-4,iy[2]-7,'a');
    textout(ix[3]-4,iy[3]-7,'b');
    textout(ix[5]-4,iy[5]-7,'c');
   end;
end;

//=============================================================================
procedure diagonalise;{
-----------------------
Diagonalisation des matrices beta}
var
  mat,mat_inv,mat_vec_prop,r12t,bet,aux           : matrice3;
  val_prop                                        : vecteur3;
  i,j,iat,ier                                     : integer;
  pi2,g2                                          : double;
  ueq,depi2,x                                       : double;
  t,v                                             : array[1..6] of double;
  nomf                                            : textfile;
const
  g_prob : array[1..10] of double
         =(0.7644,1.0026,1.1932,1.3672,1.5382,1.7164,1.9144,2.1544,2.5,5.95);
begin
 pi2:=2*pi*pi;
 g2:=sqr(g_prob[probabilite]);
 for i:=1 to 3 do begin
   for j:=1 to 3 do begin
     r12t[j,i]:=r12[i,j];
   end;
 end;
 attribue_couleur;
 depi2:=2.*3.14159*3.14159;
(* if (fdessin.radiogroup2.itemIndex = 1)then begin
   t[1]:=sqr(cel[1]);t[2]:=sqr(cel[2]);t[3]:=sqr(cel[3]);
   t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
   t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
   t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   (*v[1]:=depi2*celr[1]*celr[1];
   v[2]:=depi2*celr[2]*celr[2];
   v[3]:=depi2*celr[3]*celr[3];
   v[4]:=depi2*celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=depi2*celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=celr[2]*celr[3]*cos(celr[4]/57.2957);
   v[1]:=celr[1]*celr[1];
   v[2]:=celr[2]*celr[2];
   v[3]:=celr[3]*celr[3];
   v[4]:=celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=celr[2]*celr[3]*cos(celr[4]/57.2957);
 end;
 for iat:=1 to nb_child do begin

   for i:=1 to 3 do
   for j:=1 to 3 do bet[i,j]:=0;
   with child[iat] do begin
     if (fdessin.radiogroup2.itemIndex = 0)then begin
       bet[1,1]:=beta[1]*g2/pi2;
       bet[2,2]:=beta[2]*g2/pi2;
       bet[3,3]:=beta[3]*g2/pi2;
       bet[1,2]:=beta[4]*g2/pi2;
       bet[1,3]:=beta[5]*g2/pi2;
       bet[2,3]:=beta[6]*g2/pi2;
     end else begin
       if (iso = 0)then begin
         ueq:=0;
         for i:=1 to 6 do ueq:=ueq+pi2*beta[i]*t[i]*v[i];
         ueq:=ueq/depi2;
         bet[1,1]:=ueq*v[1]*g2;
         bet[2,2]:=ueq*v[2]*g2;
         bet[3,3]:=ueq*v[3]*g2;
         bet[1,2]:=ueq*v[4]*g2;
         bet[1,3]:=ueq*v[5]*g2;
         bet[2,3]:=ueq*v[6]*g2;
       end else begin
         bet[1,1]:=beta[1]*g2/pi2;
         bet[2,2]:=beta[2]*g2/pi2;
         bet[3,3]:=beta[3]*g2/pi2;
         bet[1,2]:=beta[4]*g2/pi2;
         bet[1,3]:=beta[5]*g2/pi2;
         bet[2,3]:=beta[6]*g2/pi2;
        end;
     end;
   end;*)
 if (fdessin.radiogroup2.itemIndex = 1)then begin
   t[1]:=sqr(cel[1]);t[2]:=sqr(cel[2]);t[3]:=sqr(cel[3]);
   t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
   t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
   t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   v[1]:=depi2*celr[1]*celr[1];
   v[2]:=depi2*celr[2]*celr[2];
   v[3]:=depi2*celr[3]*celr[3];
   v[4]:=depi2*celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=depi2*celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=depi2*celr[2]*celr[3]*cos(celr[4]/57.2957);
 end;
 assignfile(nomf,'VP.txt');
 rewrite(nomf);
 for iat:=1 to nb_child do begin

   for i:=1 to 3 do
   for j:=1 to 3 do bet[i,j]:=0;
   with child[iat] do begin
     if (fdessin.radiogroup2.itemIndex = 0)then begin
       bet[1,1]:=beta[1]*g2/pi2;
       bet[2,2]:=beta[2]*g2/pi2;
       bet[3,3]:=beta[3]*g2/pi2;
       bet[1,2]:=beta[4]*g2/pi2;
       bet[1,3]:=beta[5]*g2/pi2;
       bet[2,3]:=beta[6]*g2/pi2;
     end else begin
       if (iso = 0)then begin
         ueq:=0;
         for i:=1 to 6 do ueq:=ueq+beta[i]*t[i];
         ueq:=ueq/(3*depi2);
         bet[1,1]:=ueq*v[1]*g2/pi2;
         bet[2,2]:=ueq*v[2]*g2/pi2;
         bet[3,3]:=ueq*v[3]*g2/pi2;
         bet[1,2]:=ueq*v[4]*g2/pi2;
         bet[1,3]:=ueq*v[5]*g2/pi2;
         bet[2,3]:=ueq*v[6]*g2/pi2;
       end else begin
         bet[1,1]:=beta[1]*g2/pi2;
         bet[2,2]:=beta[2]*g2/pi2;
         bet[3,3]:=beta[3]*g2/pi2;
         bet[1,2]:=beta[4]*g2/pi2;
         bet[1,3]:=beta[5]*g2/pi2;
         bet[2,3]:=beta[6]*g2/pi2;
        end;
     end;
   end;
   bet[2,1]:=bet[1,2];
   bet[3,1]:=bet[1,3];
   bet[3,2]:=bet[2,3];
   mat_mult(bet,r12,aux);
   mat_mult(r12t,aux,mat);
//Test matrice non definie positive
        if (mat[1,1]*mat[2,2]-sqr(mat[1,2]) < 0)or
           (mat[1,1]*mat[3,3]-sqr(mat[1,3]) < 0)or
           (mat[3,3]*mat[2,2]-sqr(mat[2,3]) < 0)or
           (mat[1,1]*mat[2,2]*mat[3,3]+2*mat[1,2]*mat[1,3]*mat[2,3]-
           mat[1,1]*mat[2,3]*mat[2,3]-
           mat[2,2]*mat[1,3]*mat[1,3]-
           mat[3,3]*mat[1,2]*mat[1,2]        < 0)then
             erreur('Non definite positive matrix on atom '+ child[iat].nom);

   writeln(nomf,'atome');
   with child[iat] do begin
      writeln(nomf,nom,x:8:4,y:8:4,z:8:4);
      for j:=1 to 6 do write(nomf,beta[j]:10:6);
      writeln(nomf);
   end;
   for i:=1 to 3 do
   for j:=1 to 3 do
   if (mat_inv[i,j] < 0.0001) then mat_inv[i,j]:=0;

   diago(mat_inv,mat_vec_prop,val_prop);
   writeln(nomf,'valeurs propres');
   if (ier > 0)then begin
     erreur(child[iat].nom+' '+inttostr(iat)+'  Please contact J. Laugier');
     closefile(nomf);
     halt;
   end;
   vp_min:=100000;
   for i := 1 to 3 do  begin
     valeur_propre[iat,i]:=val_prop[i];
     if (val_prop[i] < 1e-25)then begin
       closefile(nomf);
       erreur('Halte');
       halt;
       exit;
     end;
     write(nomf,1/val_prop[i]:10:5);
     if (vp_min > val_prop[i])then vp_min:=val_prop[i];
   end;
   writeln(nomf);
   writeln(nomf,'vecteurs');
   x:=pi2/g2;
   writeln(nomf,x*bet[1,1]:12:6,x*bet[2,2]:12:6,x*bet[3,3]:12:6);
   writeln(nomf, 2*x*bet[1,2]:12:6,2*x*bet[1,3]:12:6,2*x*bet[2,3]:12:6);
   writeln(nomf,'vecteurs propres');
   for i := 1 to 3 do begin
     for j:=1 to 3 do begin
       vecteur_propre[iat,i,j]:=mat_vec_prop[i,j];
       write(nomf,vecteur_propre[iat,i,j]:12:6);
       b_quad[iat,i,j]:=mat_inv[i,j];
     end;
     writeln(nomf);
   end;
 end;
 closefile(nomf);
end;

procedure dessine;{
------------------}
var
  ix,iy,i,j,k,n1,n2,jj                           : integer;
  zmax,x,y,z                                  : double;
  indic                                       : array[1..2000] of integer;
  ix_s,iy_s                                   : array[1..8] of integer;
  s                                           : string;
  fname                    : string;
  fstyle                   : TFontStyles;
  fsize                    : integer;
  fcolor                   : integer;

begin
//Affichage de la direction de projection
  x:=r03[1,3];y:=r03[2,3];z:=r03[3,3];
  zmax:=-1000;
  if(abs(x) > zmax)then zmax:=abs(x);
  if(abs(y) > zmax)then zmax:=abs(y);
  if(abs(z) > zmax)then zmax:=abs(z);
  x:=x/zmax;y:=y/zmax;z:=z/zmax;
  str(x:10:5,s);
  fdessin.edit2.text:=s;
  str(y:10:5,s);
  fdessin.edit1.text:=s;
  str(z:10:5,s);
  fdessin.edit7.text:=s;
  fdessin.panel1.refresh;
  if (s_style = '')then font_style:=[];
  if (s_style = 'Bold')then font_style:=[fsbold];
  if (s_style = 'Bold, Underline')then font_style:=[fsbold, fsunderline];
  if (s_style = 'Underline')then font_style:=[fsunderline];
  if (s_style = 'Italic')then font_style:=[fsitalic];
  if (s_style = 'Bold, Italic')then font_style:=[fsbold, fsitalic];
  if (s_style = 'Bold, Italic, Underline')then font_style:=[fsbold, fsitalic, fsunderline];

//Effacement
  with fdessin.image1 do begin
    refresh;
    canvas.brush.color:=coul_bkgrd;
    canvas.rectangle(0,0,fdessin.image1.width,fdessin.image1.height);
    canvas.pen.color:=clblack;
  end;

 //Classement des atomes en z croissant
  zmax:=-10000;
  for i:=1 to nb_child do indic[i]:=1;
  for i:=1 to nb_child do begin
    for j:=1 to nb_child do begin
      if (zstk[j] > zmax) and (indic[j] = 1) then begin
        zmax:= zstk[j];
        num_trace[i]:=i;
        num_atome[i]:=j;
      end;
    end;
    indic[num_atome[i]]:=0;
    zmax:=-10000;
  end;

//Trac des ellipses
//Attention: il semble que le numero de trac soit num_atome et non pas num_trace!
  for j:=1 to nb_child do begin
    for jj:=1 to nb_child do begin
      i:=num_atome[nb_child-j+1];
      if (num_atome[jj] <> j) then continue;
      if (child[i].trace = 0)then continue;
      ellipse(i,num_trace[jj]);
      if (nb_bonds > 0)then begin
        for k:=1 to nb_bonds do begin
          n1:=bonds[k].atome1;
          n2:=bonds[k].atome2;
          if (child[n1].trace = 0) or (child[n2].trace = 0)then continue;
          if (n1 = i) and (zstk[n2] >= zstk[i])then liaison(n1,n2,bonds[k].nature);
          if (n2 = i) and (zstk[n1] >= zstk[i])then liaison(n1,n2,bonds[k].nature);
        end;
      end;
    end;
  end;

//Trac des labels
  trace_labels;
   
//Trac ventuel des sommets
  if (nb_stk > nb_child)then begin

    for i:=1 to 8 do begin
      ix_s[i]:=round(xstk[nb_child+i]*echelle+ixo);
      iy_s[i]:=iyo-round(ystk[nb_child+i]*echelle);
    end;
    with fdessin.image1.canvas do begin
      brush.color:=clwhite;
      pen.style:=psdot;
      pen.color:=clgray;
      for i:=1 to 4 do begin
        moveto(ix_s[i],iy_s[i]);
        j:= i+1 ;
        if (j > 4) then j:=j-4;
        lineto(ix_s[j],iy_s[j]);
      end;
      for i:=1 to 4 do begin
        moveto(ix_s[i+4],iy_s[i+4]);
        j:= 4+i+1;
        if (j > 8)then j:=j-4;
        lineto(ix_s[j],iy_s[j]);
      end;
      for i:=1 to 4 do begin
        moveto(ix_s[i],iy_s[i]);
        lineto(ix_s[i+4],iy_s[i+4]);
      end;
      pen.style:=psSolid;
      pen.color:=clblack;
      {Ecriture des noms des axes du repre}
      brush.color:=$F7E0B2;
      with font do begin
        fname:=name;
        fstyle:=style;
        fsize:=size;
        fcolor:=color;
        name:='Times New Roman';
        style:=[fsbold];
        size:=14;
        color:=clblack;
      end;
      s:='o';
      ecrit_transparent(ix_s[1],iy_s[1],s);
      s:='a';
      ecrit_transparent(ix_s[2],iy_s[2],s);
      s:='b';
      ecrit_transparent(ix_s[4],iy_s[4],s);
      s:='c';
      ecrit_transparent(ix_s[5],iy_s[5],s);
      brush.color:=clwhite;
      with font do begin
        name:=fname;
        style:=fstyle;
        size:=fsize;
        color:=fcolor;
      end;
    end;
  end;

//Dessin de la maille dans image2
  dessin_repere;

//dessin ventuel de la sphre
  if (flag_sphere = 1)then begin
    with fdessin.Image1.canvas do begin
       pen.style:=psdash;
       pen.color:=clgray;
       for i:=1 to 51 do begin;
          ix:=ixo+round((xstk[nb_stk+1]+co[i]*rayon_sphere)*echelle);
          iy:=iyo-round((ystk[nb_stk+1]+si[i]*rayon_sphere)*echelle);
          if (i = 1) then moveto(ix,iy) else lineto(ix,iy);
       end;
    end;
  end;
//croix au centre
  if (flag_sphere = 1) or (flag_boite = 1) then begin
    with fdessin.Image1.canvas do begin
       pen.style:=psSolid;
       pen.color:=clblack;
       brush.color:=clred;
       ix:=ixo+round(xstk[nb_stk+1]*echelle);
       iy:=iyo-round(ystk[nb_stk+1]*echelle);
       moveto(ix-5,iy);lineto(ix+5,iy);
       moveto(ix,iy-5);lineto(ix,iy+5);
       //ellipse(ix-5,iy-5,ix+5,iy+5);
    end;
  end;

  fdessin.image1.refresh;
  Clipboard.Assign(fdessin.Image1.Picture);
end;

procedure premier_dessin;{
--------------------------
Initialisation et trac  la cration de la fiche}
var
  i,n                                                :integer;
  xmin,ymin,zmin,xmax,ymax,zmax,xx,yy                :double;

const x_som : array[1..8] of double = (0,1,1,0,0,1,1,0);
      y_som : array[1..8] of double = (0,0,1,1,0,0,1,1);
      z_som : array[1..8] of double = (0,0,0,0,1,1,1,1);
const
      n1_som: array[1..12] of integer = (1,2,3,4,1,2,3,4,5,6,7,8);
      n2_som: array[1..12] of integer = (2,3,4,1,5,6,7,8,6,7,8,5);

begin

  phix0:=0;phiy0:=0;phiz0:=0;
  flag:=0;
  flag_cut:=0;
  flag_delete_label:=0;

//Lecture des coordonnes de dpart
  nb_stk:=nb_child;
  for i:=1 to nb_stk do begin
    xstk[i]:=child[i].x;
    ystk[i]:=child[i].y;
    zstk[i]:=child[i].z;
    trfo2(xstk[i],ystk[i],zstk[i],r30);
  end;
  if(flag_sommets = 1) then begin
     for i:=1 to 8 do begin
       nb_stk:=nb_stk+1;
       xstk[nb_stk]:=x_som[i];
       ystk[nb_stk]:=y_som[i];
       zstk[nb_stk]:=z_som[i];
       trfo2(xstk[nb_stk],ystk[nb_stk],zstk[nb_stk],r30);
     end;
  end;
  if (flag_sphere = 1) or (flag_boite = 1) then begin
    trfo(x_centre,y_centre,z_centre,
    xstk[nb_stk+1],ystk[nb_stk+1],zstk[nb_stk+1],r30);
  end;
  xmax:=-100000.;
  ymax:=xmax;
  zmax:=xmax;
  xmin:=100000.;
  ymin:=xmin;
  zmin:=xmin;

  n:=0;
  for i:=1 to nb_stk do begin
    if(child[i].trace = 1)then begin
      n:=n+1;
      if(xstk[i] > xmax) then xmax:=xstk[i];
      if(xstk[i] < xmin) then xmin:=xstk[i];
      if(ystk[i] > ymax) then ymax:=ystk[i];
      if(ystk[i] < ymin) then ymin:=ystk[i];
      if(zstk[i] > zmax) then zmax:=zstk[i];
      if(zstk[i] < zmin) then zmin:=zstk[i];
    end;
  end;

//Calcul du centre de gravite
  xog:=0;yog:=0;zog:=0;
  for i:=1 to nb_stk do begin
    if(child[i].trace = 1)then begin
      xog:=xog+xstk[i];
      yog:=yog+ystk[i];
      zog:=zog+zstk[i];
    end;
  end;
  xog:=xog/n;yog:=yog/n;zog:=zog/n;

  for i:=1 to nb_stk do begin
    xstk[i]:=xstk[i]-xog;
    ystk[i]:=ystk[i]-yog;
    zstk[i]:=zstk[i]-zog;
  end;
  if (flag_sphere = 1) or (flag_boite = 1) then begin
    xstk[nb_stk+1]:=xstk[nb_stk+1]-xog;
    ystk[nb_stk+1]:=ystk[nb_stk+1]-yog;
    zstk[nb_stk+1]:=zstk[nb_stk+1]-zog;
//***********************Modif du 27 fvrier 2000******************************
    for i:=1 to nb_stk+1 do begin
      xstk[i]:=xstk[i]-xstk[nb_stk+1];
      ystk[i]:=ystk[i]-ystk[nb_stk+1];
      zstk[i]:=zstk[i]-zstk[nb_stk+1];
    end;
//*****************************************************************************
  end;
(*  if (nom_fichier_shelx <> '')
  then fdessin.caption:=ExtractFileName(nom_fichier_shelx);
  if (nom_fichier_grt <> '')
  then fdessin.caption:=ExtractFileName(nom_fichier_grt);
  if (nom_fichier_ascii <> '')
  then fdessin.caption:=ExtractFileName(nom_fichier_ascii);
  if (nom_fichier_sortie <> '')
  then fdessin.caption:=ExtractFileName(nom_fichier_sortie);*)
  fdessin.image1.canvas.pen.color:=clblack;

//dtermination de l'chelle
  xx:=0.0001;
  for i:=1 to nb_stk do begin
    if(child[i].trace = 1)then begin
      yy:=sqr(xstk[i])+sqr(ystk[i])+sqr(zstk[i]);
      if(yy > xx) then xx:=yy;
    end;
  end;
  xx:=sqrt(xx)+1/sqrt(vp_min);
  echelle_old:=((fdessin.image1.height-10) div 2)/xx ;
  echelle:=echelle_old*facteur_echelle;
  fdessin.edit13.text:=' X 1.0';

end;

procedure reset_matrice;
//---------------------
var  i,j   : integer;
begin
  {Matrice de rotation de dpart = matrice unit}
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mat_rot[i,j]:=0;
      if(i = j)then mat_rot[i,j]:=1;
    end;
  end;
  if (flag_zoom = 0)then premier_dessin;
end;

procedure ecrit_stringgrid1;
//--------------------------
var
  //s             : string;
  s2,s1         : string;
  i             : integer;
begin
    //Eciture des symboles atomiques et des couleurs dans la grille
    with fdessin.stringGrid1 do begin
      rowcount:=nb_typ_element+2;
      if (rowcount > 5)then height:=100 else height:=20*(nb_typ_element+2);
      for i:=1 to nb_typ_element do begin
        s2:=trim(element[i].nom);
        s1:=lowercase(s2);
        if (length(s1) =2)then s2[2]:=s1[2];
        Cells[0,i+1]:=s2;
      end;
      Cells[0,1]:='Bonds';
      cells[0,0]:='BackGrd';
      refresh;
    end;
end;

procedure ecrit_panel2; //(boite  outils)
//---------------------------------------
var
  s             : string;
  s2,s1         : string[2];
  i             : integer;
begin
  with fdessin do begin
    if (flag_degrade =1)then checkBox5.state:=cbchecked else
    checkBox5.state:=cbunchecked;
    if (flag_sommets = 1)then checkBox3.state:=cbchecked else
    checkBox3.state:=cbunchecked;
    if (flag_label_centre =1) then checkBox4.checked:=true;
    if (flag_label_shift = 1) then checkBox7.checked:=true;
    str(epaisseur:6:2,s);
    edit5.text:=s;
    str(alfa:6:2,s);
    edit6.text:=s;

    //Eciture des symboles atomiques et des couleurs dans la grille
    with stringGrid1 do begin
      rowcount:=nb_typ_element+2;
      if (rowcount > 5)then height:=100 else height:=20*(nb_typ_element+2);
      for i:=1 to nb_typ_element do begin
       s2:=trim(element[i].nom);
       s1:=lowercase(s2);
       if (length(s1) =2)then s2[2]:=s1[2];
       Cells[0,i+1]:=s2;
      end;
      Cells[0,1]:='Bonds';
      cells[0,0]:='BackGrd';
    end;
    Listbox.ItemIndex:=probabilite-1;
  end;
end;

procedure calc_direction;
//---------------------
var
  rpqr                         : matrice3;
  pz,qz,rz                     : double;
  i,j,ier                      : integer;
begin
  pz:=child[no_atome_bond[2]].x-child[no_atome_bond[1]].x;
  qz:=child[no_atome_bond[2]].y-child[no_atome_bond[1]].y;
  rz:=child[no_atome_bond[2]].z-child[no_atome_bond[1]].z;
  for i:=1 to 3 do
  for j:=1 to 3 do begin
    r31[i,j]:=0;
    r13[i,j]:=0;
    rpqr[i,j]:=0;
  end;
  rpqr[3,1]:=pz;
  rpqr[3,2]:=qz;
  rpqr[3,3]:=rz;
  normd(pz,qz,rz);
  r31[3,1]:=pz;
  r31[3,2]:=qz;
  r31[3,3]:=rz;
  trfo(pz,qz,rz,r13[1,3],r13[2,3],r13[3,3],r10);
  calcmat(rpqr,ier);
  if (ier = 1)then exit;
  if (ier = 0)then begin
    conditionne_matrice;
    diagonalise;
    coefficients_contour; //Nouveaux coefficients du contour dans l'espace 3
    premier_dessin;
    dessine;
  end;
end;

procedure modif_liaison;
//---------------------
var
  i,j,n1,n2,ier : integer;
begin
  n1:=no_atome_bond[1];n2:=no_atome_bond[2];
  for i:=1 to nb_bonds do begin
    ier:=1;
    if ((bonds[i].atome1 = n1) and (bonds[i].atome2 = n2)) or
       ((bonds[i].atome1 = n2) and (bonds[i].atome2 = n1)) then begin
       if (i < nb_bonds)then for j:=i to nb_bonds-1 do bonds[j]:=bonds[j+1];
       nb_bonds:=nb_bonds-1;
       ier:=0;
       break;
    end;
  end;
  if (ier = 1)then begin
    nb_bonds:=nb_bonds+1;
    bonds[nb_bonds].atome1:=n1;
    bonds[nb_bonds].atome2:=n2;
  end;
  fdessin.panel12.caption:='To select a bond to Delete or add: '+
  'Click on the first atom (click with right button to end)';
  dessine;
end;

procedure calc_distance;
//----------------------
var
  d             : double;
  s             : string;
  i,j           : integer;
begin
  i:=no_atome_bond[1];j:=no_atome_bond[2];
  d:=sqrt(sqr(xstk[i]-xstk[j])+sqr(ystk[i]-ystk[j])+ sqr(zstk[i]-zstk[j]));
  str(d:7:3,s);
  fdessin.panel12.caption:='Distance '+child[i].nom+'-'+child[j].nom+' ='+s+
   ' (Click on the right button to end or click again on a first atom to continue)';
end;

procedure calc_angle;
//----------------------
var
  d1,d2,x1,x2,y1,y2,z1,z2,angle : double;
  s                             : string;
  i,j,k                         : integer;
begin
  i:=no_atome_angle[1];j:=no_atome_angle[2];k:=no_atome_angle[3];
  x1:=xstk[i]-xstk[j];y1:=ystk[i]-ystk[j];z1:=zstk[i]-zstk[j];
  x2:=xstk[k]-xstk[j];y2:=ystk[k]-ystk[j];z2:=zstk[k]-zstk[j];
  d1:=sqrt(sqr(x1)+sqr(y1)+ sqr(z1));
  d2:=sqrt(sqr(x2)+sqr(y2)+ sqr(z2));
  angle:=57.2957*arccos((x1*x2+y1*y2+z1*z2)/(d1*d2));
  str(angle:6:2,s);
  fdessin.panel12.caption:='Angle '+child[i].nom+'-'+child[j].nom+'-'+
  child[k].nom+' ='+s+' (Click right to stop)';
end;

procedure calc_plan;
//------------------
var
  rpqr                         : matrice3;
  v1,v2,v3                     : vecteur3;
  pz,qz,rz                     : double;
  i,j,ier                      : integer;
begin
  v1[1]:=child[no_atome_plan[2]].x-child[no_atome_plan[1]].x;
  v1[2]:=child[no_atome_plan[2]].y-child[no_atome_plan[1]].y;
  v1[3]:=child[no_atome_plan[2]].z-child[no_atome_plan[1]].z;
  v2[1]:=child[no_atome_plan[2]].x-child[no_atome_plan[3]].x;
  v2[2]:=child[no_atome_plan[2]].y-child[no_atome_plan[3]].y;
  v2[3]:=child[no_atome_plan[2]].z-child[no_atome_plan[3]].z;
  prodvec(v1,v2,v3);
  trfo3(v3,r20);
  pz:=v3[1];
  qz:=v3[2];
  rz:=v3[3];
  for i:=1 to 3 do
  for j:=1 to 3 do begin
    r31[i,j]:=0;
    r13[i,j]:=0;
    rpqr[i,j]:=0;
  end;
  rpqr[3,1]:=pz;
  rpqr[3,2]:=qz;
  rpqr[3,3]:=rz;
  normd(pz,qz,rz);
  r31[3,1]:=pz;
  r31[3,2]:=qz;
  r31[3,3]:=rz;
  trfo(pz,qz,rz,r13[1,3],r13[2,3],r13[3,3],r10);
  calcmat(rpqr,ier);
  if (ier = 1)then exit;
  if (ier = 0)then begin
    conditionne_matrice;
    diagonalise;
    coefficients_contour; //Nouveaux coefficients du contour dans l'espace 3
    premier_dessin;
    dessine;
  end;
end;

procedure trace_atomes_plans;
//--------------------------
var
  i,k,l,h           : integer;
  s                 : string;
begin
//On trace les noms des atomes slectionns
    dessine;
    with fdessin do begin
      for k:=1 to nb_plm do begin
        i:=no_plm[k];
        s:=child[i].nom;
        traite_nom_atome(s);
        s:=s+'('+inttostr(i)+')';
        fdessin.image1.canvas.font.size:=8;
        l:=fdessin.image1.canvas.textwidth(s) div 2;
        h:=fdessin.image1.canvas.textheight(s) div 2;
        fdessin.image1.canvas.brush.color:=clwhite;
        image1.Canvas.textout(ixo+round(xstk[i]*echelle)-l,
        iyo-round(ystk[i]*echelle)-h,s);
      end;
    end;
end;
