unit effaceB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ColorBtns, ExtCtrls, Grids;

type
  TfeffaceB = class(TForm)
    Panel4: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Color95Button4: TColor95Button;
    Edit1: TEdit;
    Edit2: TEdit;
    StringGrid2: TStringGrid;
    procedure efface_bloc(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure peint_stringgrid2(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  feffaceB: TfeffaceB;

implementation

uses oemath,paneau1;

{$R *.DFM}

procedure TfeffaceB.efface_bloc(Sender: TObject);
//--------------------------------------------
var
  atdel                           : array [1..5000] of ^atomes;
  i,n                             : integer;
  s                               : string;
  deb_effacement,fin_effacement   : integer;
  w                               : word;
begin
  if (edit1.text = '') or (edit2.text = '')then begin
    feffaceb.visible:=false;
    exit;
  end;
  s:=edit1.text;
  deb_effacement:=strtoint(s);
  s:=edit2.text;
  fin_effacement:=strtoint(s);
  if (deb_effacement > fin_effacement)then begin
    i:=deb_effacement;
    deb_effacement:=fin_effacement;
    fin_effacement:=i;
  end;

  //Message
  beep;
  s:='Are you sure to want to delete the atoms '+inttostr(deb_effacement)+' to '+
  inttostr(fin_effacement)+' ?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

  n:=0;
  for i:=1 to deb_effacement-1 do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=fin_effacement+1 to nb_motif do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  edit1.text:='';
  edit2.text:='';
  nb_motif:=n;
  ecrit_stringgrid2;
  //panel4.visible:=false;
  feffaceb.visible:=false;
end;

procedure TfeffaceB.initialise(Sender: TObject);
//------------------------------------------
var
   i                 : integer;
begin
   with stringgrid2 do begin
    rowcount:=nb_motif+2;
    for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
       cells[1,i]:='';
    end;
    cells[0,0]:='Nb';
    cells[1,0]:='Atom';
    for i:=1 to nb_motif do begin
       cells[0,i]:=inttostr(i);
       cells[1,i]:=motif[i].nom;
    end;
  end;
end;

procedure TfeffaceB.peint_stringgrid2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  s:=stringGrid2.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringGrid2.canvas.textWidth(s)) div 2;
  stringGrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

end.
