
procedure ellipsepr(num,rang_tracage : integer);{
----------------------------------------------}
{num = numro de l'atome dans la liste, rang_tracage rang de traage (cote z)}
var
   i,j,k,l,ix,iy,ier,nb_coupures                : integer;
   ro,xx1,yy1,distance,delta,den                : double;
   cs,sn,x31,y31,z31,x32,y32,z32,x4,y4,z4,rho,t : double;
   vp1,vp2,vp3,xnum,p,q,r,pp,qq,rr,xx,yy,zz     : double;
   coupure                                      : array[1..500] of boolean;
   r24,r34,r43                                  : matrice3;
   s                                            : string;

   tabxy                                        : array[1..51] of tpoint;
   x,y                                          : array[1..51] of integer;
   nb_point                                     : integer;
begin
  nb_coupures:=0;
  with TMetaFileCanvas.Create(MyMetaFile,0) do
    try
      draw(0,0,MyMetaFile);
      brush.color:=child[num].couleur;

//Contour
      for i:=1 to 51 do begin
        ro:=k4[num]/(k1[num]*co[i]*co[i]+k2[num]*si[i]*si[i]+k3[num]*co[i]*si[i]);
        ro:=sqrt(ro);
        xx:=ro*co[i];
        yy:=ro*si[i];
        xx:=xx+xstk[num];
        yy:=yy+ystk[num];
        ix:=round(xx*echelle+ixo);
        iy:=iyo-round(yy*echelle);
        tabxy[i]:=point(ix,iy);
      end;
      Polygon(tabxy);
      if (flag_degrade = 1) then degrade(num);

//Dessin des traces de plans principaux
      if(flag_plans =1) or (flag_axes = 1) then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do r24[i,j]:=vecteur_propre[num,i,j];
        end;
        mat_mult(r32,r24,r34);
        matinv(r34,r43,ier);
        vp1:=1/valeur_propre[num,1];
        vp2:=1/valeur_propre[num,2];
        vp3:=1/valeur_propre[num,3];

        {Axe OZ dans le repre 4 des vecteurs propres}
        x31:=0;
        y31:=0;
        z31:=1;
        trfo(x31,y31,z31,p,q,r,r43);

        xnum:=p*p/vp1+q*q/vp2+r*r/vp3;
        pp:=2*p/vp1;
        qq:=2*q/vp2;
        rr:=2*r/vp3;

        for j:=1 to 3 do begin
          nb_point:=0;
          for i:=1 to 51 do begin
            cs:=co[i];
            sn:=si[i];
            k:=j+1;
            if (k > 3) then k:=k-3;
            rho:=sqrt(1/((cs*cs*valeur_propre[num,j])+(sn*sn*valeur_propre[num,k])));
            {premier point}
            case j of
            1:begin
                x4:=rho*cs;
                y4:=rho*sn;
                z4:=0;
              end;
            2:begin
                y4:=rho*cs;
                z4:=rho*sn;
                x4:=0;
             end;
            3:begin
                z4:=rho*cs;
                x4:=rho*sn;
                y4:=0;
             end;
            end;
            trfo(x4,y4,z4,x31,y31,z31,r34);
            xx:=x31+xstk[num];
            yy:=y31+ystk[num];
            ix:=round(xx*echelle+ixo);
            iy:=iyo-round(yy*echelle);

         {deuxime point}
//Modif du 2 mars 2000----------------------------------------------------------
            den:=(pp*x4+qq*y4+rr*z4);
            if (abs(den) < 0.00001)then continue;
//------------------------------------------------------------------------------
            t:=xnum/den;
            x4:=x4+p*t;
            y4:=y4+q*t;
            z4:=z4+r*t;
            trfo(x4,y4,z4,x32,y32,z32,r34);
            if(z31 < z32)then begin
              nb_point:=nb_point+1;
              x[nb_point]:=round(xx*echelle+ixo);
              y[nb_point]:=iyo-round(yy*echelle);
              tabxy[nb_point]:=point(ix,iy);
              continue;
            end else begin;
              if (nb_point > 0)then begin
                x[nb_point]:=round(xx*echelle+ixo);
                y[nb_point]:=iyo-round(yy*echelle);
                tabxy[nb_point]:=point(ix,iy);
                polyline(slice(tabxy,nb_point));
                nb_point:=0;
              end;
            end;
          end;
          if (nb_point > 0)then polyline(slice(tabxy,nb_point));
        end;
      end;

//Trac des axes principaux
      if(flag_axes = 1) then begin
//Modif du 2 mars 2000 (Trac des plans et axes en isotrope)-------------------
//-----------------------------------------------------------------------------
        for i:=1 to 3 do begin
          case i of
          1:begin
               x4:=1/sqrt(valeur_propre[num,1]);
               y4:=0;
               z4:=0;
            end;
          2:begin
               y4:=1/sqrt(valeur_propre[num,2]);
               z4:=0;
               x4:=0;
            end;
          3:begin
              z4:=1/sqrt(valeur_propre[num,3]);
              x4:=0;
              y4:=0;
            end;
        end;
        ix:=round(xstk[num]*echelle+ixo);
        iy:=iyo-round(ystk[num]*echelle);
        trfo(x4,y4,z4,x31,y31,z31,r34);
        moveto(ix,iy);
        if(z31 < 0)then begin
           x31:=-x31;
           y31:=-y31;
        end;
        x32:=x31+xstk[num];
        y32:=y31+ystk[num];
        ix:=round(x32*echelle+ixo);
        iy:=iyo-round(y32*echelle);
        lineto(ix,iy);
      end;
    end;
//Trac des labels
    s:=child[num].nom;
    if ((flag_label_centre = 1) or (flag_label_shift = 1))
    {and (copy(s,1,2) <> 'H ')} then begin
       font.name:=font_name;
       font.style:=font_style;
       font.size:=font_size;
       font.color:=font_color;
       if (abs(child[num].dx) > 0) and (abs(child[num].dy) > 0) then begin
         brush.color:=coul_bkgrd;
       end else begin
         font.size:=7;
         font.name:='Times New Roman';
         font.style:=[];
         brush.color:=child[num].couleur;
       end;
       //ix:=round((xstk[num]-child[num].dx)*echelle+ixo);
       //iy:=iyo-round((ystk[num]-child[num].dy)*echelle);
       traite_nom_atome(s);
       //iy:=iy-(textheight(s) div 2);
       if (abs(child[num].dx) = 0) and (abs(child[num].dy) = 0) then begin
         while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
         s:=s+'('+intToStr(num)+')';
         //textout(ix-(textwidth(s) div 2),iy-5,s);
         //ix:=ix-(textwidth(s) div 2);
         //ecrit_transparent(ix,iy,s);
       end;
       // else  ecrit_transparent(ix,iy,s);;
    end;
   finally
     free;
   end;
end;

