unit fragment3;

interface
Uses
  SysUtils, WinTypes, WinProcs, Messages,StdCtrls, dialogs, math;

Procedure calc_fragment_child;
procedure reset_motif;

implementation
{R+}

uses
  oemath;

procedure reset_motif; //Restauration des atomes du child
//--------------------
begin
 (* for i:=1 to nb_motif_old do child[i]:=motif_old[i];
  nb_motif:=nb_motif_old; *)
end;

//Les atomes N1 et n2 de child sont-ils lis? si oui, no_op est > 0 et l'atome
//N2 est modifi par les translations dx,dy,dz

procedure distanceij(var atm1,atm2,atm : atomes; var ier: integer);
//-----------------------------------------------------------------
var
  el1,el2                                 : string;
  dmax,x1,y1,z1,x2,y2,z2,x3,y3,z3,
  x4,y4,z4,distance,dx,dy,dz              : double;
  i                                       : integer;
  ix,iy,iz,ipos                           : integer;
begin
    ier:=0;
//Identification des lments
    //el1:=copy(atm1.nom,1,2);traite_nom_element(el1);el1:=trim(el1);
    //el2:=copy(atm2.nom,1,2);traite_nom_element(el2);el2:=trim(el2);
    el1:=uppercase(trim(atm1.element));
    el2:=uppercase(trim(atm2.element));
//Recherche de la distance max entre ces lments
    dmax:=0;
    for i:= 1 to nb_typ_liai do begin
      if ((tableau_liai[i].atome1 = el1) and (tableau_liai[i].atome2 = el2)) or
      ((tableau_liai[i].atome2 = el1) and (tableau_liai[i].atome1 = el2)) then
      begin
        dmax:=sqr(tableau_liai[i].distance);
        break;
      end;
    end;
    if (dmax = 0)then exit;
//On cerche si les atomes sont lis en faisant des translations et oprations de symtrie
    x1:=atm1.x;
    y1:=atm1.y;
    z1:=atm1.z;
    x2:=atm2.x;
    y2:=atm2.y;
    z2:=atm2.z;
    for ix:=-4 to 4 do begin
      dx:=ix;
      for iy:=-4 to 4 do begin
        dy:=iy;
        for iz:=-4 to 4 do begin
          dz:=iz;
            x3:=x2+dx;
            y3:=y2+dy;
            z3:=z2+dz;
            x4:=x3-x1;
            y4:=y3-y1;
            z4:=z3-z1;
            trfo2(x4,y4,z4,r20);
            distance:=sqr(x4)+sqr(y4)+sqr(z4);
            if (distance <= dmax)then begin
              ier:=1;
              atm:=atm2;
              atm.x:=x3;
              atm.y:=y3;
              atm.z:=z3;
              exit;
          end;
        end;
      end;
    end;
end;

procedure calc_fragment_child;
//----------------------------
var
  fragm                                         : array[1..500,1..500] of ^atomes;
  pop                                           : array[1..1000] of integer;
  i,j,k,no_op,n,i_cour,nb_total                 : integer;
  atm1,atm2,atm3                                : atomes;
  xg,yg,zg,x1,y1,z1,dx,dy,dz,dist,dmin          : double;
  ix,iy,iz ,jx,jy,jz                            : integer;
  //nomf                                          : textfile;
begin
  nb_fragm:=0;
  nb_total:=0;

  //assignfile(nomf,'frg2.esp');
  //rewrite(nomf);
  //for i:=1 to nb_child do writeln(nomf,child[i].nom,child[i].beta[1]:8:5);
  //writeln(nomf);
  repeat

    nb_fragm:=nb_fragm+1;
    if (nb_fragm > 5000)then begin
      erreur('Too many generated atoms');
      exit;
    end;
    new(fragm[nb_fragm,1]);
    pop[nb_fragm]:=1;
    nb_total:=nb_total+1;
    for i:=1 to nb_child do begin
      if (child[i].nom <> '')then begin
        fragm[nb_fragm,1]^:=child[i];
        child[i].nom:='';
        break;
      end;
    end;
    i_cour:=1;

    //writeln(nomf,'nb_fragm:',nb_fragm:4);
    //writeln(nomf);
    //with fragm[nb_fragm,1]^ do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);

    repeat
      atm1:=fragm[nb_fragm,i_cour]^;

      //writeln(nomf,'i_cour:',i_cour:4);
      //with atm1 do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);

      for j:=1 to nb_child do begin
        if (child[j].nom = '')then continue;
        atm2:=child[j];
        distanceij(atm1,atm2,atm3,no_op);
        if (no_op = 0)then continue;
        pop[nb_fragm]:=pop[nb_fragm]+1;
        nb_total:=nb_total+1;
        if (nb_total > 5000)then begin
          erreur('Too many atoms');
          exit;
        end;
        new(fragm[nb_fragm,pop[nb_fragm]]);
        fragm[nb_fragm,pop[nb_fragm]]^:=atm3;

       // with child[j] do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);
       // with atm3 do writeln(nomf,nom:4,x:8:4,y:8:4,z:8:4);

        child[j].nom:='';
      end;
      i_cour:=i_cour+1;
    until i_cour>pop[nb_fragm];

  until nb_total = nb_child;

//recentrage des fragments
  for i:=1 to nb_fragm do begin
    xg:=0;yg:=0;zg:=0;
    for j:=1 to pop[i] do begin
      with fragm[i,j]^ do begin
        xg:=xg+x;
        yg:=yg+y;
        zg:=zg+z;
      end;
    end;
    xg:=xg/pop[i];
    yg:=yg/pop[i];
    zg:=zg/pop[i];
    dmin:=100000;
    dx:=0;dy:=0;dz:=0;
    for ix:=-4 to 4 do begin
      for iy:=-4 to 4 do begin
        for iz:=-4 to 4 do begin
          x1:=xg+ix-0.5;
          y1:=yg+iy-0.5;
          z1:=zg+iz-0.5;
          trfo2(x1,y1,z1,r20);
          dist:=sqr(x1)+sqr(y1)+sqr(z1);
          if (dist < dmin)then begin
            dmin:=dist;
            jx:=ix;
            jy:=iy;
            jz:=iz;
          end;
        end;
      end;
    end;
    for j:=1 to pop[i] do begin
      with fragm[i,j]^ do begin
        x:=x+jx;
        y:=y+jy;
        z:=z+jz;
      end;
    end;
  end;

//Les fragments sont remis dans child
  nb_child:=0;
  for i:=1 to nb_fragm do begin
    //writeln(nomf,'Fragment No:',i:4,coul_frag_name[i]);
    for j:=1 to pop[i] do begin
      nb_child:=nb_child+1;
      child[nb_child]:=fragm[i,j]^;
      child[nb_child].nbfrg:=i;
      dispose(fragm[i,j]);

      //writeln(nomf,child[nb_child].nom,child[nb_child].beta[1]:8:5);

    end;
  end;
  //closefile(nomf);

  //writeln(nomf,'atom nb ele couleur');
  for i:=1 to nb_child do begin
    with child[i] do begin
      if (nbfrg < 15)then couleur:=coul_frag[nbfrg] else couleur:=coul_frag[nbfrg-14];
      //write(nomf,nom);
      //if (length(nom) < 4)then for j:=length(nom)+1 to 4 do write(nomf,' ');
      //writeln(nomf,nbfrg:3,no_element:3,couleur:8,x:10:4,y:10:4,z:10:4);
      //writeln(nomf,nbfrg:3,no_element:3,coul_frag_name[nbfrg],y:10:4,z:10:4);
    end;
  end;

  //closefile(nomf);


end;

end.
