unit liaisons;

interface

Uses
  SysUtils, WinTypes,Controls, StdCtrls, dialogs, math;

procedure set_liaisons;

implementation

uses
  oemath;

procedure set_liaisons;
//----------------------
var
  i,j,k                                  : integer;
  xo1,yo1,zo1,xo2,yo2,zo2,d              : double;
  nomi,nomj                              : string[2];
  s                                      : string;
begin
  nb_bonds:=0;
  for i:=1 to nb_child-1 do begin
    xo1:=child[i].x;
    yo1:=child[i].y;
    zo1:=child[i].z;
    trfo2(xo1,yo1,zo1,r30);
    s:=child[i].element;
    nomi:=uptrim(s);
    for j:=i+1 to nb_child do begin
      if (child[i].part <> child[j].part)then continue;
      s:=child[j].element;
      nomj:=uptrim(s);
      for k:=1 to nb_typ_liai do begin
        if ((tableau_liai[k].atome1 = nomi) and (tableau_liai[k].atome2 = nomj))
        or ((tableau_liai[k].atome1 = nomj) and (tableau_liai[k].atome2 = nomi))
        then begin
          xo2:=child[j].x;
          yo2:=child[j].y;
          zo2:=child[j].z;
          trfo2(xo2,yo2,zo2,r30);
          d:=sqrt(sqr(xo1-xo2)+sqr(yo1-yo2)+sqr(zo1-zo2));
          if (d <= tableau_liai[k].distance) then begin
            nb_bonds:=nb_bonds+1;
            if (nb_bonds > 19999)then begin
              erreur('Too much bonds!');
              exit;
            end;
            with bonds[nb_bonds] do begin
              atome1:=i;
              atome2:=j;
              nature:=0;
              distance:=d;
              angle:=0;
              width:=epaisseur;
              couleur:=coul_liai;
              labell:='';
              dx:=0;
              dy:=0;
            end;
            if (nomi = 'C') and (nomj = 'C')then begin
              if (d > 1.439)then bonds[nb_bonds].nature:=0;
              if (d < 1.439) and (d > 1.271) then bonds[nb_bonds].nature:=1;
              if (d < 1.271) then bonds[nb_bonds].nature:=2;
            end;
            if (nomi = 'H') or (nomj = 'H') then bonds[nb_bonds].width:=epaisseur div 2;
          end;
        end;
      end;
    end;
  end;
end;

end.
