UNIT mainmenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls,printers, Buttons, Grids, ExtCtrls, ColorBtns, degradeur,
  checklst;

type
  Tfmainmenu = class(TForm)
    MainMenu1: TMainMenu;
    fichier1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Drawing: TMenuItem;
    SaveDialog1: TSaveDialog;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    Exit2: TMenuItem;
    Datakeybord1: TMenuItem;
    N2: TMenuItem;
    Panel1: TPanel;
    Color95Button9: TColor95Button;
    Panel4: TPanel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label2: TLabel;
    ListBox1: TListBox;
    Edit1: TEdit;
    edit2: TEdit;
    edit3: TEdit;
    edit4: TEdit;
    edit5: TEdit;
    edit6: TEdit;
    Panel3: TPanel;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    Color95Button1: TColor95Button;
    Color95Button2: TColor95Button;
    Label13: TLabel;
    Panel2: TPanel;
    Color95Button3: TColor95Button;
    Color95Button4: TColor95Button;
    Color95Button5: TColor95Button;
    Color95Button6: TColor95Button;
    Color95Button8: TColor95Button;
    Label5: TLabel;
    RadioGroup2: TRadioGroup;
    StringGrid2: TStringGrid;
    Color95Button7: TColor95Button;
    Panel5: TPanel;
    Label12: TLabel;
    Color95Button11: TColor95Button;
    Color95Button12: TColor95Button;
    Color95Button10: TColor95Button;
    Color95Button13: TColor95Button;
    Label3: TLabel;
    CheckListBox1: TCheckListBox;
    Load1: TMenuItem;
    Gretepfile1: TMenuItem;
    N1: TMenuItem;
    Shelxfileinputoroutput1: TMenuItem;
    Lazypulverixfile2: TMenuItem;
    Powdercellfile2: TMenuItem;
    Save1: TMenuItem;
    N4: TMenuItem;
    Shelxinputfile1: TMenuItem;
    Gretepfile2: TMenuItem;
    Panel6: TPanel;
    Label4: TLabel;
    ListBox3: TListBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Panel7: TPanel;
    ListBox2: TListBox;
    Label17: TLabel;
    BitBtn1: TBitBtn;
    Label16: TLabel;
    CIFfile1: TMenuItem;
    Label7: TLabel;
    CristallographicInformationFilecif1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Shekxformatshx1: TMenuItem;
    CrystallographicInformationFilecif1: TMenuItem;
    Panel8: TPanel;
    Color95Button14: TColor95Button;
    BitBtn2: TBitBtn;
    Label21: TLabel;
    RadioGroup1: TRadioGroup;
    Color95Button15: TColor95Button;
    PoudriX1: TMenuItem;
    procedure sortie(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure trace_ortep(Sender: TObject);
    procedure liaisons(Sender: TObject);
    procedure generer(Sender: TObject);
    procedure colore_fiche(Sender: TObject);
    procedure aide(Sender: TObject);
    procedure lit_shelx(Sender: TObject);
    procedure about(Sender: TObject);
    procedure data_keyboard(Sender: TObject);
    procedure lit_powder(Sender: TObject);
    procedure lit_lazy(Sender: TObject);
    procedure on_click_checklistbox(Sender: TObject);
    procedure click_groupe(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure selecte_tout(Sender: TObject);
    procedure deselecte_tut(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure on_click_stringgrid1(Sender: TObject);
    procedure on_select_cell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure peint_stringgrid2(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure verif_case(Sender: TObject);
    procedure set_numero(Sender: TObject);
    procedure modif_ligne(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure effaace_element(Sender: TObject);
    procedure efface_atome(Sender: TObject);
    procedure efface_bloc(Sender: TObject);
    procedure restaure(Sender: TObject);
    procedure edite_bond_lengths(Sender: TObject);
    procedure sauve_fichier_shelx(Sender: TObject);
    procedure selection_thermal_expression(Sender: TObject);
    procedure help_data(Sender: TObject);
    procedure generation_help(Sender: TObject);
    procedure affiche_child(Sender: TObject);
    procedure erase_tout(Sender: TObject);
    procedure lit_gretep(Sender: TObject);
    procedure clickpanel4(Sender: TObject);
    procedure init_active(Sender: TObject);
    procedure Gretepfile2Click(Sender: TObject);
    procedure click_groupe_getspec(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure lit_cif(Sender: TObject);
    procedure sauve_fichier_cif(Sender: TObject);
    procedure sauvegarde_data(Sender: TObject);
    procedure litdonneesclavier(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure click_stringgrid2(Sender: TObject);
    procedure Iso_aniso(Sender: TObject);
    procedure Calcul_brown(Sender: TObject);
    procedure modifie_stringgrid2(Sender: TObject; var Key: Char);
    procedure lit_fichier_poudrix(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

type
  tab_int  = array[1..12] of smallint;

var
  fmainmenu: Tfmainmenu;

procedure go_save_cif;

implementation

{$R *.DFM}
 uses
  oemath,  disp_posi, typliai, liaisons,fichiers,
  effaceE, fragment3, fragment2, sphere, dessin, apropos,  boite, paneau1,
  effaceA, effaceB, disp_coord2, licif2, formula, quel_bloc, get_sp, brown;
var
   nom_param :string;
  //mode_cif : string[20];


{---DLL GETSPEC-----------------------------------------------------------}
procedure getdll(var tabmes          : tab_mess);
                 far;stdcall;external 'getdll.dll' index 1;

{Item quit}
procedure reset_options;
//----------------------
begin
   //fdessin.radiogroup2.visible:=true;
   formule:='';
   fmainmenu.label7.visible:=false;
   groupe_espace:='';systeme:='';bravais:='';
   nom_fichier_grt:='';nom_fichier_shelx:='';nom_fichier_ascii:='';
   nb_child:=0;nbtrans:=0;npos_sel:=0;
   nb_typ_element:=0;nb_typ_liai:=0;nb_bonds:=0;
   titre:='';

//Reset flags generation
  flag_cut_boite:=0;flag_cut_sphere:=0;flag_contents:=0;
  flag_fragment:=0;flag_sphere:=0;flag_boite:=0;flag_modif_data:=0;
//reset flags dessin
  flag_sommets:=0;flag_plans:=0;flag_axes:=0;flag_distance:=0;
  flag_coupure:=0;flag_degrade:=0;flag_direction:=0;
  flag_angle:=0;flag_label_shift:=0;flag_fenetre_label:=0;
  flag_tlabel:=0;flag_label_centre:=0;flag_delete_label:=0;
  flag_noir_blanc:=0;flag_killbond:=0;flag_plan_moyen :=0;
  flag_tue_atome:=0;flag_coordinance:=0;flag_milieu:=0;
  flag_couleur_fragment:=0;flag_ecrit_labels_bond:=0;
  flag_kill_bonds:=0;

   x_arete:=1.01;y_arete:=1.01;z_arete:=1.01;
   rayon_sphere:=6;
   x_centre:=0.5;y_centre:=0.5;z_centre:=0.5;
   probabilite:=5;
   with fmainmenu.checklistbox1 do begin
     state[itemindex]:=cbunchecked;
     itemindex:=0;
     state[0]:=cbchecked;
   end;
   s_style:='Bold, Italic';
   s2_style:='Bold, Italic';
   font_color:=clblack;
   font_name:='Times New Roman';
   font_size:=12;
   font_style:=[fsbold];
   font2_color:=clblack;
   font2_name:='Times New Roman';
   font2_size:=12;
   font2_style:=[];
end;

procedure Tfmainmenu.sortie(Sender: TObject);{
--------------------------------------------}
begin
   close;
end;
(*FUNCTION SmallFonts : BOOLEAN;
{returns TRUE if  small fonts are set, FALSE if using Large Fonts }
VAR
  DC : HDC; { used to check for number of colors available }
BEGIN
  DC := GetDC(0);
  Result :=   (GetDeviceCaps(DC, LOGPIXELSX) = 96);
  { LOGPIXELSX will = 120 if large fonts are in use }
  ReleaseDC(0, DC);
END;*)


{Initialisation  la cration}
procedure Tfmainmenu.FormCreate(Sender: TObject);{
-------------------------------------------------}
var
   i    : integer;
   b    : boolean;
   nomf : textfile;
   s    :string;
const
  nom_fic : array[1..14] of string[25] =
  ('gretep.hlp','gretep.cnt','rayons.cst','getdll.dll','plan.dll','spgr2.dat',
  'spgr.peq','cubi.pos','hexa.pos','mono.pos','orth.pos','rhom.pos','tetr.pos',
  'tric.pos');
begin
   saute:=0;
   dim_du:=0.01;
   epaisseur:=6;
   couleur_du:=clred;
   s:=extractFilePath(Application.ExeName);
   repertoire_origine:=copy(s,1,length(s)-1);

//Teste la prsence des fichiers fixes
   for i:=1 to 14 do begin
     if (fileExists(repertoire_origine+'/'+nom_fic[i]) = false)then begin
       erreur('The file '+nom_fic[i]+' was not found!');
       close;
       halt;
    end;
   end;

// if (smallfonts = false) then
//erreur('Warning your system is using large fonts. This can affect the windows aspect!');
  chemin:='';
  if (height-clientHeight > 47)then
    erreur('Warning! Large fonts must create some problems to Gretep!');
  lambda:=0;
  nom_param:=paramstr(1);
  if (nom_param <> '')then begin
    if (fileExists(nom_param) = false)then begin
      erreur(nom_param+' not found');
      halt;
    end;
  end;

  checklistbox1.itemindex:=0;
  checklistbox1.state[0]:=cbchecked;
  coul_liai:=clyellow;
  coul_scalebar:=clblack;
  fmainmenu.top:=0;
  fmainmenu.left:=0;
  panel1.left:=1;
  panel1.top:=1;
  flag_couleur_fragment:=0;
  flag_kill_bonds:=0;

//------------------------------------------------------------------------------
  if (screen.width = 800)then begin
//------------------------------------------------------------------------------
  with fmainmenu do begin
    Left := 0;     Top := 0;    Width := 800;    Height := 595;
  end;
  with Label3 do begin
    Left := 352;     Top := 72;
  end;
  with Label13 do begin
    Left:=176;    Top:=40;
  end;
  with Panel1 do begin
    Left:=1;    Top:=1;    Width:=795;    Height:=545;
    HelpContext:=9
  end;
  with Color95Button9 do begin
      Left:=513;      Top:=68;      Width:=80;      Height:=30;
  end;
  with Panel4 do begin
      Left:=2;      Top:=2;      Width:=503;      Height:=168;
  end;
  with Label6 do begin
        Left:=56;        Top:=100;        Width:=9;        Height:=19;
  end;
  with Label8 do begin
        Left:=56;        Top:=120;        Width:=8;        Height:=19;
  end;
  with Label9 do begin
        Left:=56;        Top:=20;        Width:=7;        Height:=19;
  end;
  with Label10 do begin
        Left:=56;        Top:=40;        Width:=8;        Height:=19;
  end;
  with Label11 do begin
        Left:=56;        Top:=60;        Width:=7;        Height:=19;
  end;
  with Label14 do begin
        Left:=56;         Top:=80;        Width:=10;        Height:=19;
  end;
  with Label15 do begin
        Left:=11;        Top:=2;        Width:=52;        Height:=16;
  end;
  with Label2 do begin
        Left:=82;        Top:=2;        Width:=28 ;        Height:=16;
  end;
  with ListBox1 do begin
        Left:=2 ;        Top:=24;        Width:=50;        Height:=97;
  end;
  with Edit1 do begin
        Left:=70;        Top:=20;        Width:=50;        Height:=21;
  end;
  with edit2 do begin
        Left:=70;        Top:=40;        Width:=50;        Height:=21;
  end;
  with edit3 do begin
        Left:=70;         Top:=60;        Width:=50;        Height:=21;
  end;
  with edit4 do begin
        Left:=70 ;        Top:=80;        Width:=50;        Height:=21;
  end;
  with edit5 do begin
        Left:=70;        Top:=100;        Width:=50;        Height:=21;
  end;
  with edit6 do begin
        Left:=70;        Top:=120;        Width:=50;        Height:=21;
  end;
  with Panel7 do begin
        Left:=123;         Top:=2 ;        Width:=105;        Height:=161;
  end;
  with Label17 do begin
          Left:=2;          Top:=2;          Width:=100;          Height:=13;
  end;
  with Label16 do begin
          Left:=10;          Top:=16;          Width:=81;          Height:=13;
  end;
  with ListBox2 do begin
          Left:=19;          Top:=29;          Width:=70;          Height:=124;
          Font.Charset:=ANSI_CHARSET;
          Font.Color:=clBlack;
          Font.Height:=-11;
          Font.Name:='MS Sans Serif';
          Font.Style:=[] ;
          ItemHeight:=13;
  end;
  with Panel6 do begin
        Left:=233;
        Top:=panel7.top+panel4.top+1;        Width:=265;        Height:=161;
  end;
  with Label4 do begin
          Left:=83;          Top:=3;          Width:=138;          Height:=16;
  end;
  with Label18 do begin
          Left:=8;           Top:=24;          Width:=81;          Height:=13;
  end;
  with Label19 do begin
          Left:=112;          Top:=24 ;          Width:=18;          Height:=13;
  end;
  with Label20 do begin
          Left:=200;          Top:=24;          Width:=49;          Height:=13;
  end;
  with ListBox3 do begin
          Left:=8;           Top:=37;          Width:=249;          Height:=116;
          Font.Charset:=ANSI_CHARSET;
          Font.Color:=clBlack;
          Font.Height:=-11;
          Font.Name:='Courier New';
          Font.Style:=[];
          ItemHeight:=14;
  end;
  with BitBtn1 do begin
          Left:=8;           Top:=2;          Width:=57;          Height:=22;
  end;
  with Panel3 do begin
      Left:=558;       Top:=144 ;      Width:=230 ;      Height:=400;
  end;
  with Label1 do begin
        Left:=30;        Top:=4;        Width:=141;        Height:=16 ;
  end;
  with Color95Button1 do begin
        Left:=16;        Top:=374;        Width:=81;        Height:=20;
  end;
  with Color95Button2 do begin
        Left:=128;         Top:=374;        Width:=81;        Height:=20 ;
  end;
  with Label7 do begin
        Left:=4;        Top:=26;        Width:=145;        Height:=16;
        font.height:=-11;
  end;
  with Label21 do begin
        Left:=110;        Top:=26;        Width:=145;        Height:=16;
        font.height:=-11;
  end;
  with StringGrid1 do begin
        Left:=4;         Top:=49;        Width:=220 ;        Height:=320 ;
        DefaultColWidth := 45;
        DefaultRowHeight := 20;
  end;
  with Panel2 do begin
      Left:=2;       Top:=168 ;      Width:=555;      Height:=377;
  end;
  with Color95Button3 do begin
        Left:=30;        Top:=4;        Width:=30;        Height:=25;
  end;
  with Color95Button4 do begin
        Left:=120;        Top:=4;        Width:=30;        Height:=25;
  end;
  with Color95Button5 do begin
        Left:=60;        Top:=4;        Width:=30;        Height:=25;
  end;
  with Color95Button6 do begin
        Left:=90;        Top:=4;        Width:=30;        Height:=25;
  end;
  with Color95Button8 do begin
        Left:=150;        Top:=4;        Width:=30 ;        Height:=25 ;
  end;
  with Label5 do begin
        Left:=190;         Top:=30;        Width:=159;        Height:=16;
  end;
  with Color95Button7 do begin
        Left:=180;        Top:=4   ;        Width:=30;        Height:=25;
  end;
   with Color95Button12 do begin
        Left:=210;        Top:=4;        Width:=30;        Height:=25;
  end;
   with Color95Button15 do begin
        Left:=240;        Top:=4;        Width:=30;        Height:=25;
        caption:='C';
  end;
  with Color95Button13 do begin
        Left:=0;        Top:=4;        Width:=30;        Height:=25;
  end;
      with RadioGroup2 do begin
        Left:=344;        Top:=0 ;        Width:=185;        Height:=30;
  end;
  with StringGrid2 do begin
        Left:=3;        Top:=48;        Width:=545;        Height:=321;
        DefaultColWidth := 50;
        DefaultRowHeight := 20;
        Font.Charset:=ANSI_CHARSET;
        Font.Color:=clWindowText;
        Font.Height:=-11;
        Font.Name:='MS Serif';
        Font.Style:=[] ;
    end;
    with Panel5 do begin
      Left:=600;      Top:=-6 ;      Width:=187;      Height:=151;
    end;
    with Label12 do begin
        Left:=24;        Top:=35;        Width:=132;        Height:=16;
    end;
    with Color95Button11 do begin
        Left:=0;        Top:=8 ;        Width:=50;        Height:=25;
    end;
    with Color95Button10 do begin
        Left:=50;        Top:=8;        Width:=50;        Height:=25;
    end;
    with CheckListBox1 do begin
        Left:=40;        Top:=56;        Width:=121;        Height:=85;
    end;
    stringgrid2.colwidths[1]:=20 ;
    stringgrid2.colwidths[2]:=25 ;
    stringgrid2.colwidths[0]:=20 ;
    stringgrid1.colwidths[4]:=30 ;
    stringgrid1.colwidths[0]:=25 ;
    panel8.height:=30;
    panel8.height:=30;
    panel8.left:=0;panel8.width:=panel2.width;panel8.top:=panel1.height-panel8.Height;
//---------------------------------------------------------------------------
    end else begin
      stringgrid2.colwidths[0]:=18 ;
      stringgrid2.colwidths[1]:=30 ;
      stringgrid2.colwidths[2]:=28 ;
      stringgrid1.colwidths[4]:=25 ;
      stringgrid1.colwidths[0]:=15 ;
    end;
//------------------------------------------------------------------------------
  col_err:=-1;row_err:=-1;
  //GetDir(0,repertoire_origine);{ 0 = Current drive }
  px_cm:=117.66;
  for i:=1 to nb_child do begin
    with child[i] do begin
      trace:=1;
      dx:=0;
      dy:=0;
    end;
  end;

  nomstruc:='';
  fmainmenu.color:=$FFEAD8;
  Application.HelpFile:=repertoire_origine+'\gretep.hlp';
  reset_options;
  shunte_init:=0;
end;

procedure Tfmainmenu.trace_ortep(Sender: TObject);
//------------------------------------------------
var
  i,ier : integer;
  x     : real;
  nomf  : textfile;
begin
 if (fdessin.WindowState = WsMinimized)then begin
   fdessin.WindowState := WsNormal;
   exit;
 end;
 if (groupe_espace = '')then begin
   erreur('No space_group');
   exit;
 end;
 if (nom_param <> '')then begin
   if (fileExists(nom_param) = false)then begin
     erreur(nom_param+' not found');
     halt;
   end;
   lit_gretep(sender);
   exit;
 end;

 if (nb_motif = 0)then exit;
 if (flag_modif_data = 0)then begin
   for i:=1 to nb_child do begin
     child[i].trace:=1;
     child_old[i]:=child[i];
   end;
   nb_child_old:=nb_child;
   fdessin.visible:=true;
   exit;
 end;

//Maille
  if (modif_cell = 1)then begin
    relit_maille(ier);
    x:=1;
    for i:=1 to 6 do x:=x*cel[i];
    if (x = 0)then begin
      erreur('No cell parameters');
      exit;
    end;
    if (ier > 0)then exit;
    setmat;
  end;

//Positions
  relit_positions_selectionnees;

//Coordonnes
  relit_stringgrid2(ier);
  if (ier > 0)then begin
      beep;
      erreur('Coordinates read error');
      exit;
  end;
  if (nb_motif = 0)then begin
      erreur('No coordinates!');
      exit;
  end;
  if (modif_coord =1)then begin
    set_typ_liaisons;
  end;

//Gnration
  generer(sender);
  if (nb_child = 0)then begin
    beep;
    erreur('No data');
    exit;
  end;

//Dessin
  modif_coord:=0;
  modif_cell:=0;
  nom_fichier_sortie:='dummy.gre';
  ecrit_fichier_ascii;
//  fmainmenu.hide;
  fdessin.visible:=true;
end;

procedure Tfmainmenu.liaisons(Sender: TObject);
//--------------------------------------------
begin
 ftypliai.visible:=true;
 if (fboite.visible = true) then fboite.visible:=false;
end;

procedure calcul_boite;
//---------------------
var
  xx,yy,zz                                      : double;
  ier,i,j,k,m,l,n,nb_at,dx1,dx2,dy1,dy2,dz1,dz2 : integer;
  nb_at_old                                     : integer;
  boite                                         : array[1..10000] of ^atomes;
  s4                                            : string[4];
  x_mini,y_mini,z_mini,x_maxi,y_maxi,z_maxi     : double;
  nomf                                          : textfile;
begin

//On met toutes les coordonnes dans la maille lementaire
  if (flag_cut_boite = 1) then begin
    for i:=1 to nb_child do begin
      with child[i] do begin
        x:=x-trunc(x);
        if(x < 0.0) then x:=x+1;
        y:=y-trunc(y);
        if(y < 0.0) then y:=y+1;
        z:=z-trunc(z);
        if(z < 0.0) then z:=z+1;
      end;
    end;
  end;
  x_mini:=x_centre-x_arete/2;y_mini:=y_centre-y_arete/2;z_mini:=z_centre-z_arete/2;
  x_maxi:=x_centre+x_arete/2;y_maxi:=y_centre+y_arete/2;z_maxi:=z_centre+z_arete/2;
  dx1:=round(x_mini)-1;
  dy1:=round(y_mini)-1;
  dz1:=round(z_mini)-1;
  dx2:=round(x_maxi)+1;
  dy2:=round(y_maxi)+1;
  dz2:=round(z_maxi)+1;
  nb_at:=0;
//==============================================================================
if (flag_cut_boite = 1)then begin
  for n:=1 to nb_child do begin
    for i:=dx1 to dx2 do begin
      xx:=child[n].x+i;
      if(xx < x_mini) or (xx > x_maxi) then continue;

      for j:=dy1 to dy2 do begin
        yy:=child[n].y+j;
        if(yy < y_mini) or (yy > y_maxi) then continue;
        //@@@@@@@@@@@
        if (flag_contents = 1) and (systeme = 'HEXA')
        and (abs(xx-yy) > 1.001)then continue;
        //@@@@@@@@@@@
        for k:= dz1 to dz2 do begin
          zz:=child[n].z+k;
          if(zz < z_mini) or (zz > z_maxi) then continue;
          nb_at:=nb_at+1;
          new(boite[nb_at]);
          boite[nb_at]^:=child[n];
          with boite[nb_at]^ do begin
            x:=xx;
            y:=yy;
            z:=zz;
          end;
        end;
      end;
    end;
  end;
end;
//=============================================================================
  if (flag_cut_boite = 0)then begin
 (*assignFile(nomf,'coord');
  rewrite(nomf);
  for i:=1 to nb_child do begin
    with child[i] do begin
      writeln(nomf,nom:4,'  ',element:2,labell:4,nbfrg:5,x:8:4,y:10:4,z:10:4,beta[1]:8:5,beta[2]:8:5,
      beta[3]:8:5,beta[4]:8:5,beta[5]:8:5,beta[6]:8:5);
    end;
  end;
  closefile(nomf);*)
    for i:=dx1 to dx2 do begin
      for j:=dy1 to dy2 do begin
        for k:= dz1 to dz2 do begin
          for n:=1 to nb_fragm do begin
            nb_at_old:=nb_at;
            ier:=1;
            for l:=1 to nb_child do begin //On cherche tous les atomes du fragment
              if (child[l].nbfrg <> n)then continue;
              xx:=child[l].x+i;
              yy:=child[l].y+j;
              zz:=child[l].z+k;
              if  (xx >= x_mini) and (xx <= x_maxi)
              and (yy >= y_mini) and (yy <= y_maxi)
              and (zz >= z_mini) and (zz <= z_maxi)then ier:=0;
              nb_at:=nb_at+1;
              new(boite[nb_at]);
              boite[nb_at]^:=child[l];
              with boite[nb_at]^ do begin
                x:=xx;
                y:=yy;
                z:=zz;
              end;
            end;
           if (ier = 1) and (nb_at  > 1)then begin
             for l:=nb_at_old+1 to nb_at do dispose(boite[l]);
             nb_at:=nb_at_old;
           end;
        end;
      end;
    end;
  end;
end;
//===========================================================================
  {Marquage des doubles}
  for i:=1 to nb_at-1 do begin
    if(boite[i]^.nom = '')then continue;
    for j:=i+1 to nb_at do begin
      if (abs(boite[i]^.x-boite[j]^.x) < 0.0001) and
         (abs(boite[i]^.y-boite[j]^.y) < 0.0001) and
         (abs(boite[i]^.z-boite[j]^.z) < 0.0001) then boite[j].nom:='';
    end;
  end;

//On remet les sites slectionns dans le tableau atg
  nb_child:=0;
  for i:=1 to nb_at do begin
    if (boite[i]^.nom = '')then continue;
    nb_child:=nb_child+1;
    if (nb_child > 4999)then begin
      erreur('Too many generated atoms');
      for j:=1 to nb_at do dispose(boite[j]);
      exit;
    end;
    child[nb_child]:=boite[i]^;
  end;
  for i:=1 to nb_at do dispose(boite[i]);

end;

procedure calcul_sphere;
//---------------------
var
  xx,yy,zz,x0,y0,z0,x2,y2,z2,rayon_carre,dist   : double;
  i,j,k,m,n,nb_at,dx1,dy1,dz1                   : integer;
  l,ier,nb_at_old                               : integer;
  boite                                         : array[1..5000] of ^atomes;
  s4                                            : string[4];
begin
//On met toutes les coordonnes dans la maille lementaire
  if (flag_cut_sphere = 1) then begin
    for i:=1 to nb_child do begin
      with child[i] do begin
        x:=x-trunc(x);
        if(x < 0.0) then x:=x+1;
        y:=y-trunc(y);
        if(y < 0.0) then y:=y+1;
        z:=z-trunc(z);
        if(z < 0.0) then z:=z+1;
      end;
    end;
  end;
  dx1:=round(rayon_sphere/cel[1])+1;
  dy1:=round(rayon_sphere/cel[2])+1;
  dz1:=round(rayon_sphere/cel[3])+1;
  nb_at:=0;
  rayon_carre:=sqr(rayon_sphere);
  if (flag_cut_sphere = 0) then begin
    for i:=-dx1 to dx1 do begin
      for j:=-dy1 to dy1 do begin
        for k:= -dz1 to dz1 do begin
          for n:=1 to nb_fragm do begin
             ier:=1;
             nb_at_old:=nb_at;
             for l:=1 to nb_child do begin
               if (child[l].nbfrg <> n)then continue;
               x0:=child[l].x+i;
               xx:=x0-x_centre;
               y0:=child[l].y+j;
               yy:=y0-y_centre;
               z0:=child[l].z+k;
               zz:=z0-z_centre;
               trfo(xx,yy,zz,x2,y2,z2,r30);
               dist:=sqr(x2)+sqr(y2)+sqr(z2);
               if (dist < rayon_carre)then begin
                 ier:=0;
                 //break;
               end;
               nb_at:=nb_at+1;
               new(boite[nb_at]);
               boite[nb_at]^:=child[l];
               with boite[nb_at]^ do begin
                x:=x0;
                y:=y0;
                z:=z0;
               end;
              //if (ier = 1)then break;
             end;
             if (ier =1)then begin
               for l:=nb_at_old+1 to nb_at do dispose(boite[l]);
               nb_at:=nb_at_old;
             end;
          end;
        end;
      end;
    end;
  end;
  if (flag_cut_sphere = 1) then begin
    for i:=-dx1 to dx1 do begin
      for j:=-dy1 to dy1 do begin
        for k:= -dz1 to dz1 do begin
           for l:=1 to nb_child do begin
             x0:=child[l].x+i;
             xx:=x0-x_centre;
             y0:=child[l].y+j;
             yy:=y0-y_centre;
             z0:=child[l].z+k;
             zz:=z0-z_centre;
             trfo(xx,yy,zz,x2,y2,z2,r30);
             dist:=sqr(x2)+sqr(y2)+sqr(z2);
             if (dist <= rayon_carre)then begin
               nb_at:=nb_at+1;
               new(boite[nb_at]);
               boite[nb_at]^:=child[l];
               with boite[nb_at]^ do begin
                x:=x0;
                y:=y0;
                z:=z0;
               end;
             end;
          end;
        end;
      end;
    end;
  end;

  {Marquage des doubles}
  for i:=1 to nb_at-1 do begin
    if(boite[i]^.nom = '')then continue;
    for j:=i+1 to nb_at do begin
      if (abs(boite[i]^.x-boite[j]^.x) < 0.0001) and
         (abs(boite[i]^.y-boite[j]^.y) < 0.0001) and
         (abs(boite[i]^.z-boite[j]^.z) < 0.0001) then boite[j].nom:='';
    end;
  end;

  {On remet les sites slectionns dans le tableau atg}
  nb_child:=0;
  for i:=1 to nb_at do begin
    if (boite[i]^.nom = '')then continue;
    nb_child:=nb_child+1;
    if (nb_child > 4999)then begin
      erreur('Too many generated atoms');
      for j:=1 to nb_at do dispose(boite[j]);
      exit;
    end;
    child[nb_child]:=boite[i]^;
  end;
  for i:=1 to nb_at do dispose(boite[i]);

end;

procedure Tfmainmenu.generer(Sender: TObject);
//-------------------------------------------
var
  s2                                                    : string[2];
  s                                                     : string;
  xx,yy,zz,depi2,som,u_iso                              : double;
  ier,i,j,k,l                                           : integer;
  r,r_trans,bet,aux                                     : matrice3;
  nomf                                                  : TextFile;
  u,v                                                   : array[1..6] of double;
  mol                                                   : array[1..5000] of ^atomes;
  x1,y1,z1,x2,y2,z2,xg,yg,zg,dmax,distance,dx,dy,dz     : double;
  nb_mol,ix,iy,iz                                       : integer;
  mat,mat_inv,r12t                                      : matrice3;
begin

//Mise en reserve du motif asymtrique
  for i:=1 to nb_motif do begin
    motif_old[i]:=motif[i];
  end;

  nb_child:=0;
  if (nb_motif = 0)then exit;
  depi2:=2.*3.14159*3.14159;
  v[1]:=depi2*celr[1]*celr[1];
  v[2]:=depi2*celr[2]*celr[2];
  v[3]:=depi2*celr[3]*celr[3];
  v[4]:=depi2*celr[1]*celr[2]*cos(celr[6]/57.2957);
  v[5]:=depi2*celr[1]*celr[3]*cos(celr[5]/57.2957);
  v[6]:=depi2*celr[2]*celr[3]*cos(celr[4]/57.2957);
  u[1]:=depi2*celr[1]*celr[1];
  u[2]:=depi2*celr[2]*celr[2];
  u[3]:=depi2*celr[3]*celr[3];
  u[4]:=depi2*celr[1]*celr[2];
  u[5]:=depi2*celr[1]*celr[3];
  u[6]:=depi2*celr[2]*celr[3];
  screen.cursor:=crhourglass;

//-------------------------------------------------------------------------------
//18 mai 2001 Test des paramtres thermiques conduisant  une matrice non inversible
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      r12t[j,i]:=r12[i,j];
    end;
  end;
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      if (iso > 0)then continue;
      bet[1,1]:=beta[1]*u[1];
      bet[2,2]:=beta[2]*u[2];
      bet[3,3]:=beta[3]*u[3];
      bet[1,2]:=beta[4]*u[4];
      bet[1,3]:=beta[5]*u[5];
      bet[2,3]:=beta[6]*u[6];
      bet[2,1]:=bet[1,2];
      bet[3,1]:=bet[1,3];
      bet[3,2]:=bet[2,3];
      mat_mult(bet,r12,aux);
      mat_mult(r12t,aux,mat);
      matinv(mat,mat_inv,ier);
      if (ier > 0)then begin
         for j:=1 to 6 do beta[j]:=0;
         u_iso:=(bet[1,1]+bet[2,2]+bet[3,3])/3;
         beta[1]:=u_iso;
         beep;
         str(u_iso:6:4,s);
         erreur ('Atom '+nom+' has a non definite positive matrix Uij. Ueq was reset to '+s);
         iso:=1;
      end;
    end;
  end;
//-------------------------------------------------------------------------------

  if (flag_fragment = 1) or (flag_boite = 1) or (flag_sphere = 1) then
  calc_fragment_motif;
  nb_mol:=0;
  for i:=1 to npos_sel do begin
    for j:=1 to nb_motif do begin
      nb_mol:=nb_mol+1;
      new(mol[nb_mol]);
      mol[nb_mol]^:=motif[j];
      mol[nb_mol]^.nbfrg:=i;
      with motif[j] do begin
        mol[nb_mol].x:=
        tp_sel[i,1,4]+x*tp_sel[i,1,1]+y*tp_sel[i,1,2]+z*tp_sel[i,1,3];
        mol[nb_mol]^.y:=
        tp_sel[i,2,4]+x*tp_sel[i,2,1]+y*tp_sel[i,2,2]+z*tp_sel[i,2,3];
        mol[nb_mol]^.z:=
        tp_sel[i,3,4]+x*tp_sel[i,3,1]+y*tp_sel[i,3,2]+z*tp_sel[i,3,3];
        mol[nb_mol]^.no_element:=no_element;
      end;
//Passage des uij aux bij
      with mol[nb_mol]^ do begin
        s:=element;
        s2:=uptrim(s);
        if (s2 = 'H')then beta[2]:=0;
        if (beta[2] = 0) then begin
          if (s2 = 'H')then xx:=0.01 else xx:=beta[1];
          bet[1,1]:=xx*v[1];
          bet[2,2]:=xx*v[2];
          bet[3,3]:=xx*v[3];
          bet[1,2]:=xx*v[4];
          bet[1,3]:=xx*v[5];
          bet[2,3]:=xx*v[6];
          iso:=1;
        end else begin
          bet[1,1]:=beta[1]*u[1];
          bet[2,2]:=beta[2]*u[2];
          bet[3,3]:=beta[3]*u[3];
          bet[1,2]:=beta[4]*u[4];
          bet[1,3]:=beta[5]*u[5];
          bet[2,3]:=beta[6]*u[6];
          iso:=0;
        end;
        bet[2,1]:=bet[1,2];
        bet[3,1]:=bet[1,3];
        bet[3,2]:=bet[2,3];

//Test matrice non definie positive
        if (bet[1,1]*bet[2,2]-sqr(bet[1,2]) < 0)or
           (bet[1,1]*bet[3,3]-sqr(bet[1,3]) < 0)or
           (bet[3,3]*bet[2,2]-sqr(bet[2,3]) < 0)or
           (bet[1,1]*bet[2,2]*bet[3,3]+2*bet[1,2]*bet[1,3]*bet[2,3]-
           bet[1,1]*bet[2,3]*bet[2,3]-
           bet[2,2]*bet[1,3]*bet[1,3]-
           bet[3,3]*bet[1,2]*bet[1,2]        < 0)then
             erreur('Non definite positive matrix on atom '+ mol[nb_mol]^.nom);
      end;

//Transformation des Betij par les oprateurs de symtrie
      for l:=1 to 3 do begin
        for k:=1 to 3 do begin
          r[l,k]:=tp_sel[i,l,k];
          r_trans[k,l]:=r[l,k];
        end;
      end;
      mat_mult(bet,r_trans,aux);
      mat_mult(r,aux,bet);
      with mol [nb_mol]^ do begin
        beta[1]:=bet[1,1];
        beta[2]:=bet[2,2];
        beta[3]:=bet[3,3];
        beta[4]:=bet[1,2];
        beta[5]:=bet[1,3];
        beta[6]:=bet[2,3];
      end;
    end;
  end;

//Elimination des doubles dus aux atomes situs sur un lment de symtrie
  if (nb_mol> 1) then begin
    for i:=1 to nb_mol-1 do begin
      if (mol[i]^.nom = '')then continue;
      ier:=0;
      for j:=i+1 to nb_mol do begin
        x1:=mol[i]^.x;
        y1:=mol[i]^.y;
        z1:=mol[i]^.z;
        x2:=mol[j]^.x;
        y2:=mol[j]^.y;
        z2:=mol[j]^.z;
        x1:=x1-trunc(x1);
        y1:=y1-trunc(y1);
        z1:=z1-trunc(z1);
        x2:=x2-trunc(x2);
        y2:=y2-trunc(y2);
        z2:=z2-trunc(z2);
        if (x1 < 0)then x1:=x1+1;
        if (y1 < 0)then y1:=y1+1;
        if (z1 < 0)then z1:=z1+1;
        if (x2 < 0)then x2:=x2+1;
        if (y2 < 0)then y2:=y2+1;
        if (z2 < 0)then z2:=z2+1;
        xx:=abs(x2-x1);
        yy:=abs(y2-y1);
        zz:=abs(z2-z1);
        som:= xx+yy+zz;
        if (som < 0.0001) then begin
          ier:=1;
          mol[j]^.nom:='';
          mol[j]^.element:='';
          mol[j]^.labell:='';
          mol[j]^.nbfrg:=0;
          continue;
        end;
      end;
    end;
  end;
  nb_child:=0;
  for i:=1 to nb_mol do begin
    if (mol[i]^.nom = '')or (mol[i]^.nbfrg = 0) then continue;
    nb_child:=nb_child+1;
    child[nb_child]:=mol[i]^;
    dispose(mol[i]);
  end;
  if (flag_fragment = 1) or (flag_boite = 1) or (flag_sphere = 1) then
  calc_fragment_child;
//*********************************(i)****************************************

  for i:=1 to nb_child do begin
    child[i].trace:=1;
    child[i].tlabel:=1;
    child_old[i]:=child[i];
  end;
  nb_child_old:=nb_child;
  if (flag_boite = 1) then calcul_boite;
  if (flag_sphere = 1) then calcul_sphere;
  if (flag_contents = 1)then calcul_boite;

//rcupration du motif asymetrique
  for i:=1 to nb_motif do motif[i]:=motif_old[i];
  for i:=1 to nb_child do begin
    child_old[i]:=child[i];
    slabel[i]:=child[i].element+child[i].labell;
  end;
  nb_child_old:=nb_child;
  set_liaisons;
  screen.cursor:=crdefault;
end;

procedure Tfmainmenu.colore_fiche(Sender: TObject);
//------------------------------------------------
var
 i1,i2    : integer;
 FDegrade : TDegradeClass;
begin
    FDegrade:=TDegradeClass.Create;
    i1:=$ff0000;
    i2:=$FFDAD0;
    fdegrade.Graduate(self,i1,i2);
end;

procedure Tfmainmenu.aide(Sender: TObject);
//-----------------------------------------
begin
   chdir(repertoire_origine);
   Application.HelpFile:=repertoire_origine+'\gretep.hlp';
   Application.HelpContext(7);
end;

procedure Tfmainmenu.about(Sender: TObject);
//-----------------------------------------
begin
  fabout.visible:=true;
end;

procedure change_colorbuttons;
//---------------------------
begin
with fmainmenu do begin
    stringgrid2.height:=438;
    panel8.visible:=true;
    panel5.visible:=false;
    panel3.visible:=false;
    color95button3.visible:=false;
    color95button9.visible:=false;
    color95button4.visible:=false;
    color95button5.visible:=false;
    color95button6.visible:=false;
    color95button7.visible:=false;
    color95button8.visible:=false;
    color95button12.visible:=false;
    color95button13.visible:=false;
    panel2.color:=clsilver;
    stringGrid2.fixedcolor:=clsilver;
    label5.caption:='Enter the asymetric unit contents';
  end;
end;

procedure remet_colorbuttons;
//---------------------------
begin
  with fmainmenu do begin
    panel8.visible:=false;
    panel5.visible:=true;
    panel3.visible:=true;
    color95button3.visible:=true;
    color95button9.visible:=true;
    color95button4.visible:=true;
    color95button5.visible:=true;
    color95button6.visible:=true;
    color95button7.visible:=true;
    color95button8.visible:=true;
    color95button12.visible:=true;
    color95button13.visible:=true;
    panel2.color:=$00FFDEB4;
    stringGrid2.fixedcolor:=$00FFDEB4;
    label5.caption:='Asymetric unit contents';
    stringgrid2.height:=473;
  end;
end;

procedure Tfmainmenu.data_keyboard(Sender: TObject);
//--------------------------------------------------
begin
  //change_colorbuttons;
  panel4.visible:=true;
  panel2.visible:=false;
  panel8.visible:=false;
  nom_fichier_grt:='';nom_fichier_shelx:='';nom_fichier_ascii:='';
  nb_motif:=0;nom_fichier_shelx:='';nom_fichier_grt:='';
  npos:=0;npos_sel:=0;
  reset_options;
  with fdessin do begin
     checkbox1.state:=cbunchecked;
     checkbox2.state:=cbunchecked;
     checkbox1.state:=cbunchecked;
     checkbox3.state:=cbunchecked;
     checkbox4.state:=cbunchecked;
     checkbox5.state:=cbunchecked;
     checkbox6.state:=cbunchecked;
     checkbox7.state:=cbunchecked;
     checklistbox1.itemindex:=0;
     checklistbox1.state[0]:=cbchecked;
  end;
  clear_stringgrid2;
  panel1.visible:=true;
  flag_modif_data:=1;
end;

//------------------------------------------------------------------------------
//Lecture du fichier d'entre
//------------------------------------------------------------------------------

//Format Gretep
procedure Tfmainmenu.lit_gretep(Sender: TObject);
//--------------------------------------------------
var
  s         : string;
  i,j       : integer;
begin
  OpenDialog1.FilterIndex:=5;
  openDialog1.InitialDir:='';
  if (nom_param <> '') then begin
    nom_fichier_ascii:=nom_param;
    nom_param:='';
  end else if OpenDialog1.Execute then begin
    s:=OpenDialog1.FileName;
    if (s = '')then exit;
    fbrown.memo2.Clear;
    reset_options;
    for i:=1 to 192 do selected[i]:=0;
    nom_fichier_ascii:=s;
  end else exit;

  screen.cursor:=crhourglass;
  teste_fichier_unix(nom_fichier_ascii);
  screen.cursor:=crdefault;

  lit_fichier_ascii;
//Test des atomes portant le mme nom
    for i:=1 to nb_motif-1 do begin
       for j:=i+1 to nb_motif do begin
         if (motif[i].nom = motif[j].nom) then begin
           erreur ('The atom Nb'+inttostr(i)+'('+motif[j].nom+') has the same name as the atom Nb'+
           inttostr(j)+'('+motif[j].nom+')');
           exit;
         end;
       end;
    end;

    radiogroup2.ItemIndex:=0;
    for i:=0 to 4 do checklistbox1.state[i]:=cbunchecked;
    if (flag_contents = 1)then checklistbox1.ItemIndex:=4;
    if (flag_fragment = 1)then checklistbox1.ItemIndex:=3;
    if (flag_sphere = 1)then checklistbox1.ItemIndex:=2;
    if (flag_boite = 1)then checklistbox1.ItemIndex:=1;
    checklistbox1.state[checklistbox1.ItemIndex]:=cbchecked;
    with fdessin do begin
      if (flag_plans = 1)then checkbox1.state:=cbchecked
      else checkbox1.state:=cbunchecked;
      if (flag_axes = 1)then checkbox2.state:=cbchecked
      else checkbox2.state:=cbunchecked;
      if (flag_sommets = 1)then checkbox3.state:=cbchecked
      else checkbox3.state:=cbunchecked;
      if (flag_degrade = 1)then checkbox5.state:=cbchecked
      else checkbox5.state:=cbunchecked;
      if (flag_label_shift =1)then checkbox7.state:=cbchecked
      else checkbox7.state:=cbunchecked;
      if (flag_label_centre =1)then checkbox4.state:=cbchecked
      else checkbox4.state:=cbunchecked;
//      if (flag_ecrit_labels_bond =1)then checkbox9.state:=cbchecked
//      else checkbox9.state:=cbunchecked;
      if (flag_noir_blanc =1)then checkbox6.state:=cbchecked
      else checkbox6.state:=cbunchecked;
//Ecriture des labels bonds
      if (flag_ecrit_labels_bond = 1)then begin
        saute:=1;
        checkbox9.checked:=true;

        flag_ecrit_labels_bond:=0;
        saute:=0;
      end else checkbox9.checked:=false;

      str((epaisseur*0.01):6:2,s);
      edit5.text:=s;
      trackbar1.position:=round(epaisseur);
      str(alfa:6:2,s);
      edit6.text:=s;
      trackbar2.position:=round(alfa/2);
      listbox.itemindex:=probabilite-1;
      flag_label_centre:=0;
      flag_label_shift:=0;
      for i:=1 to nb_child do begin
        if(child[i].dx <> 0) or (child[i].dy <> 0)then begin
          checkbox7.state:=cbchecked;
          break;
        end;
      end;
      for i:=1 to nb_bonds do begin
        if(bonds[i].dx <> 0) or (bonds[i].dy <> 0)then begin
          saute:=1;
          checkbox9.state:=cbchecked;
          saute:=0;
          break;
        end;
      end;
    end;
    for i:=1 to nb_child do child_old[i]:=child[i];
    nb_child_old:=nb_child;
    label7.visible:=true;
    if (groupe_espace = '')then label7.caption:='No Space Group found'
    else label7.caption:='Space Group: '+groupe_espace;
    panel1.visible:=true;
    ecrit_panel1;
    if (fboite.visible = true) then fboite.visible:=false;
    fdessin.visible:=true;

end;

procedure verif_positions;
//------------------------
var
  i,j,k,n            : integer;
  s                  : string;
  sp                 : array[1..192] of string[24];
  tpp                : array[1..192,1..3,1..4]of double;
  v4                 : vecteur4;
  nomf:textfile;
begin
     chdir(repertoire_origine);
     assignfile(nomf,'espion_pos.txt');
     rewrite(nomf);
     writeln(nomf,'npos=',npos);
     for i:=1 to npos do writeln(nomf,i:4,' ',s_pos[i]);
     writeln(nomf);

//Suppression des translations > 1 ou ngatives
     for i:=1 to npos do begin
           if (tp[i,1,4] >= 1)then tp[i,1,4]:=tp[i,1,4]-1;
           if (tp[i,2,4] >= 1)then tp[i,2,4]:=tp[i,2,4]-1;
           if (tp[i,3,4] >= 1)then tp[i,3,4]:=tp[i,3,4]-1;
           if (tp[i,1,4] < 0)then tp[i,1,4]:=tp[i,1,4]+1;
           if (tp[i,2,4] < 0)then tp[i,2,4]:=tp[i,2,4]+1;
           if (tp[i,3,4] < 0)then tp[i,3,4]:=tp[i,3,4]+1;
     end;

//Codage des positions
     for i:=1 to npos do begin
       sp[i]:='';
       for j:=1 to 3 do begin
         for k:=1 to 4  do v4[k]:=tp[i,j,k];
         code(v4,s);
         if (j = 3) then sp[i]:=sp[i]+s else sp[i]:=sp[i]+s+',';
       end;
     end;

//Suppression des blancs
     for i:=1 to npos do begin
       s:=sp[i];
       while(pos(' ',s) > 0) do delete(s,pos(' ',s),1);
       sp[i]:=s;
     end;

//Recherche des doubles
     for i:=1 to npos-1 do begin
       for j:=i+1 to npos do begin
         if (sp[i] = sp[j])then begin
           sp[j]:='';
         end;
       end;
     end;

//Elimination des blancs
     n:=0;
     for i:=1 to npos do begin
       if (sp[i] = '')then continue;
       n:=n+1;
       s_pos[n]:=sp[i];
       for j:=1 to 3 do
       for k:=1 to 4 do tpp[n,j,k]:=tp[i,j,k];
     end;
     npos:=n;
     writeln(nomf,'npos=',npos);
     for i:=1 to npos do
     writeln(nomf,i:4,' ',s_pos[i]);
     for j:=1 to 3 do
     for k:=1 to 4 do tp[i,j,k]:=tpp[i,j,k];
     closefile(nomf);
end;

//Format ShelX
procedure Tfmainmenu.lit_shelx(Sender: TObject);
//----------------------------------------------------
var
  i,ier,j,k                       : integer;
  s                               : string;
  bet                             : matrice3;
  u_iso                           : double;

begin
   if (nom_param = '')then fbrown.memo2.Clear;
   OpenDialog1.filterIndex:=1;
   if (nom_param <> '')then begin
     nom_fichier_shelx:=nom_param;
     nom_param:='';
   end else if OpenDialog1.execute then begin
     s:=OpenDialog1.FileName;
//Quand le nom de fichier est pass par paramtre on ne peut accder a fdessin!
     if (s = '')then exit;
     reset_options;
     for i:=1 to 192 do selected[i]:=0;
     radiogroup2.itemindex:=0;
     nom_fichier_shelx:=s;
     with fdessin do begin
       checkbox1.state:=cbunchecked;
       checkbox2.state:=cbunchecked;
       checkbox1.state:=cbunchecked;
       checkbox3.state:=cbunchecked;
       checkbox4.state:=cbunchecked;
       checkbox5.state:=cbunchecked;
       checkbox6.state:=cbunchecked;
       checkbox7.state:=cbunchecked;
       checklistbox1.itemindex:=0;
       checklistbox1.state[0]:=cbchecked;
     end;
   end else exit;
   if(nom_fichier_shelx = '')then exit;
   screen.cursor:=crhourglass;
   teste_fichier_unix(nom_fichier_shelx);
   screen.cursor:=crdefault;
   nom_fichier_shelx:=uppercase(extractFileName(nom_fichier_shelx));
   nomstruc:=copy(nom_fichier_shelx,1,length(nom_fichier_shelx)-4);
   if (pos('.INS',nom_fichier_shelx) > 0) or (pos('.INP',nom_fichier_shelx) > 0)
   or (pos('.SHX',nom_fichier_shelx) > 0) then licarte_input else licarte_output;
   label7.visible:=true;
   //-----------------------
//Recherche du groupe d'espace. Elimination des translations >=1, < 0  (2/05/03)
   if (groupe_espace = '')then begin
     verif_positions;
     get_spgr;
     if (groupe_espace = '')then label7.caption:='No Space Group found';
   end else label7.caption:='Space Group: '+groupe_espace;
//------------------------------

   ecrit_panel1;
   panel1.visible:=true;
   flag_modif_data:=1;

//Matrice non definie positive?
   for i:=1 to nb_motif do begin
     with motif[i] do begin
       bet[1,1]:=beta[1];
       bet[2,2]:=beta[2];
       bet[3,3]:=beta[3];
       bet[1,2]:=beta[4];
       bet[1,3]:=beta[5];
       bet[2,3]:=beta[6];
       bet[2,1]:=beta[4];
       bet[3,1]:=beta[5];
       bet[3,2]:=beta[6];
       teste_matrice_beta(bet,ier);
       if (ier = 1)then begin
         for j:=1 to 6 do beta[j]:=0;
         if (u_iso = 0)then u_iso:=(bet[1,1]+bet[2,2]+bet[3,3])/3;
         beta[1]:=u_iso;
         beep;
         str(u_iso:6:4,s);
         erreur ('Atom '+nom+' has a non definite positive matrix Uij. Ueq was reset to '+s);
         iso:=1;
       end;

     end;
   end;

   panel1.visible:=true;
   ecrit_panel1;
   flag_modif_data:=1;
 end;

//Format Lazy-Pulverix
procedure Tfmainmenu.lit_lazy(Sender: TObject);
//----------------------------------------------------------
var
  i,ier       : integer;
  s           : string;
begin
   if (nom_param = '')then fbrown.memo2.Clear;
   OpenDialog1.filterIndex:=4;
   if (nom_param <> '')then begin
     nom_fichier_shelx:=nom_param;
     nom_param:='';
   end else if OpenDialog1.execute then begin
     s:=OpenDialog1.FileName;
//Quand le nom de fichier est pass par paramtre on ne peut accder a fdessin!
     if (s = '')then exit;
     radiogroup2.itemindex:=1;
     reset_options;
     for i:=1 to 192 do selected[i]:=0;
     nom_fichier_shelx:=s;
     with fdessin do begin
       checkbox1.state:=cbunchecked;
       checkbox2.state:=cbunchecked;
       checkbox1.state:=cbunchecked;
       checkbox3.state:=cbunchecked;
       checkbox4.state:=cbunchecked;
       checkbox5.state:=cbunchecked;
       checkbox6.state:=cbunchecked;
       checkbox7.state:=cbunchecked;
       checklistbox1.itemindex:=0;
       checklistbox1.state[0]:=cbchecked;
     end;
   end else exit;

   //checklistbox1.itemindex:=0;// car phnomne trange: l'appel de opendialog1 remet
   //checklistbox1.itemindex  sa dernire valeur (en tout cas pour call contents!!!)
   screen.cursor:=crhourglass;
   teste_fichier_unix(nom_fichier_shelx);
   screen.cursor:=crdefault;
   nom_fichier_shelx:=extractFileName(nom_fichier_shelx);
   nomstruc:=copy(nom_fichier_shelx,1,length(nom_fichier_shelx)-4);
   lit_Lazypulverix(ier);
   if (ier > 0)then begin
      erreur('Error while reading input file');
      nom_fichier_shelx:='';
      exit;
   end;
   label7.visible:=true;
   if (groupe_espace = '')then label7.caption:='No Space Group found'
   else label7.caption:='Space Group: '+groupe_espace;
   panel1.visible:=true;
   ecrit_panel1;
   flag_modif_data:=1;
end;

//Format Powder Cell
procedure Tfmainmenu.lit_powder(Sender: TObject);
//---------------------------------------------------
var
  i,ier   : integer;
  s       : string;
begin
   if (nom_param = '')then fbrown.memo2.Clear;
   radiogroup2.itemindex:=1;
   OpenDialog1.filterIndex:=3;
   if (nom_param <> '')then begin
     nom_fichier_shelx:=nom_param;
     nom_param:='';
   end else if OpenDialog1.execute then begin
     s:=OpenDialog1.FileName;
//Quand le nom de fichier est pass par paramtre on ne peut accder a fdessin!
     if (s = '')then exit;
     reset_options;
     for i:=1 to 192 do selected[i]:=0;
     nom_fichier_shelx:=s;
     with fdessin do begin
       checkbox1.state:=cbunchecked;
       checkbox2.state:=cbunchecked;
       checkbox1.state:=cbunchecked;
       checkbox3.state:=cbunchecked;
       checkbox4.state:=cbunchecked;
       checkbox5.state:=cbunchecked;
       checkbox6.state:=cbunchecked;
       checkbox7.state:=cbunchecked;
       checklistbox1.itemindex:=0;
       checklistbox1.state[0]:=cbchecked;
     end;
   end else exit;
   screen.cursor:=crhourglass;
   teste_fichier_unix(nom_fichier_shelx);
   screen.cursor:=crdefault;
   nom_fichier_shelx:=extractFileName(nom_fichier_shelx);
   nomstruc:=copy(nom_fichier_shelx,1,length(nom_fichier_shelx)-4);
   lit_powdercell(ier);
   if (ier > 0)then begin
      erreur('Error while reading input file');
      nom_fichier_shelx:='';
      exit;
   end;
   label7.visible:=true;
   if (groupe_espace = '')then label7.caption:='No Space Group found'
   else label7.caption:='Space Group: '+groupe_espace;
   ecrit_panel1;
   panel1.visible:=true;
   flag_modif_data:=1;
end;

procedure Tfmainmenu.on_click_checklistbox(Sender: TObject);
//---------------------------------------------------------
var
  i   : integer;
  w   : word;
begin
  flag_modif_data:=1;
  flag_boite:=0;flag_sphere:=0;flag_fragment:=0;flag_contents:=0;
  if (checklistbox1.State[checklistbox1.itemindex] = cbunchecked)then begin
    checklistbox1.State[0]:=cbchecked;
    checklistbox1.itemindex:= 0;
    exit;
end;
  for i:=0 to 4 do begin
    if (i = checklistbox1.itemindex)then continue;
    checklistbox1.state[i]:=cbunchecked;
  end;
  case checklistbox1.itemIndex of
    1: begin
        flag_boite:=1;
        fboite.visible:=true;
       end;
    2: begin
         flag_sphere:=1;
         fsphere.visible:=true;
       end;
    3: flag_fragment:=1;
    4: begin
        x_arete:=1.01;
        y_arete:=1.01;
        z_arete:=1.01;
        x_centre:=0.5;
        y_centre:=0.5;
        z_centre:=0.5;
        quel_systeme;
        (*if (systeme ='HEXA')then begin
          x_arete:=2.01;
          y_arete:=2.01;
          z_arete:=1.01;
          x_centre:=0;
          y_centre:=0;
          z_centre:=0;
        end; *)
        flag_cut_boite:=1;
        flag_contents:=1;
        with stringgrid1 do begin
          for i:=1 to rowcount do begin
            if (cells[1,i] = '')then break;
            cells[4,i]:='*';
         end;
        end;
        relit_positions_selectionnees;
      end;
    end;
    flag_couleur_fragment:=0;
    if (flag_fragment = 1) or (flag_boite = 1) or (flag_sphere = 1) then begin
        beep;
        w:=messageDlg('Do you want to colour the fragments?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then begin
          flag_couleur_fragment:=0;
        end else begin
          flag_couleur_fragment:=1;
        end;
    end;

    //checklistbox1.itemindex:=0;
end;

procedure Tfmainmenu.click_groupe(Sender: TObject);
//------------------------------------------------
var
   i,j,k                    : integer;
   v4                       : vecteur4;
   s,s1                     : string;
begin
  if (systeme = 'MONO') and (cel[5] = 90) and (cel[6] <> 90) then begin
    beep;
    erreur('No Space group available for C monoclinic cell');
    listbox2.itemindex:=-1;
    exit;
  end;

  if (listbox1.ItemIndex = -1)then begin
    beep;
    erreur('Select the system');
    exit;
  end;
  listbox3.itemindex:=-1;
  groupe_espace:=listbox2.items[listbox2.itemIndex];
  label7.visible:=true;
  label7.caption:='Space Group: '+groupe_espace;
  bravais:=copy(groupe_espace,1,1);
  set_positions;
  npos_sel:=1;
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      if (j > 1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
    end;
    s_pos[i]:=s;
    selected[i]:=0;
  end;
  selected[1]:=1;
  flag_modif_data:=1;
//12 aout 5000
//on_click_checklistbox(Sender);
  ecrit_stringgrid1;
  deselecte_tut(Sender);
  with fmainmenu.checklistbox1 do begin
     state[itemindex]:=cbunchecked;
     itemindex:=0;
     state[0]:=cbchecked;
  end;
  relit_positions_selectionnees;
  set_liaisons;
  if (panel2.visible = false)then panel2.visible:=true;
end;

procedure reset_panel4;
//---------------------
var
   s                : string;
begin
  with fmainmenu do begin
     if (systeme = 'CUBI') then begin
       s:=edit1.text;
       edit2.text:=s; edit3.text:=s;
       edit4.text:='90';edit5.text:='90';edit6.text:='90';
    end;
    if (systeme = 'TETR')then begin
       s:=edit1.text;
       edit2.text:=s;
       edit4.text:='90';edit5.text:='90';edit6.text:='90';
    end;
    if (systeme = 'HEXA')then begin
       s:=edit1.text;
       edit2.text:=s;edit3.text:=s;
       edit4.text:='90';edit5.text:='90';edit6.text:='120';
    end;
    if (systeme = 'RHOM')then begin
       s:=edit1.text;
       edit2.text:=s;edit3.text:=s;
       s:=edit4.text;
       edit5.text:=s;edit6.text:=s;
    end;
    if (systeme = 'MONO')then begin
       //edit4.text:='90';edit6.text:='90';
    end;
  end;
end;

procedure Tfmainmenu.ListBox1Click(Sender: TObject);
//-------------------------------------------------
begin
  if (listbox1.ItemIndex > -1)then begin
    flag_modif_data:=1;
    systeme:=copy(listbox1.Items[listbox1.ItemIndex],1,4);
    systeme:=uppercase(systeme);
    bravais:=copy(systeme,1,1);
    couleur_edit_param;
    clear_stringgrid1;
    lit_affiche_groupes;
    affiche_groupes_getspec;
    reset_panel4;
  end;
end;

procedure Tfmainmenu.selecte_tout(Sender: TObject);
//---------------------------------------------
var
 i             : integer;
begin
   flag_modif_data:=1;
   with stringgrid1 do begin
     for i:=1 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='*';
     end;
   end;
   relit_positions_selectionnees;
end;

procedure Tfmainmenu.deselecte_tut(Sender: TObject);
//--------------------------------------------------
var  i:integer;
begin
     flag_modif_data:=1;
     with stringgrid1 do begin
     for i:=2 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='';
     end;
   end;
end;

procedure Tfmainmenu.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//------------------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  //Changement de couleur si la position est slectionne
  s:=trim(Stringgrid1.cells[4,row]);
  if (s = '*') and (col = 4) then begin
    stringgrid1.canvas.brush.color:=$F3D1FF;
    stringgrid1.canvas.fillrect(rect);
    stringgrid1.canvas.font.color:=clblack;
    stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end else stringgrid1.canvas.brush.color:=clwhite;
  s:=stringgrid1.cells[col,row];
  //On numrote si le numro est absent
  if (col > 0) and (stringgrid1.cells[0,row] = '') and
  (stringgrid1.cells[1,row] <> '')then
  stringgrid1.cells[0,row]:=inttostr(row);
  //centrage
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);

end;

procedure Tfmainmenu.on_click_stringgrid1(Sender: TObject);
//---------------------------------------------------------
var
  s              : string;
begin
   flag_modif_data:=1;
   if (acol <> 4)then exit;
   s:=stringgrid1.cells[acol,arow];
   if (s = '') then s:='*' else s:='';
   stringgrid1.cells[acol,arow]:=s;
end;

procedure Tfmainmenu.on_select_cell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-----------------------------------------------------------------------
begin
   arow:=row;
   acol:=col;
end;

procedure Tfmainmenu.peint_stringgrid2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------------------
var
  s             : string;
  posx          : integer;
begin
  with stringGrid2.canvas do begin
    if (col = col_err) and (row = row_err)then begin
      font.color:=clred;
      textout(rect.left+1,rect.top+1,stringgrid2.cells[col,row]);
      erreur('Erreur  la ligne '+inttostr(row)+' ,colonne '+inttostr(col+1));
      col_err:=-1;
      row_err:=-1;
    end;
    s:=stringGrid2.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-textWidth(s)) div 2;
    textrect(rect,rect.left+posx,rect.top,s);
  end;
end;

procedure Tfmainmenu.verif_case(Sender: TObject);
//-----------------------------------------------
begin
  verif_frappe;
end;

procedure Tfmainmenu.set_numero(Sender: TObject);
//-----------------------------------------------
begin
  flag_modif_data:=1;
  with fmainmenu do begin
    if edit1.focused then no_case:=1;
    if edit2.focused then no_case:=2;
    if edit3.focused then no_case:=3;
    if edit4.focused then no_case:=4;
    if edit5.focused then no_case:=5;
    if edit6.focused then no_case:=6;
  end;
  modif_cell:=1;
end;

procedure TFmainmenu.modif_ligne(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
//----------------------------------------------------------------
var
  i,j                 :integer;
  s,s1                : string;
begin
  modif_coord:=1;
  col_err:=-1;
  row_err:=-1;
  with stringGrid2 do begin

//Effacement de la ligne si l'element est blanc
    if (col > 0)and (trim(cells[1,row]) = '')then begin
      for i:=1 to colcount-1 do cells[i,row]:='';
      for i:=row to rowcount-2 do begin  //compression
        Cells[0,i]:=inttostr(i);
        for j:=1 to colcount-1 do cells[j,i]:=cells[j,i+1];
      end;
      relit_stringgrid2(i);
      flag_modif_data:=1;
      exit;
    end;

//Passage en majuscules
    for i:=0 to colcount do begin
      s:=cells[i,row];
      s:=uppercase(s);
      if (i = 1) then begin
        s1:=lowercase(s);
        s[2]:=s1[2];
      end;
      cells[i,row]:=s;
    end;

//Ecriture des zeros et u11=0.1 (26 mai 2001)
    for i:=col+1 to 11 do begin
      if (i = 2)then continue;
      s:=trim(cells[i,row]);
      if (s = '')then begin
        //if (i = 12)then cells[i,row]:='0.1' else cells[i,row]:='0';
        cells[i,row]:='0';
      end;
    end;

  end;
end;

procedure Tfmainmenu.effaace_element(Sender: TObject);
//---------------------------------------------------
begin
   flag_modif_data:=1;
   feffaceE.visible:=true;
end;

procedure Tfmainmenu.efface_atome(Sender: TObject);
//-------------------------------------------------
begin
   flag_modif_data:=1;
   feffaceA.visible:=true;
end;

procedure Tfmainmenu.efface_bloc(Sender: TObject);
//------------------------------------------------
begin
   flag_modif_data:=1;
   feffaceb.visible:=true;
end;

procedure Tfmainmenu.restaure(Sender: TObject);
//----------------------------------------------
var
  s      : string;
  i,ier  : integer;
begin
  radiogroup1.itemIndex:=0;
  flag_modif_data:=1;
  nb_child:=0;nb_motif:=0;nbtrans:=0;npos:=0;npos_sel:=0;
  nb_typ_element:=0;nb_typ_liai:=0;nb_bonds:=0;
  groupe_espace:='';
  if (nom_fichier_shelx <> '')then begin
    s:=nom_fichier_shelx;
    if (pos('.inp',s) > 0) or (pos('.ins',s) > 0)then licarte_input;
    if (pos('.out',s) > 0) then licarte_output;
    if (pos('.lzy',s) > 0) then lit_lazypulverix(ier);
    if (pos('.cel',s) > 0) then lit_powdercell(ier);
    if (pos('.cif',s) > 0) then lit_fichier_cif(ier);
    label7.visible:=false;
  end else if(nom_fichier_ascii <> '')then begin
    lit_fichier_ascii;
  end;
  deselecte_tut(Sender);
  with fmainmenu.checklistbox1 do begin
     state[itemindex]:=cbunchecked;
     itemindex:=0;
     state[0]:=cbchecked;
  end;
  label7.visible:=true;
  if (groupe_espace = '')then label7.caption:='No Space Group found'
  else label7.caption:='Space Group: '+groupe_espace;
  ecrit_panel1;
  set_typ_liaisons;
end;

procedure Tfmainmenu.edite_bond_lengths(Sender: TObject);
//------------------------------------------------------
begin
   flag_modif_data:=1;
   ftypliai.visible:=true;
end;

procedure Tfmainmenu.sauve_fichier_shelx(Sender: TObject);
//--------------------------------------------------------
var
  ier           : integer;
  w             : word;
begin
  if (nb_motif = 0)then exit;
//Nom du fichier
  savedialog1.filterindex:=1;
  savedialog1.initialdir:=repertoire_origine;
  if savedialog1.execute then
    nom_fichier_sortie:=savedialog1.filename;
  if (nom_fichier_sortie = '')then exit;
  if (pos('.',nom_fichier_sortie) = 0)then
  nom_fichier_sortie:=nom_fichier_sortie+'.shx';
  if FileExists(nom_fichier_sortie) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
  end;
//On relit toutes les donnees
  relit_maille(ier);
  if (ier > 0)then exit;
  relit_stringgrid2(ier);
  if (ier > 0)then begin
    beep;
    erreur('Coordinates read error');
    exit;
  end;
  relit_positions_selectionnees;
  if (nb_motif = 0)then begin
    beep;
    erreur('No data');
    exit;
  end;
//Ecriture
  ecrit_fichier_shelx;
  ecrit_stringgrid2;
  flag_modif_data:=1;
  nom_fichier_shelx:=nom_fichier_sortie;
  nom_fichier_ascii:='';
end;

procedure Tfmainmenu.selection_thermal_expression(Sender: TObject);
//----------------------------------------------------------------
begin
  flag_modif_data:=1;
  ecrit_stringgrid2;
end;

procedure Tfmainmenu.help_data(Sender: TObject);
//----------------------------------------------
begin
   Application.HelpFile:=repertoire_origine+'\gretep.hlp';
   Application.HelpContext(4);
end;

procedure Tfmainmenu.generation_help(Sender: TObject);
//---------------------------------------------------
begin
   Application.HelpFile:=repertoire_origine+'\gretep.hlp';
   Application.HelpContext(1);
end;

procedure Tfmainmenu.affiche_child(Sender: TObject);
//---------------------------------------------------
var
  i,ier       : integer;
  x           : real;
begin
//Maille
  if (modif_cell = 1)then begin
    relit_maille(ier);
    x:=1;
    for i:=1 to 6 do x:=x*cel[i];
    if (x = 0)then begin
      erreur('No cell parameters');
      exit;
    end;
    if (ier > 0)then exit;
    setmat;
  end;

//Positions
  relit_positions_selectionnees;

//Coordonnes
  relit_stringgrid2(ier);
  if (ier > 0)then begin
      beep;
      erreur('Coordinates read error');
      exit;
  end;
  if (nb_motif = 0)then begin
      erreur('No coordinates!');
      exit;
  end;
  if (modif_coord =1)then begin
    set_typ_liaisons;
  end;
  if (nb_motif = 0)then exit;

//Gnration
  generer(sender);
  if (nb_child = 0)then begin
    beep;
    erreur('No data');
    exit;
  end;
  fdisp_coord.show;
end;

procedure Tfmainmenu.erase_tout(Sender: TObject);
//----------------------------------------------
begin
   flag_modif_data:=1;
  nom_fichier_shelx:='';
  nom_fichier_sortie:='';
  nom_fichier_grt:='';
  clear_stringgrid2;
  nb_motif:=0;
end;

procedure Tfmainmenu.clickpanel4(Sender: TObject);
//------------------------------------------------
begin
   flag_modif_data:=1;
end;

procedure Tfmainmenu.init_active(Sender: TObject);
//------------------------------------------------
 begin
  //edit7.text:=nom_param;
  flag_brown:=0;
  panel1.top:=0;
  panel1.left:=0;
  if (nom_param <> '')then begin
    nom_param:=lowercase(nom_param);
    if (pos('.gre',nom_param) > 0)then begin
      ecrit_stringgrid2;
      showmessage('The file '+nom_param+' was loaded. Click on the "Plot" Item');
      exit;
    end else if(pos('.ins',nom_param) > 0) or (pos('.shx',nom_param) > 0)
            or (pos('.inp',nom_param) > 0) or (pos('.out',nom_param) > 0)
            or (pos('.res',nom_param) > 0)
            or (pos('.lst',nom_param) > 0)  then begin
      lit_shelx(Sender);
    end else if (pos('.lzy',lowercase(nom_param)) > 0)then begin
      lit_lazy(Sender);
    end else if (pos('.cel',lowercase(nom_param)) > 0)then begin
     lit_powder(Sender);
    end else if (pos('.cry',lowercase(nom_param)) > 0)then begin
     lit_fichier_poudrix(Sender);
    end else if (pos('.cif',lowercase(nom_param)) > 0)then begin
     lit_cif(sender);
    end;
  end;
  ecrit_stringgrid2;
end;

procedure Tfmainmenu.Gretepfile2Click(Sender: TObject);
//------------------------------------------------------
var
  w     : word;
begin
  if (nb_child = 0)then exit;
   savedialog1.filterIndex:=2;
   if SaveDialog1.execute then begin
     nom_fichier_sortie:=SaveDialog1.filename;
     if (nom_fichier_sortie = '')then exit;
     if (pos('.',nom_fichier_sortie) = 0)then
     nom_fichier_sortie:=nom_fichier_sortie+'.gre';
     if FileExists(nom_fichier_sortie) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
     end;
     ecrit_fichier_ascii;
   end;
end;

//Dtermination des positions par Getspec (7 nov 00)
procedure Tfmainmenu.click_groupe_getspec(Sender: TObject);
//---------------------------------------------------------
var
   i,j,k,ier,no             : integer;
   v4                       : vecteur4;
   s,s1                     : string;
   c                        : char;
   tabmes                   : tab_mess;
   nomf                     : textfile;
   tableau                  : tab_reel;
begin
  clear_stringgrid1;
  listbox2.itemindex:=-1;
  chdir(repertoire_origine);
  if fileExists('scfs.dat')then deletefile('scfs.dat');
  s:='';
  s:= listbox3.items[listbox3.itemIndex];
  s:=copy(s,1,12);
  s:=trim(s);
  groupe_espace:=s;
  bravais:=copy(groupe_espace,1,1);
  for i:=1 to length(s) do begin
    c:=s[i];
    tabmes[i]:=ord(c);
  end;
  if (length(s) < 16)then begin
    for i:=length(s)+1 to 16 do tabmes[i]:=32;
  end;

  getdll(tabmes);

//Lecture des positions gnres
  assignfile(nomf,'scfs.dat');
  reset(nomf);
  npos:=0;
  readln(nomf);
  while not(eof(nomf)) do begin
    readln(nomf,s);
    if (s = '')then break;
    while (pos(' .',s)> 0)  do insert(' 0',s,pos(' .',s)+1);
    while (pos('-.',s)> 0) do insert('0',s,pos(' -.',s)+1);
    dec(s,tableau,no,ier);
    npos:=npos+1;
    for i:=1 to 3 do tp[npos,1,i]:=tableau[i];
    tp[npos,1,4]:=tableau[4];
    for i:=1 to 3 do tp[npos,2,i]:=tableau[i+4];
    tp[npos,2,4]:=tableau[8];
    for i:=1 to 3 do tp[npos,3,i]:=tableau[i+8];
    tp[npos,3,4]:=tableau[12];
  end;
  closefile(nomf);

//Codage des positions
  centre:=-1;
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      s:=s+s1+',';
    end;
    s_pos[i]:=copy(s,1,length(s)-1);
    selected[i]:=0;
    if (pos('-X,-Y,-Z',s_pos[i]) > 0)then centre:=1;
  end;

//Translations
  set_transla;
  npos_sel:=1;
  selected[1]:=1;
  flag_modif_data:=1;
  ecrit_stringgrid1;
  deselecte_tut(Sender);
  with fmainmenu.checklistbox1 do begin
     state[itemindex]:=cbunchecked;
     itemindex:=0;
     state[0]:=cbchecked;
  end;

//12 aout 2000
  //on_click_checklistbox(Sender);
  label7.visible:=true;
  label7.caption:='Space Group: '+groupe_espace;
  relit_positions_selectionnees;
  set_liaisons;
  if (panel2.visible = false)then panel2.visible:=true;
end;

procedure Tfmainmenu.BitBtn1Click(Sender: TObject);
//----------------------------------------------
begin
   chdir(repertoire_origine);
   Application.HelpFile:='gretep.hlp';
   Application.HelpContext(12);
end;


procedure go_save_cif;
//--------------------
var
  ier           : integer;
  w             : word;
begin
  with fmainmenu do begin

//Nom du fichier
    savedialog1.filterindex:=3;
    savedialog1.initialdir:=repertoire_origine;
    if savedialog1.execute then
      nom_fichier_sortie:=savedialog1.filename;
    if (nom_fichier_sortie = '')then exit;
    if (pos('.',nom_fichier_sortie) = 0)then
    nom_fichier_sortie:=nom_fichier_sortie+'.cif';
    if FileExists(nom_fichier_sortie) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
    end;

//On relit toutes les donnees
    relit_maille(ier);
    if (ier > 0)then exit;
    relit_stringgrid2(ier);
    if (ier > 0)then begin
      beep;
      erreur('Coordinates read error');
      exit;
    end;
    relit_positions_selectionnees;
    if (nb_motif = 0)then begin
      beep;
      erreur('No data');
      exit;
    end;

//Ecriture
    flag_modif_data:=1;
    ecrit_stringgrid2;
    nom_fichier_shelx:=nom_fichier_sortie;
    nom_fichier_ascii:='';
    fformula.visible:=true;

  end;

end;

procedure Tfmainmenu.sauve_fichier_cif(Sender: TObject);
//------------------------------------------------------
begin
  if (nb_motif = 0)then exit;
  if (groupe_espace = '')then begin
    beep;
    fget_sp.visible:=true;
    exit;
  end;
  go_save_cif;
end;

procedure Tfmainmenu.sauvegarde_data(Sender: TObject);
//----------------------------------------------------
begin
  beep;
  PopupMenu1.popup(250,240);   //Popmenu
end;

procedure Tfmainmenu.litdonneesclavier(Sender: TObject);
//-----------------------------------------------------
var
  ier             : integer;
begin
  relit_maille(ier);
  if (ier > 0) then exit;
  relit_stringgrid2(ier);
  if (ier > 0) then exit;
  if (npos = 0)then begin
      beep;
      erreur('No equivalent positions');
      exit;
  end;
  if (nb_motif = 0)then begin
      erreur('No coordinates!');
      exit;
  end;
  //set_positions;
  set_typ_liaisons;
  remet_colorbuttons;
  flag_modif_data:=1;
  ecrit_stringgrid2;
end;

procedure Tfmainmenu.BitBtn2Click(Sender: TObject);
//-------------------------------------------------
begin
  remet_colorbuttons;
end;

procedure Tfmainmenu.click_stringgrid2(Sender: TObject);
//------------------------------------------------------
begin
 change_colorbuttons;
end;

procedure Tfmainmenu.Iso_aniso(Sender: TObject);
//---------------------------------------------
var
  ueq,depi2              : double;
  i,iat                  : integer;
  t,u                    : array[1..6] of double;
begin
// uij Isotropes
  flag_modif_data:=1;
  if (radiogroup1.itemIndex = 1) then begin
    fdessin.radiogroup2.visible:=false;
    depi2:=2*pi*pi;

    t[1]:=sqr(cel[1]);
    t[2]:=sqr(cel[2]);
    t[3]:=sqr(cel[3]);
    t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
    t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
    t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   (*
     v[1]:=depi2*celr[1]*celr[1];
     v[2]:=depi2*celr[2]*celr[2];
     v[3]:=depi2*celr[3]*celr[3];
     v[4]:=depi2*celr[1]*celr[2]*cos(celr[6]/57.2957);
     v[5]:=depi2*celr[1]*celr[3]*cos(celr[5]/57.2957);
     v[6]:=depi2*celr[2]*celr[3]*cos(celr[4]/57.2957);
    *)
     u[1]:=depi2*celr[1]*celr[1];
     u[2]:=depi2*celr[2]*celr[2];
     u[3]:=depi2*celr[3]*celr[3];
     u[4]:=depi2*celr[1]*celr[2];
     u[5]:=depi2*celr[1]*celr[3];
     u[6]:=depi2*celr[2]*celr[3];

    for iat:=1 to nb_motif do begin
      with motif[iat] do begin
        if (iso = 0) then begin
           ueq:=0;
           for i:=1 to 6 do ueq:=ueq+beta[i]*u[i]*t[i];
           beta[1]:=ueq/(3*depi2);
           for i:=2 to 6 do beta[i]:=0;
           iso:=1;
         end;
      end;
    end;
    ecrit_stringgrid2;
  end else begin
    fdessin.radiogroup2.visible:=true;
    restaure(Sender);
    ecrit_stringgrid2;
  end;
end;

procedure Tfmainmenu.Calcul_brown(Sender: TObject);
//-------------------------------------------------
begin
  if (fbrown.WindowState = WsMinimized)then begin
    Fbrown.WindowState:=WsNormal;
    exit;
  end;
  flag_brown:=0;
  if (nb_motif > 0) then fbrown.visible:=true;
end;

procedure Tfmainmenu.modifie_stringgrid2(Sender: TObject; var Key: Char);
//-----------------------------------------------------------------------
begin
  if (npos > 0)then panel8.visible:=true;
end;

// CIF format
procedure Tfmainmenu.lit_cif(Sender: TObject);
//--------------------------------------------------
var
  i,j,k,ier,n,n1,n2   : integer;
  s,s1                : string;
  nomf,nomesp         : textfile;

  label 1;
begin
   if FileExists('dummy.cif') then DeleteFile('dummy.cif');
   if FileExists('dummy.shx') then DeleteFile('dummy.shx');
   if (nom_param = '')then fbrown.memo2.Clear;
   radiogroup2.itemindex:=0;
   OpenDialog1.filterIndex:=6;
   if (nom_param <> '')then begin
     nom_fichier_shelx:=nom_param;
     nom_param:='';
   end else if OpenDialog1.execute then begin
     s:=OpenDialog1.FileName;
//Quand le nom de fichier est pass par paramtre on ne peut accder a fdessin!
     if (s = '')then exit;
     reset_options;
     for i:=1 to 192 do selected[i]:=0;
     nom_fichier_shelx:=s;
     with fdessin do begin
       checkbox1.state:=cbunchecked;
       checkbox2.state:=cbunchecked;
       checkbox1.state:=cbunchecked;
       checkbox3.state:=cbunchecked;
       checkbox4.state:=cbunchecked;
       checkbox5.state:=cbunchecked;
       checkbox6.state:=cbunchecked;
       checkbox7.state:=cbunchecked;
       checklistbox1.itemindex:=0;
       checklistbox1.state[0]:=cbchecked;
     end;
   end else exit;
   if(nom_fichier_shelx = '')then exit;
   screen.cursor:=crhourglass;
//-----------------
   //teste_fichier_unix(nom_fichier_shelx);
//-----------------
   screen.cursor:=crdefault;
   nomstruc:=copy(extractFileName(nom_fichier_shelx),1,length(nom_fichier_shelx)-4);
   ier:=0;

   assignfile(nomesp,'blocs.txt');
   rewrite(nomesp);
//Plusieurs blocs?
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    nb_blocs:=0;
    n:=0;
    while not(eof(nomf)) do begin
      readln(nomf,s);
      n:=n+1;
      if (s = '')then continue;
      s:=trim(s);
      if (copy(lowercase(s),1,11) = 'data_global') then continue;

//dbut de bloc ?
1:    s:=trim(s);
      if (copy(lowercase(s),1,5) = 'data_')then begin
        n1:=n;
        ier:=0;
        s1:=s;
        delete(s1,1,5);
        while not eof(nomf) do begin
          readln(nomf,s);
          n:=n+1;
          if (copy(lowercase(s),1,5) = 'data_') or eof(nomf) then break; //fin de bloc
          if (pos('#end',lowercase(s)) > 0) then break;
          if (pos('_cell_length_a',s) > 0)then ier:=ier+1;
          if (pos('_symmetry_equiv_pos_as_xyz',s) > 0) or
              (pos('_symmetry_space_group_name_H-M',s) > 0)or
              (pos('_symmetry_space_group_name_Hall',s) > 0) then ier:=ier+1;
        end;
//c'est un bloc
        if (ier >= 2) and (uppercase(s1) <> 'GLOBAL')then begin
           inc(nb_blocs);
           bloc[nb_blocs].debut:=n1;
           bloc[nb_blocs].fin:=n-1;
           bloc[nb_blocs].tit:=s1;
        end ;
        if not eof(nomf) then goto 1;
      end;
    end;
    closefile(nomf);

    if (nb_blocs = 0)then begin
      erreur ('Gretep cannot finf any valuable bloc');
      exit;
    end;

    for i:=1 to nb_blocs do begin
      writeln(nomesp,bloc[i].debut:4,bloc[i].fin:4,' ',bloc[i].tit);
    end;
    closefile(nomesp);

    if (nb_blocs <= 1)then begin
//-----------------
      numero_bloc:=1;
      lit_fichier_cif(ier);
//-----------------
      if (ier > 0)then exit;
    end else begin
      fquel_bloc.visible:=true;
      ier:=1;
      exit;
    end;

   if (ier > 0)then begin
      nom_fichier_shelx:='';
      exit;
   end;

   setmat;
   quel_systeme;
   set_typ_liaisons;

//-----------------------
//Recherche du groupe d'espace. Elimination des translations >=1, < 0
   if (groupe_espace = '')then begin
     verif_positions;
     get_spgr;
     if (groupe_espace = '')then label7.caption:='No Space Group found';
   end else label7.caption:='Space Group: '+groupe_espace;
//-----------------------

   label7.visible:=true;
   ecrit_panel1;
   panel1.visible:=true;
   flag_modif_data:=1;
end;


procedure Tfmainmenu.lit_fichier_poudrix(Sender: TObject);
//--------------------------------------------------------
var
  i,ier       : integer;
  s           : string;
begin
   if (nom_param = '')then fbrown.memo2.Clear;
   OpenDialog1.filterIndex:=7;
   if (nom_param <> '')then begin
     nom_fichier_shelx:=nom_param;
     nom_param:='';
   end else if OpenDialog1.execute then begin
     s:=OpenDialog1.FileName;
//Quand le nom de fichier est pass par paramtre on ne peut accder a fdessin!
     if (s = '')then exit;
     radiogroup2.itemindex:=1;
     reset_options;
     for i:=1 to 192 do selected[i]:=0;
     nom_fichier_shelx:=s;
     with fdessin do begin
       checkbox1.state:=cbunchecked;
       checkbox2.state:=cbunchecked;
       checkbox1.state:=cbunchecked;
       checkbox3.state:=cbunchecked;
       checkbox4.state:=cbunchecked;
       checkbox5.state:=cbunchecked;
       checkbox6.state:=cbunchecked;
       checkbox7.state:=cbunchecked;
       checklistbox1.itemindex:=0;
       checklistbox1.state[0]:=cbchecked;
     end;
   end;

   //checklistbox1.itemindex:=0;// car phnomne trange: l'appel de opendialog1 remet
   //checklistbox1.itemindex  sa dernire valeur (en tout cas pour call contents!!!)
   screen.cursor:=crhourglass;
   //teste_fichier_unix(nom_fichier_shelx);
   screen.cursor:=crdefault;
   nom_fichier_shelx:=extractFileName(nom_fichier_shelx);
   nomstruc:=copy(nom_fichier_shelx,1,length(nom_fichier_shelx)-4);
   lit_poudrix(ier);
   if (ier > 0)then begin
      erreur('Error while reading input file');
      nom_fichier_shelx:='';
      exit;
   end;
   label7.visible:=true;
   if (groupe_espace = '')then label7.caption:='No Space Group found'
   else label7.caption:='Space Group: '+groupe_espace;
   panel1.visible:=true;
   ecrit_panel1;
   flag_modif_data:=1;
end;


end.

