unit mask_elements;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ColorBtns;

type
  Tfmask_element = class(TForm)
    StringGrid1: TStringGrid;
    Color95Button2: TColor95Button;
    Label1: TLabel;
    procedure initialise(Sender: TObject);
    procedure peint_grid1(Sender: TObject; Col, Row: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure select_cell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure sortie(Sender: TObject);
    procedure on_click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmask_element: Tfmask_element;

implementation

{$R *.DFM}
uses
  oemath, dessin;

var
    arow1,acol1   : integer;

procedure Tfmask_element.initialise(Sender: TObject);
//-------------------------------------------
var
   i                 : integer;
begin
  with stringgrid1 do begin
   rowcount:=nb_typ_element+2;
   height:=21*rowcount;
   if(height > 425)then height:=425;
   for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
   end;
   cells[1,0]:='Elem.';
   for i:=1 to nb_typ_element do cells[0,i]:=element[i].nom;
 end;

end;

procedure Tfmask_element.peint_grid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  s:=trim(StringGrid1.cells[col,row]);
  if (pos('*',s) > 0) then begin
    stringgrid1.canvas.brush.color:=$EECBFF;
    stringgrid1.canvas.fillrect(rect);
    stringgrid1.canvas.font.color:=clblack;
    stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end ;
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
 end;

procedure Tfmask_element.select_cell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//--------------------------------------------------------------
begin
  arow1:=row;
  acol1:=col;
end;

procedure Tfmask_element.sortie(Sender: TObject);
//-----------------------------------------------
var
  i,j   : integer;
  s,s1     : string;
 // nomf  : textfile;
begin
 (* assignFile(nomf,'espion');
  rewrite(nomf);
  writeln(nomf,'avant');
  for i:=1 to nb_child do begin
    with child[i] do begin
      writeln(nomf,nom,no_element:5,trace:5);
    end;
  end; *)

  for i:=1 to nb_typ_element do begin
    s:=stringgrid1.cells[0,i];
    if (pos('*',s) = 0) then continue;
  (*for j:=1 to nb_child do begin
      if (child[j].no_element = i)then begin
        child[j].trace:=0;
        //break;
    end; *)
//Modif 1/3/2001    
    delete(s,pos('*',s),1);s:=trim(s);
    for j:=1 to nb_child do begin
      s1:=child[j].nom; traite_nom_element(s1);
      s1:=copy(s1,1,2);s1:=trim(s1);
      if (s = s1)then begin
        child[j].trace:=0;
      end;
    end;
  end;

  //writeln(nomf,'apres');
  //for i:=1 to nb_child do begin
   // child_old[i]:=child[i];
   (* with child[i] do begin
      writeln(nomf,nom,no_element:5,trace:5);
    end; *)
  //end;
 // closefile(nomf);

  //dessine;
  //fdessin.redessine(sender);
  close;
end;

procedure Tfmask_element.on_click(Sender: TObject);
//-------------------------------------------------
var s:string;
begin
  s:=stringGrid1.cells[acol1,arow1];
  if (pos('*',s) > 0) then delete (s,pos('*',s),1)
  else s:=s+'*';
  stringGrid1.cells[acol1,arow1]:=s;
end;

end.
