unit paneau1;

interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math, graphics;

var
   acol,arow                     : integer;
   col_err,row_err               : integer;
   no_case                       : integer;

procedure verif_frappe;
procedure couleur_edit_param;
procedure lit_affiche_groupes;
procedure ecrit_panel1;
procedure ecrit_stringgrid1;
procedure relit_maille(var ier:integer);
procedure relit_stringGrid2(var ier:integer);
procedure relit_positions_selectionnees;
procedure ecrit_stringgrid2;
procedure clear_stringgrid2;
procedure clear_stringgrid1;
procedure affiche_groupes_getspec;

implementation

uses
oemath, mainmenu, effaceE, effaceA, effaceB, fichiers, typliai, dessin;


procedure verif_frappe;
//---------------------
var
  s                : string;
  x                : double;
  ier              : integer;
begin
  with fmainmenu do begin
    case no_case of
      1: s:=edit1.text;
      2: s:=edit2.text;
      3: s:=edit3.text;
      4: s:=edit4.text;
      5: s:=edit5.text;
      6: s:=edit6.text;
    end;
    verif(s);
    val(s,x,ier);
    if (ier > 0)then begin
      case no_case of
        1: edit1.setfocus;
        2: edit2.setfocus;
        3: edit3.setfocus;
        4: edit4.setfocus;
        5: edit5.setfocus;
        6: edit6.setfocus;
      end;
      erreur ('Type error!');
      exit;
    end;
    case no_case of
      1:begin
        if (systeme = 'CUBI') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        if (systeme = 'TETR') or (systeme = 'HEXA') then edit2.text:=s;
        if (systeme = 'RHOM') then begin
          edit2.text:=s;
          edit3.text:=s;
        end;
        cel[1]:=x;
      end;
      2: cel[2]:=x;
      3: cel[3]:=x;
      4:begin
          cel[4]:=x;
          if (systeme = 'RHOM') then begin
            edit5.text:=s;
            edit6.text:=s;
            cel[5]:=x;
            cel[6]:=x;
          end;
        end;
    end;
  end;
end;

procedure couleur_edit_param;{
-----------------------------}
begin
    with fmainmenu do begin
      edit1.color:=clwhite;
      edit2.color:=clwhite;
      edit3.color:=clwhite;
      edit4.color:=clwhite;
      edit5.color:=clwhite;
      edit6.color:=clwhite;
      if(systeme = 'CUBI')then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;edit3.text:=edit1.text;
      end else if (systeme = 'TETR')then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
          edit2.text:=edit1.text;
      end else if (systeme  = 'ORTH')then begin
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='90';
      end else if (systeme = 'HEXA') then begin
          edit2.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit4.text:='90';edit5.text:='90';edit6.text:='120';
          edit2.text:=edit1.text;
      end else If (systeme = 'RHOM') then begin
          edit2.color:=clsilver;
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit2.text:=edit1.text;edit3.text:=edit1.text;
          edit5.text:=edit4.text;edit6.text:=edit4.text;
      end else if(systeme = 'MONO')then begin
          //edit4.color:=clsilver;
          //edit6.color:=clsilver;
          //edit4.text:='90';edit6.text:='90';
      end;
    end;
end;

procedure lit_affiche_groupes;
//----------------------------
var
  s,s1                    : string;
  nomf                    : TextFile;
  n,i                     : integer;
begin
  with fmainmenu do begin
    chdir(repertoire_origine);
    s1:=systeme+'.pos';
    AssignFile(nomf,s1);
    reset(nomf);
    listbox2.items.clear;
    nb_groupes:=0;
    while not (eof(nomf)) do begin
      readln(nomf,s);
      s:=TrimRight(s);
      if(length(s) = 0)then begin
        readln(nomf,s);
        s:=trim(s);
        listbox2.items.add(s);
        nb_groupes:=nb_groupes+1;
        readln(nomf);
        readln(nomf,n);for i:=1 to n do readln(nomf);
        readln(nomf,n);if (n > 0)then for i:=1 to n do readln(nomf);
      end;
    end;
    closeFile(nomf);
  end;
end;

//Allume le groupe et le systme slectionns
procedure allume_groupes;{
-------------------------}
var
  s,s1                    : string;
  i                       : integer;
  sender                  : tobject;
begin
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'RHOM')then bravais:='P';
  groupe_espace:=uppercase(groupe_espace);
  s:=groupe_espace;s:=trim(s);s:=uppercase(s);

//Allumage du systeme
  for i:=1 to 7 do begin
    s:=copy(fmainmenu.listbox1.items.strings[i-1],1,4);
    s:=uppercase(s);
    if(s = systeme)then begin
      fmainmenu.listbox1.ItemIndex:=i-1;
      break;
    end;
  end;

//Allumage du groupe d'espace dans listbox2
  if(length(groupe_espace) > 0)then begin
    fmainmenu.listbox2.ItemIndex:=-1;
    for i:=1 to nb_groupes do begin
      s:=fmainmenu.listbox2.items.strings[i-1];
      s:=Trim(s);
      if(groupe_espace = s) then begin
        fmainmenu.listbox2.ItemIndex:=i-1;
        break;
      end;
    end;

//Allumage du groupe d'espace dans listbox3
    if (fmainmenu.listbox2.ItemIndex = -1)then begin
      for i:=1 to nb_groupes_getspec do begin
        s:=fmainmenu.listbox3.items.strings[i-1];
        s:=copy(s,1,pos(' ',s)-1);
        s:=Trim(s);
        if(groupe_espace = s) then begin
          fmainmenu.listbox3.ItemIndex:=i-1;
          if (pos('.cif',nom_fichier_shelx) > 0) and (npos > 0)then exit;
          fmainmenu.click_groupe_getspec(sender);
          break;
        end;
        s:=fmainmenu.listbox3.items.strings[i-1];
        delete(s,1,pos('  ',s));
        s:=trim(s);
        s:=copy(s,1,15);
        s:=Trim(s);
        if(groupe_espace = s) then begin
          fmainmenu.listbox3.ItemIndex:=i-1;
          break;
        end;
      end;
    end;

  end;
end;

procedure relit_maille(var ier:integer);
//--------------------------------------
begin
  with fmainmenu do begin
    val(edit1.text,cel[1],ier);
    val(edit2.text,cel[2],ier);
    val(edit3.text,cel[3],ier);
    val(edit4.text,cel[4],ier);
    val(edit5.text,cel[5],ier);
    val(edit6.text,cel[6],ier);
  end;
  if (ier > 0 )or (cel[1]*cel[2]*cel[3]*cel[4]*cel[5]*cel[6] = 0) then begin
    erreur('Cell parameters error');
    exit;
  end;
end;

procedure relit_stringGrid2(var ier:integer);
//------------------------------------------
var
    i,j,k       : integer;
    s           : string;
    nomf        : textfile;
    x,depi2     : double;
    u           : array[1..6] of real;
begin
  ier:=0;
  with fmainmenu.StringGrid2 do begin
    nb_motif:=0;
    for i:=1 to rowcount-1 do begin
      s:=cells[1,i];
      s:=uppercase(s);
      if (length(s) = 0)then continue;
      nb_motif:=nb_motif+1;
      motif[nb_motif].element:=s;
      motif[nb_motif].labell:=cells[2,i];
      s:=motif[nb_motif].element+motif[nb_motif].labell;
      traite_nom_atome(s);
      motif[nb_motif].nom:=s;
//x,y,z
      for j:=1 to 3 do begin
        s:=cells[j+2,i];
        s:=trim(s);
        if (length(s) = 0)then begin
          x:=0;
          cells[j+2,i]:='0';
        end else val(s,x,ier);
        if (ier > 0)then begin
          row_err:=i;
          col_err:=j+1;
          fmainmenu.stringgrid2.refresh;
          exit;
        end;
        case j of
          1: motif[nb_motif].x:=x;
          2: motif[nb_motif].y:=x;
          3: motif[nb_motif].z:=x;
        end;
      end;

//betaij
      motif[i].iso:=0;
      for j:=1 to 6 do begin
        s:=cells[j+5,i];
        s:=trim(s);
        if (length(s) = 0)then begin
          x:=0;
        end else val(s,x,ier);
        if (ier > 0)then begin
          row_err:=i;
          col_err:=j+5;
          fmainmenu.stringgrid2.refresh;
          exit;
        end;
        motif[i].beta[j]:=x;
      end;

//Atomes isotropes

      with motif[nb_motif] do begin
        if (beta[2] = 0) and (beta[3] = 0) then begin
          s:=cells[12,i];
          if (s = '')then s:='0';
          val(s,beta[1],ier);
          if (ier > 0)then begin
            row_err:=i;
            col_err:=12;
            fmainmenu.stringgrid2.refresh;
            exit;
          end;
          if (beta[1] = 0)then beta[1]:=0.1;
          str(beta[1]:8:6,s);
          cells[12,i]:=s;
          iso:=1;
          for k:=2 to 6 do motif[i].beta[k]:=0;
          for k:=1 to 6 do cells[j+k,i]:='';
        end;
      end;

    end;
  end;

//Retour aux uij
  if (fmainmenu.radiogroup2.itemIndex > 0)then begin
    depi2:=2.*3.14159*3.14159;
    u[1]:=depi2*celr[1]*celr[1];
    u[2]:=depi2*celr[2]*celr[2];
    u[3]:=depi2*celr[3]*celr[3];
    u[4]:=depi2*celr[1]*celr[2];
    u[5]:=depi2*celr[1]*celr[3];
    u[6]:=depi2*celr[2]*celr[3];
    for i:=1 to nb_motif do begin
      with motif[i] do begin
        case fmainmenu.radiogroup2.itemIndex of
          1: for k:=1 to 6 do beta[k]:=beta[k]/(2*depi2);        //Bij
          2: for k:=1 to 6 do beta[k]:=beta[k]/u[k];           //Betaij
        end;
      end;
    end;
  end;
end;
(*
procedure relit_positions_selectionnees;
//--------------------------------------
var
   s,s1                : string;
   i,j,k,ier           : integer;
   x1,x2               : double;
const
   cod  : array[1..10] of string[20] =('Y-X','X-Y','X+Y','Y+X','-Z','-Y','-X','Z','Y','X');
   xn   : array[1..10] of integer = (-1, 1, 1, 1, 0, 0,-1, 0, 0, 1);
   yn   : array[1..10] of integer = ( 1,-1, 1, 1, 0,-1, 0, 0, 1, 0);
   zn   : array[1..10] of integer = ( 0, 0, 0, 0,-1, 0, 0, 1, 0, 0);
begin
  npos_sel:=0;
  with fmainmenu.stringgrid1 do begin
    //ligne i
    for i:=1 to npos do begin
      s:=cells[1,i];s:=trim(s);
      if (s = '')then break;
      if (cells[4,i] <> '*')then begin
        selected[i]:=0;
        continue;
      end;
      npos_sel:=npos_sel+1;
      selected[i]:=1;
      //colonne j
      for j:=1 to 3 do begin
        s:=cells[j,i];
        s:=trim(s);
        s:=UpperCase(s);
        for k:=1 to 10 do begin
          if (pos(cod[k],s) > 0)then begin
            tp_sel[npos_sel,j,1]:=xn[k];
            tp_sel[npos_sel,j,2]:=yn[k];
            tp_sel[npos_sel,j,3]:=zn[k];
            delete(s,pos(cod[k],s),length(cod[k]));
            s:=trim(s);
            ier:=0;
            break;
          end;
        end;

        while (pos('+',s) > 0)do s[pos('+',s)]:=' ';s:=trim(s);
        if (s = '')then begin
          tp_sel[npos_sel,j,4]:=0;
          continue;
        end;
        if (pos('/',s) = 0)then begin
          val(s,tp_sel[npos_sel,j,4],ier);
        end else begin
          s1:=copy(s,1,pos('/',s)-1);
          val(s1,x1,ier);
          delete(s,1,pos('/',s));
          val(s,x2,ier);
          tp_sel[npos_sel,j,4]:=x1/x2;
        end;
        if (ier > 0)then begin
            s:=cells[1,i]+' '+cells[2,i]+' '+cells[3,i];
            erreur('Decoding Error: '+s+'. Position Nb '+inttostr(i));
            exit;
        end;
      end;
    end;
  end;
end;
*)
procedure relit_positions_selectionnees;
//--------------------------------------
var
   s,s1                : string;
   i,j,k,ier           : integer;
   x1,x2               : double;
const
//Modifi le 4/05/03 (ajout de -X+Y et -Y+X)
   cod  : array[1..12] of string[20] =('-X+Y','-Y+X','Y-X','X-Y','X+Y','Y+X',
   '-Z','-Y','-X','Z','Y','X');
   xn   : array[1..12] of integer = (-1, 1,-1, 1, 1, 1, 0, 0,-1, 0, 0, 1);
   yn   : array[1..12] of integer = ( 1,-1, 1,-1, 1, 1, 0,-1, 0, 0, 1, 0);
   zn   : array[1..12] of integer = ( 0, 0, 0, 0, 0, 0,-1, 0, 0, 1, 0, 0);
begin
  npos_sel:=0;
  with fmainmenu.stringgrid1 do begin

//ligne i
    for i:=1 to npos do begin
      s:=cells[1,i];s:=trim(s);
      if (s = '')then break;
      if (cells[4,i] <> '*')then begin
        selected[i]:=0;
        continue;
      end;
      npos_sel:=npos_sel+1;
      selected[i]:=1;
      
//colonne j
      for j:=1 to 3 do begin
        s:=cells[j,i];
        s:=trim(s);
        s:=UpperCase(s);
        for k:=1 to 12 do begin
          //if (s = cod[k])then begin
          if (pos(cod[k],s) > 0)then begin
            tp_sel[npos_sel,j,1]:=xn[k];
            tp_sel[npos_sel,j,2]:=yn[k];
            tp_sel[npos_sel,j,3]:=zn[k];
            delete(s,pos(cod[k],s),length(cod[k]));
            s:=trim(s);
            ier:=0;
            break;
          end;
        end;
        if (ier > 0)then begin
            s:=cells[1,i]+', '+cells[2,i]+', '+cells[3,i];
            erreur('Decoding Error: '+s+'. Position Nb '+inttostr(i));
            npos:=0;
            exit;
        end;

        while (pos('+',s) > 0)do s[pos('+',s)]:=' ';s:=trim(s);
        if (s = '')then begin
          tp_sel[npos_sel,j,4]:=0;
          continue;
        end;
        if (pos('/',s) = 0)then begin
          val(s,tp_sel[npos_sel,j,4],ier);
        end else begin
          s1:=copy(s,1,pos('/',s)-1);
          val(s1,x1,ier);
          delete(s,1,pos('/',s));
          val(s,x2,ier);
          tp_sel[npos_sel,j,4]:=x1/x2;
        end;
        if (ier > 0)then begin
            s:=cells[1,i]+', '+cells[2,i]+', '+cells[3,i];
            erreur('Decoding Error: '+s+'. Position Nb '+inttostr(i));
            npos:=0;
            exit;
        end;
      end;
    end;
  end;
end;

procedure ecrit_maille;
//---------------------
var
  s   : string;
begin
  with fmainmenu do begin
    str(cel[1]:8:4,s);
    edit1.text:=s;
    str(cel[2]:8:4,s);
    edit2.text:=s;
    str(cel[3]:8:4,s);
    edit3.text:=s;
    str(cel[4]:8:3,s);
    edit4.text:=s;
    str(cel[5]:8:3,s);
    edit5.text:=s;
    str(cel[6]:8:3,s);
    edit6.text:=s;
  end;
end;

procedure raze_data;
//------------------
var
  i         : integer;
begin
  nom_fichier_shelx:='';
  nom_fichier_grt:='';
  npos:=0;
  npos_sel:=0;
  nb_motif:=0;
  nb_child:=0;
  for i:=1 to 6 do cel[i]:=0;
end;

procedure ecrit_stringgrid1;
//--------------------------
var
  i,j,k         : integer;
  s             : string;
  v4            : vecteur4;
  //nomf          : textfile;
begin
  (*assignfile(nomf,'espion');
  rewrite(nomf); *)
  fmainmenu.label21.visible:=true;
  fmainmenu.label21.caption:='Nb of positions: '+inttostr(npos);
  with fmainmenu.StringGrid1 do begin
    Rowcount:=npos+1;
    if (rowcount < 18)then rowcount:=18;
    cells[0,0]:='Nb';
    cells[1,0]:='a';
    cells[2,0]:='b';
    cells[3,0]:='c';
    cells[4,0]:='Sel.';

//Affichage des positions dns stringgrid1
    if (npos = 0)then exit;
    for i:=1 to rowcount-1 do
      for j:=0 to 4 do cells[j,i]:='';

    if (pos('.cif',nom_fichier_shelx) = 0)then begin
      for i:=1 to npos do begin
        str(i:3,s);
        cells[0,i]:=inttostr(i);
        s_pos[i]:='';
        //write(nomf,i:5,' ');
        for j:=1 to 3 do begin
          for k:=1 to 4 do v4[k]:=tp[i,j,k];
          code(v4,s);
          s:=lowercase(s);
          //cells[j,i]:=uppercase(s);
          cells[j,i]:=s;
          s_pos[i]:=s_pos[i]+s+',';
          //write(nomf,s,' ');
        end;
        //writeln(nomf);
        if (selected[i] = 1)then cells[4,i]:= '*';
        delete(s_pos[i],length(s_pos[i]),1);
      end;
    end else begin
      for i:=1 to npos do begin
        cells[0,i]:=inttostr(i);
        s:=trim(s_pos[i]);
        j:=pos(',',s);
        cells[1,i]:=copy(s,1,j-1);
        delete(s,1,j);
        j:=pos(',',s);
        cells[2,i]:=copy(s,1,j-1);
        delete(s,1,j);
        cells[3,i]:=s;
        if (selected[i] = 1)then cells[4,i]:= '*';
      end;
    end;
    //closefile(nomf);
  end;
end;

procedure clear_stringgrid2;
//--------------------------
var
    i,j          : integer;
begin
   with fmainmenu.stringGrid2 do begin
     cells[0,0]:='No';
     cells[1,0]:='Elem.';
     cells[2,0]:='Label';
     cells[3,0]:='X';
     cells[4,0]:='Y';
     cells[5,0]:='Z';
     case fmainmenu.radiogroup2.itemIndex of
     0: begin
          cells[6,0]:='u11';
          cells[7,0]:='u22';
          cells[8,0]:='u33';
          cells[9,0]:='u12';
          cells[10,0]:='u13';
          cells[11,0]:='u23';
          cells[12,0]:='Uiso';
        end;
     1: begin
          cells[6,0]:='B11';
          cells[7,0]:='B22';
          cells[8,0]:='B33';
          cells[9,0]:='B12';
          cells[10,0]:='B13';
          cells[11,0]:='B23';
          cells[12,0]:='Biso';
        end;
     2: begin
          cells[6,0]:='Beta11';
          cells[7,0]:='Beta22';
          cells[8,0]:='Beta33';
          cells[9,0]:='Beta12';
          cells[10,0]:='Beta13';
          cells[11,0]:='Beta23';
          cells[12,0]:='BETAiso';
        end;
     end;
     for i:=0 to colcount-1 do
     for j:=1 to rowcount-1 do cells[i,j]:='';
   end;
end;

procedure clear_stringgrid1;
//--------------------------
var
    i,j          : integer;
begin
   fmainmenu.label21.visible:=false;
   with fmainmenu.stringGrid1 do begin
     colwidths[0]:=15;
     colwidths[4]:=25;
     cells[0,0]:='Nb';
     cells[1,0]:='a';
     cells[2,0]:='b';
     cells[3,0]:='c';
     cells[4,0]:='Sel.';
     for i:=0 to colcount-1 do
     for j:=1 to rowcount-1 do cells[i,j]:='';
   end;
end;

procedure ecrit_stringgrid2;
//--------------------------
var
    i,j,k        : integer;
    s,s1            : string;
    u,b          : array[1..6] of real;
    depi2        : real;
begin
 depi2:=2.*3.14159*3.14159;
 u[1]:=depi2*celr[1]*celr[1];
 u[2]:=depi2*celr[2]*celr[2];
 u[3]:=depi2*celr[3]*celr[3];
 u[4]:=depi2*celr[1]*celr[2];
 u[5]:=depi2*celr[1]*celr[3];
 u[6]:=depi2*celr[2]*celr[3];
 clear_stringgrid2;
 if (nb_motif > 0)then begin
   if (nb_motif > 99)then fmainmenu.stringGrid2.rowcount:=nb_motif+5;
   clear_stringgrid2;
   with fmainmenu.stringGrid2 do begin
     if (nb_motif > 0)then begin
       for i:=1 to nb_motif do begin
         with motif[i] do begin
           cells[0,i]:=inttostr(i);
           s:=element;s:=trim(s);
           s1:=lowercase(s);
           if (length(s) = 2)then s[2]:=s1[2];
           cells[1,i]:=s;
           cells[2,i]:=labell;
           str(x:9:5,s);
           cells[3,i]:=s;
           str(y:9:5,s);
           cells[4,i]:=s;
           str(z:9:5,s);
           cells[5,i]:=s;
//Les paramtres sont tirs des uij
           case fmainmenu.radiogroup2.itemIndex of
               0: for k:=1 to 6 do b[k]:=beta[k];             //uij
               1: for k:=1 to 6 do b[k]:=2*depi2*beta[k];     //Bij
               2: for k:=1 to 6 do b[k]:=beta[k]*u[k];        //Betaij
           end;
           if (b[2] = 0) and (b[3] =0)then iso:=1;

           if (iso = 0)then begin
             for j:=1 to 6 do begin
               if (abs(beta[j]) <  0.00001)then begin
                 s:='0';
               end else begin
                 str(b[j]:9:6,s);
               end;
               cells[5+j,i]:=s;
             end;
             cells[12,i]:=' ';
           end else begin
             for j:=1 to 6 do cells[5+j,i]:='';
             str(b[1]:8:5,s);
             cells[12,i]:=s;
           end;
         end;
       end;
     end;
   end;
 end;
end;

procedure affiche_groupes_getspec;
//--------------------------------
//Groupes Getspec
var
  i,j,i1,i2            : integer;
  s                    : string;
  s12                  : string;
  s21                  : string;
  s4                   : string;
  nomf                 : textfile;
begin
  if (systeme = 'TRIC')then begin
    i1:=1;
    i2:=18;
  end else if (systeme = 'MONO')then begin
    i1:=19;
    i2:=178;
  end else if (systeme = 'ORTH')then begin
    i1:=179;
    i2:=370;
  end else if (systeme = 'TETR')then begin
    i1:=371;
    i2:=480;
  end else if (systeme = 'HEXA')then begin
    i1:=481;
    i2:=547;
  end else if (systeme = 'RHOM')then begin
    i1:=548;
    i2:=556;
  end else if (systeme = 'CUBI')then begin
    i1:=558;
    i2:=637;
  end;
  nb_groupes_getspec:=i2-i1+1;

  fmainmenu.listbox3.clear;
  chdir(repertoire_origine);
  assignfile(nomf,'spgr2.dat');
  reset(nomf);
  if (i1 > 1)then begin
    for i:=1 to i1-1 do readln(nomf);
  end;
  for i:=1 to i2-i1+1 do begin
      readln(nomf,s);
      s12:=copy(s,6,12);s12:=trim(s12);
      if (length(s12) < 12)then for j:=length(s12)+1 to 12 do s12:=s12+' ';
      s21:=copy(s,27,20);s21:=trim(s21);
      if (length(s21) < 17)then for j:=length(s21)+1 to 17 do s21:=s21+' ';
      s4:=copy(s,47,3);s4:=trim(s4);
      if (length(s4) < 3)then for j:=length(s4)+1 to 3 do s4:=s4+' ';
      fmainmenu.listbox3.items.add(s12+s21+s4);
  end;
  closefile(nomf);
end;

procedure ecrit_panel1;
//--------------------
var
    i,i1,i2      : integer;
    s            : string;
    nomf         : textfile;
    a5           : string[5];
    a14          : string[14];
begin
   fmainmenu.stringgrid2.color:=clwhite;
   if (nb_motif > 0)then begin
     quel_systeme;
     couleur_edit_param;
     for i:=0 to 6 do begin
       s:=copy(fmainmenu.listbox1.Items[i],1,4);
       s:=uppercase(s);
       if (s = systeme) then begin
         fmainmenu.listbox1.ItemIndex:=i;
         break;
       end;
     end;
     lit_affiche_groupes;
     affiche_groupes_getspec;
     if (groupe_espace <> '')then allume_groupes;
     ecrit_maille;
   end;

// fmainmenu.left:=6;
   if (nom_fichier_shelx > '')then
   fmainmenu.caption:=
  'GRETEP V2. Data for '+extractfileName(nom_fichier_shelx);
//   fmainmenu.caption:=
//  'GRETEP V2. Data for '+titre+' ('+extractfileName(nom_fichier_shelx)+')';
   if (nom_fichier_grt > '')then
   fmainmenu.caption:=
  'GRETEP V2. Data for '+titre+' ('+extractfileName(nom_fichier_grt)+')';
   if (nom_fichier_ascii > '')then
   fmainmenu.caption:=
  'GRETEP V2. Data for '+titre+' ('+extractfileName(nom_fichier_ascii)+')';

   ecrit_stringgrid1;
   ecrit_stringgrid2;

end;

end.
